/*
 * Copyright (c) 2012, Freescale Semiconductor, Inc.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without modification,
 * are permitted provided that the following conditions are met:
 *
 * Redistributions of source code must retain the above copyright notice, this list
 * of conditions and the following disclaimer.
 * Redistributions in binary form must reproduce the above copyright notice, this
 * list of conditions and the following disclaimer in the documentation and/or
 * other materials provided with the distribution.
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR
 * ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON
 * ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */
#include "CoverAlbumBitmap.hpp"
namespace Fsl
{
  // NOLINTNEXTLINE(modernize-avoid-c-arrays)
  const uint8_t CoverAlbumBitmaps::MozartBitmap[] = {
    0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,
    0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,
    0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,
    255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255,
    0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,
    0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,
    0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,
    255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255,
    0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,
    0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,
    0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,
    255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255,
    0,   0,   0,   255, 0,   0,   0,   255, 2,   2,   2,   255, 3,   3,   3,   255, 0,   0,   0,   255, 0,   0,   0,   255, 1,   1,   1,   255, 12,
    12,  12,  255, 19,  19,  19,  255, 99,  99,  99,  255, 128, 128, 128, 255, 118, 118, 118, 255, 72,  72,  72,  255, 76,  76,  76,  255, 23,  23,
    23,  255, 27,  27,  27,  255, 17,  17,  17,  255, 19,  19,  19,  255, 14,  14,  14,  255, 0,   0,   0,   255, 6,   6,   6,   255, 10,  10,  10,
    255, 0,   0,   0,   255, 8,   8,   8,   255, 0,   0,   0,   255, 1,   1,   1,   255, 1,   1,   1,   255, 1,   1,   1,   255, 1,   1,   1,   255,
    1,   1,   1,   255, 1,   1,   1,   255, 1,   1,   1,   255, 1,   1,   1,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,
    0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,
    0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,
    255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255,
    0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,
    0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,
    0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,
    255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255,
    0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,
    0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,
    0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,
    255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255,
    0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,
    0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 3,   3,   3,   255, 0,   0,
    0,   255, 0,   0,   0,   255, 1,   1,   1,   255, 1,   1,   1,   255, 0,   0,   0,   255, 1,   1,   1,   255, 5,   5,   5,   255, 46,  46,  46,
    255, 113, 113, 113, 255, 121, 121, 121, 255, 124, 124, 124, 255, 66,  66,  66,  255, 40,  40,  40,  255, 31,  31,  31,  255, 6,   6,   6,   255,
    8,   8,   8,   255, 22,  22,  22,  255, 12,  12,  12,  255, 7,   7,   7,   255, 0,   0,   0,   255, 0,   0,   0,   255, 9,   9,   9,   255, 2,
    2,   2,   255, 1,   1,   1,   255, 1,   1,   1,   255, 1,   1,   1,   255, 1,   1,   1,   255, 1,   1,   1,   255, 1,   1,   1,   255, 1,   1,
    1,   255, 1,   1,   1,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,
    255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255,
    0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,
    0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,
    0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,
    255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255,
    0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,
    0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,
    0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,
    255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255,
    0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,
    0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,
    0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,
    255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 1,   1,   1,   255, 0,   0,   0,   255,
    0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 2,   2,   2,   255, 6,   6,   6,   255, 118, 118, 118, 255, 107, 107, 107, 255, 111,
    111, 111, 255, 59,  59,  59,  255, 32,  32,  32,  255, 13,  13,  13,  255, 7,   7,   7,   255, 0,   0,   0,   255, 22,  22,  22,  255, 24,  24,
    24,  255, 15,  15,  15,  255, 4,   4,   4,   255, 1,   1,   1,   255, 5,   5,   5,   255, 0,   0,   0,   255, 1,   1,   1,   255, 1,   1,   1,
    255, 1,   1,   1,   255, 1,   1,   1,   255, 1,   1,   1,   255, 1,   1,   1,   255, 1,   1,   1,   255, 1,   1,   1,   255, 0,   0,   0,   255,
    0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,
    0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,
    0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,
    255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255,
    0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,
    0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,
    0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,
    255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255,
    0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,
    0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,
    0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,
    255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255,
    0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,
    0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 3,   3,   3,   255, 1,   1,   1,   255, 0,   0,   0,   255, 2,   2,   2,   255, 2,   2,
    2,   255, 0,   0,   0,   255, 59,  59,  59,  255, 124, 124, 124, 255, 98,  98,  98,  255, 72,  72,  72,  255, 58,  58,  58,  255, 24,  24,  24,
    255, 45,  45,  45,  255, 35,  35,  35,  255, 21,  21,  21,  255, 22,  22,  22,  255, 15,  15,  15,  255, 8,   8,   8,   255, 5,   5,   5,   255,
    5,   5,   5,   255, 8,   8,   8,   255, 6,   6,   6,   255, 1,   1,   1,   255, 1,   1,   1,   255, 1,   1,   1,   255, 1,   1,   1,   255, 1,
    1,   1,   255, 1,   1,   1,   255, 1,   1,   1,   255, 1,   1,   1,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,
    0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,
    255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255,
    0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,
    0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,
    0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,
    255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255,
    0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,
    0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,
    0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,
    255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255,
    0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,
    0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,
    0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 3,   3,   3,   255, 0,   0,   0,
    255, 0,   0,   0,   255, 5,   5,   5,   255, 1,   1,   1,   255, 0,   0,   0,   255, 5,   5,   5,   255, 26,  26,  26,  255, 126, 126, 126, 255,
    87,  87,  87,  255, 70,  70,  70,  255, 57,  57,  57,  255, 33,  33,  33,  255, 21,  21,  21,  255, 86,  86,  86,  255, 34,  34,  34,  255, 20,
    20,  20,  255, 11,  11,  11,  255, 16,  16,  16,  255, 24,  24,  24,  255, 22,  22,  22,  255, 9,   9,   9,   255, 0,   0,   0,   255, 3,   3,
    3,   255, 1,   1,   1,   255, 1,   1,   1,   255, 1,   1,   1,   255, 1,   1,   1,   255, 1,   1,   1,   255, 1,   1,   1,   255, 1,   1,   1,
    255, 1,   1,   1,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255,
    0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,
    0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,
    0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,
    255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255,
    0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,
    0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,
    0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,
    255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255,
    0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,
    0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,
    0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,
    255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255,
    0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 6,   6,   6,   255, 0,   0,   0,   255, 0,   0,   0,   255, 3,   3,   3,   255, 0,
    0,   0,   255, 0,   0,   0,   255, 36,  36,  36,  255, 107, 107, 107, 255, 118, 118, 118, 255, 59,  59,  59,  255, 28,  28,  28,  255, 36,  36,
    36,  255, 17,  17,  17,  255, 19,  19,  19,  255, 47,  47,  47,  255, 13,  13,  13,  255, 12,  12,  12,  255, 11,  11,  11,  255, 28,  28,  28,
    255, 32,  32,  32,  255, 25,  25,  25,  255, 13,  13,  13,  255, 0,   0,   0,   255, 0,   0,   0,   255, 1,   1,   1,   255, 1,   1,   1,   255,
    1,   1,   1,   255, 1,   1,   1,   255, 1,   1,   1,   255, 1,   1,   1,   255, 1,   1,   1,   255, 1,   1,   1,   255, 0,   0,   0,   255, 0,
    0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,
    0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,
    255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255,
    0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,
    0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,
    0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,
    255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255,
    0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,
    0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,
    0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,
    255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255,
    0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,
    0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,
    0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 2,   2,   2,   255, 2,   2,   2,   255, 9,   9,   9,   255, 37,  37,  37,  255, 85,  85,  85,
    255, 123, 123, 123, 255, 70,  70,  70,  255, 50,  50,  50,  255, 13,  13,  13,  255, 15,  15,  15,  255, 20,  20,  20,  255, 22,  22,  22,  255,
    10,  10,  10,  255, 31,  31,  31,  255, 45,  45,  45,  255, 48,  48,  48,  255, 47,  47,  47,  255, 15,  15,  15,  255, 13,  13,  13,  255, 38,
    38,  38,  255, 28,  28,  28,  255, 16,  16,  16,  255, 1,   1,   1,   255, 1,   1,   1,   255, 1,   1,   1,   255, 1,   1,   1,   255, 1,   1,
    1,   255, 1,   1,   1,   255, 1,   1,   1,   255, 1,   1,   1,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,
    255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255,
    0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,
    0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,
    0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,
    255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255,
    0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,
    0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,
    0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,
    255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255,
    0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,
    0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,
    0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,
    255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 6,   6,   6,   255,
    0,   0,   0,   255, 7,   7,   7,   255, 68,  68,  68,  255, 132, 132, 132, 255, 114, 114, 114, 255, 50,  50,  50,  255, 31,  31,  31,  255, 11,
    11,  11,  255, 10,  10,  10,  255, 0,   0,   0,   255, 2,   2,   2,   255, 12,  12,  12,  255, 22,  22,  22,  255, 56,  56,  56,  255, 55,  55,
    55,  255, 77,  77,  77,  255, 83,  83,  83,  255, 41,  41,  41,  255, 50,  50,  50,  255, 92,  92,  92,  255, 57,  57,  57,  255, 2,   2,   2,
    255, 1,   1,   1,   255, 1,   1,   1,   255, 1,   1,   1,   255, 1,   1,   1,   255, 1,   1,   1,   255, 1,   1,   1,   255, 1,   1,   1,   255,
    1,   1,   1,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,
    0,   0,   255, 0,   0,   0,   255, 3,   3,   3,   255, 11,  11,  11,  255, 0,   0,   0,   255, 6,   6,   6,   255, 0,   0,   0,   255, 0,   0,
    0,   255, 5,   5,   5,   255, 0,   0,   0,   255, 1,   1,   1,   255, 2,   2,   2,   255, 7,   7,   7,   255, 0,   0,   0,   255, 0,   0,   0,
    255, 5,   5,   5,   255, 0,   0,   0,   255, 2,   2,   2,   255, 0,   0,   0,   255, 2,   2,   2,   255, 7,   7,   7,   255, 0,   0,   0,   255,
    0,   0,   0,   255, 4,   4,   4,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 10,  10,  10,  255, 0,
    0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 10,  10,  10,  255, 0,   0,   0,   255, 0,   0,   0,   255, 4,   4,   4,   255, 0,   0,
    0,   255, 0,   0,   0,   255, 11,  11,  11,  255, 0,   0,   0,   255, 1,   1,   1,   255, 8,   8,   8,   255, 0,   0,   0,   255, 0,   0,   0,
    255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255,
    0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,
    0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,
    0,   255, 3,   3,   3,   255, 0,   0,   0,   255, 2,   2,   2,   255, 0,   0,   0,   255, 6,   6,   6,   255, 0,   0,   0,   255, 0,   0,   0,
    255, 3,   3,   3,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255,
    0,   0,   0,   255, 0,   0,   0,   255, 1,   1,   1,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,
    0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 14,  14,  14,  255, 59,  59,  59,  255, 111, 111, 111, 255, 123, 123,
    123, 255, 89,  89,  89,  255, 48,  48,  48,  255, 29,  29,  29,  255, 7,   7,   7,   255, 0,   0,   0,   255, 0,   0,   0,   255, 9,   9,   9,
    255, 0,   0,   0,   255, 5,   5,   5,   255, 14,  14,  14,  255, 41,  41,  41,  255, 69,  69,  69,  255, 89,  89,  89,  255, 91,  91,  91,  255,
    100, 100, 100, 255, 103, 103, 103, 255, 80,  80,  80,  255, 14,  14,  14,  255, 18,  18,  18,  255, 9,   9,   9,   255, 10,  10,  10,  255, 0,
    0,   0,   255, 0,   0,   0,   255, 3,   3,   3,   255, 0,   0,   0,   255, 0,   0,   0,   255, 12,  12,  12,  255, 0,   0,   0,   255, 0,   0,
    0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,
    255, 2,   2,   2,   255, 3,   3,   3,   255, 0,   0,   0,   255, 1,   1,   1,   255, 0,   0,   0,   255, 5,   5,   5,   255, 1,   1,   1,   255,
    0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 4,   4,   4,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,
    0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 1,   1,   1,   255, 1,   1,   1,   255, 0,   0,   0,   255, 1,   1,
    1,   255, 3,   3,   3,   255, 2,   2,   2,   255, 4,   4,   4,   255, 0,   0,   0,   255, 13,  13,  13,  255, 1,   1,   1,   255, 5,   5,   5,
    255, 0,   0,   0,   255, 0,   0,   0,   255, 12,  12,  12,  255, 3,   3,   3,   255, 7,   7,   7,   255, 0,   0,   0,   255, 0,   0,   0,   255,
    1,   1,   1,   255, 9,   9,   9,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,
    0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,
    0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,
    255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 3,   3,   3,   255, 0,   0,   0,   255,
    5,   5,   5,   255, 0,   0,   0,   255, 7,   7,   7,   255, 2,   2,   2,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,
    0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,
    0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 2,   2,   2,   255, 0,   0,   0,   255, 0,   0,   0,   255, 7,   7,   7,   255, 16,  16,  16,
    255, 62,  62,  62,  255, 91,  91,  91,  255, 108, 108, 108, 255, 88,  88,  88,  255, 53,  53,  53,  255, 28,  28,  28,  255, 13,  13,  13,  255,
    4,   4,   4,   255, 1,   1,   1,   255, 1,   1,   1,   255, 0,   0,   0,   255, 5,   5,   5,   255, 0,   0,   0,   255, 7,   7,   7,   255, 5,
    5,   5,   255, 18,  18,  18,  255, 83,  83,  83,  255, 76,  76,  76,  255, 52,  52,  52,  255, 84,  84,  84,  255, 112, 112, 112, 255, 44,  44,
    44,  255, 55,  55,  55,  255, 17,  17,  17,  255, 10,  10,  10,  255, 9,   9,   9,   255, 5,   5,   5,   255, 4,   4,   4,   255, 5,   5,   5,
    255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255,
    0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 1,   1,   1,   255, 7,   7,   7,   255, 0,
    0,   0,   255, 0,   0,   0,   255, 2,   2,   2,   255, 0,   0,   0,   255, 0,   0,   0,   255, 8,   8,   8,   255, 0,   0,   0,   255, 0,   0,
    0,   255, 14,  14,  14,  255, 0,   0,   0,   255, 0,   0,   0,   255, 10,  10,  10,  255, 0,   0,   0,   255, 1,   1,   1,   255, 7,   7,   7,
    255, 0,   0,   0,   255, 4,   4,   4,   255, 4,   4,   4,   255, 0,   0,   0,   255, 7,   7,   7,   255, 1,   1,   1,   255, 1,   1,   1,   255,
    0,   0,   0,   255, 0,   0,   0,   255, 1,   1,   1,   255, 0,   0,   0,   255, 0,   0,   0,   255, 13,  13,  13,  255, 0,   0,   0,   255, 8,
    8,   8,   255, 0,   0,   0,   255, 10,  10,  10,  255, 0,   0,   0,   255, 0,   0,   0,   255, 3,   3,   3,   255, 0,   0,   0,   255, 9,   9,
    9,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,
    255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255,
    0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,
    0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 1,   1,   1,   255, 0,   0,   0,   255, 7,   7,   7,   255, 0,   0,   0,   255, 5,   5,
    5,   255, 1,   1,   1,   255, 1,   1,   1,   255, 1,   1,   1,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,
    255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 2,   2,   2,   255,
    2,   2,   2,   255, 0,   0,   0,   255, 2,   2,   2,   255, 13,  13,  13,  255, 25,  25,  25,  255, 45,  45,  45,  255, 60,  60,  60,  255, 54,
    54,  54,  255, 21,  21,  21,  255, 0,   0,   0,   255, 0,   0,   0,   255, 4,   4,   4,   255, 0,   0,   0,   255, 0,   0,   0,   255, 4,   4,
    4,   255, 0,   0,   0,   255, 1,   1,   1,   255, 0,   0,   0,   255, 5,   5,   5,   255, 0,   0,   0,   255, 1,   1,   1,   255, 26,  26,  26,
    255, 67,  67,  67,  255, 14,  14,  14,  255, 83,  83,  83,  255, 130, 130, 130, 255, 50,  50,  50,  255, 22,  22,  22,  255, 15,  15,  15,  255,
    9,   9,   9,   255, 2,   2,   2,   255, 2,   2,   2,   255, 3,   3,   3,   255, 0,   0,   0,   255, 0,   0,   0,   255, 4,   4,   4,   255, 4,
    4,   4,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,
    0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 6,   6,   6,   255, 0,   0,   0,   255, 6,   6,   6,   255, 0,   0,   0,   255, 10,  10,  10,
    255, 0,   0,   0,   255, 0,   0,   0,   255, 3,   3,   3,   255, 0,   0,   0,   255, 0,   0,   0,   255, 5,   5,   5,   255, 0,   0,   0,   255,
    0,   0,   0,   255, 6,   6,   6,   255, 0,   0,   0,   255, 0,   0,   0,   255, 4,   4,   4,   255, 3,   3,   3,   255, 0,   0,   0,   255, 0,
    0,   0,   255, 2,   2,   2,   255, 2,   2,   2,   255, 0,   0,   0,   255, 0,   0,   0,   255, 21,  21,  21,  255, 3,   3,   3,   255, 0,   0,
    0,   255, 4,   4,   4,   255, 13,  13,  13,  255, 0,   0,   0,   255, 12,  12,  12,  255, 0,   0,   0,   255, 14,  14,  14,  255, 5,   5,   5,
    255, 2,   2,   2,   255, 2,   2,   2,   255, 0,   0,   0,   255, 16,  16,  16,  255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255,
    0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,
    0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,
    0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,
    255, 0,   0,   0,   255, 1,   1,   1,   255, 0,   0,   0,   255, 5,   5,   5,   255, 0,   0,   0,   255, 0,   0,   0,   255, 4,   4,   4,   255,
    2,   2,   2,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,
    0,   0,   255, 0,   0,   0,   255, 2,   2,   2,   255, 1,   1,   1,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,
    0,   255, 6,   6,   6,   255, 15,  15,  15,  255, 19,  19,  19,  255, 7,   7,   7,   255, 0,   0,   0,   255, 0,   0,   0,   255, 1,   1,   1,
    255, 2,   2,   2,   255, 2,   2,   2,   255, 2,   2,   2,   255, 0,   0,   0,   255, 7,   7,   7,   255, 0,   0,   0,   255, 1,   1,   1,   255,
    2,   2,   2,   255, 0,   0,   0,   255, 1,   1,   1,   255, 13,  13,  13,  255, 62,  62,  62,  255, 21,  21,  21,  255, 40,  40,  40,  255, 93,
    93,  93,  255, 40,  40,  40,  255, 38,  38,  38,  255, 38,  38,  38,  255, 7,   7,   7,   255, 16,  16,  16,  255, 7,   7,   7,   255, 11,  11,
    11,  255, 9,   9,   9,   255, 0,   0,   0,   255, 0,   0,   0,   255, 3,   3,   3,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,
    255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255,
    4,   4,   4,   255, 0,   0,   0,   255, 6,   6,   6,   255, 2,   2,   2,   255, 0,   0,   0,   255, 6,   6,   6,   255, 5,   5,   5,   255, 0,
    0,   0,   255, 7,   7,   7,   255, 1,   1,   1,   255, 0,   0,   0,   255, 3,   3,   3,   255, 0,   0,   0,   255, 1,   1,   1,   255, 3,   3,
    3,   255, 0,   0,   0,   255, 0,   0,   0,   255, 6,   6,   6,   255, 0,   0,   0,   255, 0,   0,   0,   255, 11,  11,  11,  255, 0,   0,   0,
    255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 4,   4,   4,   255, 0,   0,   0,   255, 11,  11,  11,  255, 0,   0,   0,   255,
    8,   8,   8,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 11,  11,  11,  255, 8,
    8,   8,   255, 0,   0,   0,   255, 1,   1,   1,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,
    0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,
    255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255,
    0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 1,   1,   1,   255, 0,
    0,   0,   255, 8,   8,   8,   255, 0,   0,   0,   255, 0,   0,   0,   255, 7,   7,   7,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,
    0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 5,   5,   5,
    255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 2,   2,   2,   255,
    6,   6,   6,   255, 0,   0,   0,   255, 0,   0,   0,   255, 11,  11,  11,  255, 8,   8,   8,   255, 0,   0,   0,   255, 0,   0,   0,   255, 2,
    2,   2,   255, 0,   0,   0,   255, 5,   5,   5,   255, 0,   0,   0,   255, 1,   1,   1,   255, 0,   0,   0,   255, 0,   0,   0,   255, 26,  26,
    26,  255, 53,  53,  53,  255, 37,  37,  37,  255, 73,  73,  73,  255, 90,  90,  90,  255, 29,  29,  29,  255, 61,  61,  61,  255, 64,  64,  64,
    255, 29,  29,  29,  255, 25,  25,  25,  255, 4,   4,   4,   255, 6,   6,   6,   255, 20,  20,  20,  255, 22,  22,  22,  255, 4,   4,   4,   255,
    0,   0,   0,   255, 2,   2,   2,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,
    0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 9,   9,   9,   255, 0,   0,
    0,   255, 3,   3,   3,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 1,   1,   1,
    255, 0,   0,   0,   255, 2,   2,   2,   255, 7,   7,   7,   255, 0,   0,   0,   255, 0,   0,   0,   255, 7,   7,   7,   255, 0,   0,   0,   255,
    0,   0,   0,   255, 0,   0,   0,   255, 2,   2,   2,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 9,   9,   9,   255, 3,
    3,   3,   255, 15,  15,  15,  255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 6,   6,   6,   255, 0,   0,   0,   255, 0,   0,
    0,   255, 6,   6,   6,   255, 3,   3,   3,   255, 17,  17,  17,  255, 0,   0,   0,   255, 0,   0,   0,   255, 7,   7,   7,   255, 1,   1,   1,
    255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255,
    0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,
    0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,
    0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 2,   2,   2,   255, 0,   0,   0,   255, 12,  12,  12,  255, 2,   2,   2,   255, 0,   0,   0,
    255, 0,   0,   0,   255, 9,   9,   9,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255,
    0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 4,   4,   4,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,
    0,   0,   255, 3,   3,   3,   255, 1,   1,   1,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,
    0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 1,   1,   1,
    255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 2,   2,   2,   255, 72,  72,  72,  255, 101, 101, 101, 255, 123, 123, 123, 255,
    85,  85,  85,  255, 51,  51,  51,  255, 51,  51,  51,  255, 60,  60,  60,  255, 25,  25,  25,  255, 24,  24,  24,  255, 70,  70,  70,  255, 26,
    26,  26,  255, 27,  27,  27,  255, 31,  31,  31,  255, 24,  24,  24,  255, 11,  11,  11,  255, 7,   7,   7,   255, 7,   7,   7,   255, 2,   2,
    2,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,
    255, 0,   0,   0,   255, 4,   4,   4,   255, 0,   0,   0,   255, 12,  12,  12,  255, 0,   0,   0,   255, 0,   0,   0,   255, 41,  41,  41,  255,
    0,   0,   0,   255, 0,   0,   0,   255, 42,  42,  42,  255, 0,   0,   0,   255, 2,   2,   2,   255, 3,   3,   3,   255, 0,   0,   0,   255, 9,
    9,   9,   255, 0,   0,   0,   255, 1,   1,   1,   255, 0,   0,   0,   255, 13,  13,  13,  255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,
    0,   255, 0,   0,   0,   255, 15,  15,  15,  255, 0,   0,   0,   255, 0,   0,   0,   255, 228, 228, 228, 255, 24,  24,  24,  255, 16,  16,  16,
    255, 13,  13,  13,  255, 0,   0,   0,   255, 0,   0,   0,   255, 5,   5,   5,   255, 29,  29,  29,  255, 226, 226, 226, 255, 10,  10,  10,  255,
    0,   0,   0,   255, 17,  17,  17,  255, 0,   0,   0,   255, 11,  11,  11,  255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,
    0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,
    0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,
    255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255,
    1,   1,   1,   255, 0,   0,   0,   255, 93,  93,  93,  255, 0,   0,   0,   255, 0,   0,   0,   255, 1,   1,   1,   255, 5,   5,   5,   255, 0,
    0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,
    0,   255, 0,   0,   0,   255, 2,   2,   2,   255, 0,   0,   0,   255, 0,   0,   0,   255, 1,   1,   1,   255, 3,   3,   3,   255, 1,   1,   1,
    255, 0,   0,   0,   255, 1,   1,   1,   255, 7,   7,   7,   255, 6,   6,   6,   255, 1,   1,   1,   255, 0,   0,   0,   255, 0,   0,   0,   255,
    7,   7,   7,   255, 4,   4,   4,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,
    0,   0,   255, 33,  33,  33,  255, 128, 128, 128, 255, 139, 139, 139, 255, 131, 131, 131, 255, 123, 123, 123, 255, 77,  77,  77,  255, 60,  60,
    60,  255, 12,  12,  12,  255, 38,  38,  38,  255, 43,  43,  43,  255, 17,  17,  17,  255, 73,  73,  73,  255, 65,  65,  65,  255, 42,  42,  42,
    255, 20,  20,  20,  255, 12,  12,  12,  255, 7,   7,   7,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255,
    0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 7,   7,   7,   255, 0,
    0,   0,   255, 0,   0,   0,   255, 11,  11,  11,  255, 2,   2,   2,   255, 125, 125, 125, 255, 17,  17,  17,  255, 21,  21,  21,  255, 118, 118,
    118, 255, 6,   6,   6,   255, 29,  29,  29,  255, 35,  35,  35,  255, 6,   6,   6,   255, 33,  33,  33,  255, 31,  31,  31,  255, 32,  32,  32,
    255, 1,   1,   1,   255, 55,  55,  55,  255, 8,   8,   8,   255, 10,  10,  10,  255, 20,  20,  20,  255, 32,  32,  32,  255, 82,  82,  82,  255,
    27,  27,  27,  255, 0,   0,   0,   255, 201, 201, 201, 255, 184, 184, 184, 255, 0,   0,   0,   255, 4,   4,   4,   255, 0,   0,   0,   255, 5,
    5,   5,   255, 0,   0,   0,   255, 172, 172, 172, 255, 203, 203, 203, 255, 6,   6,   6,   255, 7,   7,   7,   255, 0,   0,   0,   255, 0,   0,
    0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,
    255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255,
    0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,
    0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 4,   4,   4,   255, 175, 175,
    175, 255, 5,   5,   5,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 5,   5,   5,   255, 0,   0,   0,   255, 0,   0,   0,
    255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 1,   1,   1,   255,
    0,   0,   0,   255, 0,   0,   0,   255, 1,   1,   1,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 4,   4,   4,   255, 0,
    0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 2,   2,   2,   255, 2,   2,   2,   255, 1,   1,   1,   255, 0,   0,   0,   255, 1,   1,
    1,   255, 0,   0,   0,   255, 2,   2,   2,   255, 3,   3,   3,   255, 0,   0,   0,   255, 7,   7,   7,   255, 62,  62,  62,  255, 168, 168, 168,
    255, 159, 159, 159, 255, 126, 126, 126, 255, 111, 111, 111, 255, 57,  57,  57,  255, 4,   4,   4,   255, 34,  34,  34,  255, 26,  26,  26,  255,
    37,  37,  37,  255, 101, 101, 101, 255, 58,  58,  58,  255, 53,  53,  53,  255, 29,  29,  29,  255, 14,  14,  14,  255, 24,  24,  24,  255, 24,
    24,  24,  255, 10,  10,  10,  255, 5,   5,   5,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,
    0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 1,   1,   1,   255, 7,   7,   7,   255, 0,   0,   0,   255, 0,   0,   0,
    255, 16,  16,  16,  255, 71,  71,  71,  255, 90,  90,  90,  255, 72,  72,  72,  255, 73,  73,  73,  255, 29,  29,  29,  255, 68,  68,  68,  255,
    40,  40,  40,  255, 61,  61,  61,  255, 14,  14,  14,  255, 52,  52,  52,  255, 67,  67,  67,  255, 23,  23,  23,  255, 33,  33,  33,  255, 92,
    92,  92,  255, 56,  56,  56,  255, 83,  83,  83,  255, 17,  17,  17,  255, 82,  82,  82,  255, 18,  18,  18,  255, 1,   1,   1,   255, 180, 180,
    180, 255, 98,  98,  98,  255, 119, 119, 119, 255, 0,   0,   0,   255, 0,   0,   0,   255, 4,   4,   4,   255, 98,  98,  98,  255, 119, 119, 119,
    255, 167, 167, 167, 255, 13,  13,  13,  255, 0,   0,   0,   255, 0,   0,   0,   255, 12,  12,  12,  255, 99,  99,  99,  255, 145, 145, 145, 255,
    126, 126, 126, 255, 30,  30,  30,  255, 2,   2,   2,   255, 5,   5,   5,   255, 6,   6,   6,   255, 117, 117, 117, 255, 105, 105, 105, 255, 114,
    114, 114, 255, 109, 109, 109, 255, 110, 110, 110, 255, 92,  92,  92,  255, 0,   0,   0,   255, 1,   1,   1,   255, 74,  74,  74,  255, 119, 119,
    119, 255, 127, 127, 127, 255, 75,  75,  75,  255, 17,  17,  17,  255, 0,   0,   0,   255, 0,   0,   0,   255, 73,  73,  73,  255, 21,  21,  21,
    255, 38,  38,  38,  255, 119, 119, 119, 255, 7,   7,   7,   255, 109, 109, 109, 255, 210, 210, 210, 255, 109, 109, 109, 255, 119, 119, 119, 255,
    25,  25,  25,  255, 0,   0,   0,   255, 5,   5,   5,   255, 0,   0,   0,   255, 0,   0,   0,   255, 7,   7,   7,   255, 0,   0,   0,   255, 3,
    3,   3,   255, 0,   0,   0,   255, 2,   2,   2,   255, 0,   0,   0,   255, 5,   5,   5,   255, 0,   0,   0,   255, 8,   8,   8,   255, 0,   0,
    0,   255, 0,   0,   0,   255, 8,   8,   8,   255, 0,   0,   0,   255, 2,   2,   2,   255, 0,   0,   0,   255, 5,   5,   5,   255, 0,   0,   0,
    255, 1,   1,   1,   255, 8,   8,   8,   255, 0,   0,   0,   255, 0,   0,   0,   255, 7,   7,   7,   255, 6,   6,   6,   255, 0,   0,   0,   255,
    11,  11,  11,  255, 0,   0,   0,   255, 0,   0,   0,   255, 139, 139, 139, 255, 158, 158, 158, 255, 129, 129, 129, 255, 98,  98,  98,  255, 66,
    66,  66,  255, 33,  33,  33,  255, 20,  20,  20,  255, 20,  20,  20,  255, 24,  24,  24,  255, 33,  33,  33,  255, 42,  42,  42,  255, 22,  22,
    22,  255, 57,  57,  57,  255, 57,  57,  57,  255, 51,  51,  51,  255, 43,  43,  43,  255, 17,  17,  17,  255, 8,   8,   8,   255, 14,  14,  14,
    255, 6,   6,   6,   255, 2,   2,   2,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255,
    3,   3,   3,   255, 3,   3,   3,   255, 0,   0,   0,   255, 9,   9,   9,   255, 9,   9,   9,   255, 0,   0,   0,   255, 80,  80,  80,  255, 21,
    21,  21,  255, 21,  21,  21,  255, 72,  72,  72,  255, 77,  77,  77,  255, 0,   0,   0,   255, 5,   5,   5,   255, 85,  85,  85,  255, 33,  33,
    33,  255, 61,  61,  61,  255, 0,   0,   0,   255, 79,  79,  79,  255, 50,  50,  50,  255, 93,  93,  93,  255, 49,  49,  49,  255, 30,  30,  30,
    255, 0,   0,   0,   255, 91,  91,  91,  255, 0,   0,   0,   255, 0,   0,   0,   255, 172, 172, 172, 255, 13,  13,  13,  255, 159, 159, 159, 255,
    46,  46,  46,  255, 11,  11,  11,  255, 37,  37,  37,  255, 162, 162, 162, 255, 0,   0,   0,   255, 180, 180, 180, 255, 7,   7,   7,   255, 8,
    8,   8,   255, 28,  28,  28,  255, 161, 161, 161, 255, 80,  80,  80,  255, 27,  27,  27,  255, 50,  50,  50,  255, 180, 180, 180, 255, 61,  61,
    61,  255, 10,  10,  10,  255, 3,   3,   3,   255, 40,  40,  40,  255, 54,  54,  54,  255, 63,  63,  63,  255, 59,  59,  59,  255, 181, 181, 181,
    255, 60,  60,  60,  255, 4,   4,   4,   255, 34,  34,  34,  255, 106, 106, 106, 255, 45,  45,  45,  255, 47,  47,  47,  255, 124, 124, 124, 255,
    124, 124, 124, 255, 10,  10,  10,  255, 14,  14,  14,  255, 151, 151, 151, 255, 76,  76,  76,  255, 165, 165, 165, 255, 69,  69,  69,  255, 18,
    18,  18,  255, 46,  46,  46,  255, 176, 176, 176, 255, 52,  52,  52,  255, 57,  57,  57,  255, 0,   0,   0,   255, 12,  12,  12,  255, 0,   0,
    0,   255, 6,   6,   6,   255, 5,   5,   5,   255, 1,   1,   1,   255, 2,   2,   2,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,
    255, 4,   4,   4,   255, 0,   0,   0,   255, 0,   0,   0,   255, 8,   8,   8,   255, 0,   0,   0,   255, 15,  15,  15,  255, 1,   1,   1,   255,
    0,   0,   0,   255, 7,   7,   7,   255, 3,   3,   3,   255, 8,   8,   8,   255, 0,   0,   0,   255, 0,   0,   0,   255, 4,   4,   4,   255, 3,
    3,   3,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 7,   7,   7,   255, 0,   0,   0,   255, 56,  56,
    56,  255, 153, 153, 153, 255, 143, 143, 143, 255, 82,  82,  82,  255, 61,  61,  61,  255, 40,  40,  40,  255, 19,  19,  19,  255, 10,  10,  10,
    255, 9,   9,   9,   255, 10,  10,  10,  255, 19,  19,  19,  255, 30,  30,  30,  255, 58,  58,  58,  255, 58,  58,  58,  255, 71,  71,  71,  255,
    70,  70,  70,  255, 29,  29,  29,  255, 23,  23,  23,  255, 52,  52,  52,  255, 41,  41,  41,  255, 9,   9,   9,   255, 0,   0,   0,   255, 0,
    0,   0,   255, 9,   9,   9,   255, 0,   0,   0,   255, 0,   0,   0,   255, 2,   2,   2,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,
    0,   255, 3,   3,   3,   255, 0,   0,   0,   255, 0,   0,   0,   255, 43,  43,  43,  255, 17,  17,  17,  255, 0,   0,   0,   255, 54,  54,  54,
    255, 0,   0,   0,   255, 100, 100, 100, 255, 65,  65,  65,  255, 19,  19,  19,  255, 79,  79,  79,  255, 67,  67,  67,  255, 57,  57,  57,  255,
    46,  46,  46,  255, 68,  68,  68,  255, 95,  95,  95,  255, 30,  30,  30,  255, 28,  28,  28,  255, 0,   0,   0,   255, 65,  65,  65,  255, 38,
    38,  38,  255, 2,   2,   2,   255, 188, 188, 188, 255, 0,   0,   0,   255, 44,  44,  44,  255, 180, 180, 180, 255, 8,   8,   8,   255, 160, 160,
    160, 255, 40,  40,  40,  255, 8,   8,   8,   255, 165, 165, 165, 255, 1,   1,   1,   255, 4,   4,   4,   255, 125, 125, 125, 255, 73,  73,  73,
    255, 3,   3,   3,   255, 0,   0,   0,   255, 1,   1,   1,   255, 22,  22,  22,  255, 194, 194, 194, 255, 0,   0,   0,   255, 5,   5,   5,   255,
    16,  16,  16,  255, 0,   0,   0,   255, 0,   0,   0,   255, 106, 106, 106, 255, 104, 104, 104, 255, 2,   2,   2,   255, 0,   0,   0,   255, 0,
    0,   0,   255, 0,   0,   0,   255, 1,   1,   1,   255, 0,   0,   0,   255, 8,   8,   8,   255, 174, 174, 174, 255, 0,   0,   0,   255, 0,   0,
    0,   255, 168, 168, 168, 255, 163, 163, 163, 255, 3,   3,   3,   255, 6,   6,   6,   255, 0,   0,   0,   255, 0,   0,   0,   255, 179, 179, 179,
    255, 2,   2,   2,   255, 0,   0,   0,   255, 8,   8,   8,   255, 7,   7,   7,   255, 4,   4,   4,   255, 0,   0,   0,   255, 0,   0,   0,   255,
    0,   0,   0,   255, 9,   9,   9,   255, 1,   1,   1,   255, 3,   3,   3,   255, 0,   0,   0,   255, 0,   0,   0,   255, 7,   7,   7,   255, 0,
    0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 2,   2,   2,   255, 0,   0,   0,   255, 3,   3,   3,   255, 4,   4,   4,   255, 0,   0,
    0,   255, 2,   2,   2,   255, 3,   3,   3,   255, 0,   0,   0,   255, 0,   0,   0,   255, 4,   4,   4,   255, 2,   2,   2,   255, 0,   0,   0,
    255, 4,   4,   4,   255, 0,   0,   0,   255, 0,   0,   0,   255, 15,  15,  15,  255, 135, 135, 135, 255, 147, 147, 147, 255, 107, 107, 107, 255,
    57,  57,  57,  255, 26,  26,  26,  255, 17,  17,  17,  255, 9,   9,   9,   255, 6,   6,   6,   255, 2,   2,   2,   255, 0,   0,   0,   255, 8,
    8,   8,   255, 18,  18,  18,  255, 52,  52,  52,  255, 73,  73,  73,  255, 70,  70,  70,  255, 79,  79,  79,  255, 95,  95,  95,  255, 90,  90,
    90,  255, 92,  92,  92,  255, 98,  98,  98,  255, 34,  34,  34,  255, 14,  14,  14,  255, 0,   0,   0,   255, 0,   0,   0,   255, 3,   3,   3,
    255, 7,   7,   7,   255, 1,   1,   1,   255, 0,   0,   0,   255, 1,   1,   1,   255, 6,   6,   6,   255, 0,   0,   0,   255, 3,   3,   3,   255,
    9,   9,   9,   255, 9,   9,   9,   255, 7,   7,   7,   255, 0,   0,   0,   255, 0,   0,   0,   255, 17,  17,  17,  255, 0,   0,   0,   255, 0,
    0,   0,   255, 10,  10,  10,  255, 16,  16,  16,  255, 0,   0,   0,   255, 0,   0,   0,   255, 9,   9,   9,   255, 5,   5,   5,   255, 0,   0,
    0,   255, 0,   0,   0,   255, 2,   2,   2,   255, 13,  13,  13,  255, 13,  13,  13,  255, 2,   2,   2,   255, 0,   0,   0,   255, 169, 169, 169,
    255, 0,   0,   0,   255, 1,   1,   1,   255, 89,  89,  89,  255, 194, 194, 194, 255, 94,  94,  94,  255, 0,   0,   0,   255, 5,   5,   5,   255,
    181, 181, 181, 255, 7,   7,   7,   255, 0,   0,   0,   255, 192, 192, 192, 255, 7,   7,   7,   255, 0,   0,   0,   255, 0,   0,   0,   255, 8,
    8,   8,   255, 0,   0,   0,   255, 153, 153, 153, 255, 48,  48,  48,  255, 10,  10,  10,  255, 0,   0,   0,   255, 3,   3,   3,   255, 78,  78,
    78,  255, 148, 148, 148, 255, 6,   6,   6,   255, 0,   0,   0,   255, 0,   0,   0,   255, 18,  18,  18,  255, 133, 133, 133, 255, 157, 157, 157,
    255, 170, 170, 170, 255, 153, 153, 153, 255, 200, 200, 200, 255, 35,  35,  35,  255, 0,   0,   0,   255, 165, 165, 165, 255, 53,  53,  53,  255,
    0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 180, 180, 180, 255, 2,   2,   2,   255, 0,   0,   0,   255, 9,
    9,   9,   255, 0,   0,   0,   255, 0,   0,   0,   255, 16,  16,  16,  255, 4,   4,   4,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,
    0,   255, 0,   0,   0,   255, 1,   1,   1,   255, 9,   9,   9,   255, 0,   0,   0,   255, 0,   0,   0,   255, 7,   7,   7,   255, 11,  11,  11,
    255, 5,   5,   5,   255, 3,   3,   3,   255, 9,   9,   9,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 8,   8,   8,   255,
    2,   2,   2,   255, 0,   0,   0,   255, 0,   0,   0,   255, 4,   4,   4,   255, 1,   1,   1,   255, 3,   3,   3,   255, 0,   0,   0,   255, 0,
    0,   0,   255, 54,  54,  54,  255, 146, 146, 146, 255, 115, 115, 115, 255, 60,  60,  60,  255, 31,  31,  31,  255, 10,  10,  10,  255, 7,   7,
    7,   255, 5,   5,   5,   255, 4,   4,   4,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 7,   7,   7,   255, 41,  41,  41,
    255, 58,  58,  58,  255, 83,  83,  83,  255, 98,  98,  98,  255, 100, 100, 100, 255, 125, 125, 125, 255, 110, 110, 110, 255, 24,  24,  24,  255,
    0,   0,   0,   255, 25,  25,  25,  255, 12,  12,  12,  255, 0,   0,   0,   255, 5,   5,   5,   255, 2,   2,   2,   255, 0,   0,   0,   255, 5,
    5,   5,   255, 0,   0,   0,   255, 8,   8,   8,   255, 0,   0,   0,   255, 0,   0,   0,   255, 25,  25,  25,  255, 246, 246, 246, 255, 165, 165,
    165, 255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 2,   2,   2,   255, 0,   0,   0,   255, 0,   0,   0,
    255, 4,   4,   4,   255, 5,   5,   5,   255, 0,   0,   0,   255, 7,   7,   7,   255, 8,   8,   8,   255, 0,   0,   0,   255, 21,  21,  21,  255,
    228, 228, 228, 255, 191, 191, 191, 255, 0,   0,   0,   255, 4,   4,   4,   255, 187, 187, 187, 255, 0,   0,   0,   255, 6,   6,   6,   255, 4,
    4,   4,   255, 96,  96,  96,  255, 9,   9,   9,   255, 0,   0,   0,   255, 0,   0,   0,   255, 176, 176, 176, 255, 14,  14,  14,  255, 0,   0,
    0,   255, 190, 190, 190, 255, 1,   1,   1,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 9,   9,   9,   255, 148, 148, 148,
    255, 41,  41,  41,  255, 0,   0,   0,   255, 0,   0,   0,   255, 50,  50,  50,  255, 166, 166, 166, 255, 0,   0,   0,   255, 1,   1,   1,   255,
    6,   6,   6,   255, 5,   5,   5,   255, 154, 154, 154, 255, 64,  64,  64,  255, 0,   0,   0,   255, 0,   0,   0,   255, 4,   4,   4,   255, 174,
    174, 174, 255, 0,   0,   0,   255, 18,  18,  18,  255, 157, 157, 157, 255, 13,  13,  13,  255, 9,   9,   9,   255, 8,   8,   8,   255, 3,   3,
    3,   255, 7,   7,   7,   255, 157, 157, 157, 255, 6,   6,   6,   255, 9,   9,   9,   255, 3,   3,   3,   255, 39,  39,  39,  255, 11,  11,  11,
    255, 21,  21,  21,  255, 3,   3,   3,   255, 8,   8,   8,   255, 0,   0,   0,   255, 9,   9,   9,   255, 0,   0,   0,   255, 0,   0,   0,   255,
    0,   0,   0,   255, 2,   2,   2,   255, 19,  19,  19,  255, 0,   0,   0,   255, 6,   6,   6,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,
    0,   0,   255, 73,  73,  73,  255, 45,  45,  45,  255, 0,   0,   0,   255, 5,   5,   5,   255, 2,   2,   2,   255, 3,   3,   3,   255, 0,   0,
    0,   255, 3,   3,   3,   255, 5,   5,   5,   255, 0,   0,   0,   255, 6,   6,   6,   255, 0,   0,   0,   255, 92,  92,  92,  255, 113, 113, 113,
    255, 104, 104, 104, 255, 43,  43,  43,  255, 4,   4,   4,   255, 3,   3,   3,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255,
    0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 7,   7,   7,   255, 53,  53,  53,  255, 92,  92,  92,  255, 96,
    96,  96,  255, 95,  95,  95,  255, 132, 132, 132, 255, 114, 114, 114, 255, 10,  10,  10,  255, 36,  36,  36,  255, 29,  29,  29,  255, 11,  11,
    11,  255, 0,   0,   0,   255, 2,   2,   2,   255, 1,   1,   1,   255, 0,   0,   0,   255, 0,   0,   0,   255, 3,   3,   3,   255, 0,   0,   0,
    255, 5,   5,   5,   255, 13,  13,  13,  255, 7,   7,   7,   255, 255, 255, 255, 255, 240, 240, 240, 255, 106, 106, 106, 255, 7,   7,   7,   255,
    7,   7,   7,   255, 2,   2,   2,   255, 9,   9,   9,   255, 1,   1,   1,   255, 5,   5,   5,   255, 0,   0,   0,   255, 0,   0,   0,   255, 3,
    3,   3,   255, 0,   0,   0,   255, 0,   0,   0,   255, 11,  11,  11,  255, 166, 166, 166, 255, 251, 251, 251, 255, 185, 185, 185, 255, 0,   0,
    0,   255, 0,   0,   0,   255, 169, 169, 169, 255, 4,   4,   4,   255, 0,   0,   0,   255, 0,   0,   0,   255, 4,   4,   4,   255, 2,   2,   2,
    255, 9,   9,   9,   255, 13,  13,  13,  255, 174, 174, 174, 255, 9,   9,   9,   255, 5,   5,   5,   255, 124, 124, 124, 255, 74,  74,  74,  255,
    5,   5,   5,   255, 0,   0,   0,   255, 0,   0,   0,   255, 17,  17,  17,  255, 189, 189, 189, 255, 0,   0,   0,   255, 7,   7,   7,   255, 29,
    29,  29,  255, 172, 172, 172, 255, 21,  21,  21,  255, 11,  11,  11,  255, 0,   0,   0,   255, 0,   0,   0,   255, 8,   8,   8,   255, 197, 197,
    197, 255, 0,   0,   0,   255, 2,   2,   2,   255, 0,   0,   0,   255, 0,   0,   0,   255, 189, 189, 189, 255, 24,  24,  24,  255, 0,   0,   0,
    255, 153, 153, 153, 255, 13,  13,  13,  255, 0,   0,   0,   255, 0,   0,   0,   255, 1,   1,   1,   255, 0,   0,   0,   255, 185, 185, 185, 255,
    2,   2,   2,   255, 0,   0,   0,   255, 26,  26,  26,  255, 90,  90,  90,  255, 46,  46,  46,  255, 60,  60,  60,  255, 46,  46,  46,  255, 61,
    61,  61,  255, 34,  34,  34,  255, 61,  61,  61,  255, 39,  39,  39,  255, 60,  60,  60,  255, 52,  52,  52,  255, 42,  42,  42,  255, 77,  77,
    77,  255, 8,   8,   8,   255, 2,   2,   2,   255, 6,   6,   6,   255, 0,   0,   0,   255, 3,   3,   3,   255, 226, 226, 226, 255, 107, 107, 107,
    255, 5,   5,   5,   255, 0,   0,   0,   255, 0,   0,   0,   255, 6,   6,   6,   255, 0,   0,   0,   255, 2,   2,   2,   255, 0,   0,   0,   255,
    2,   2,   2,   255, 4,   4,   4,   255, 16,  16,  16,  255, 132, 132, 132, 255, 97,  97,  97,  255, 86,  86,  86,  255, 29,  29,  29,  255, 0,
    0,   0,   255, 2,   2,   2,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 2,   2,   2,   255, 1,   1,
    1,   255, 0,   0,   0,   255, 0,   0,   0,   255, 30,  30,  30,  255, 58,  58,  58,  255, 96,  96,  96,  255, 129, 129, 129, 255, 131, 131, 131,
    255, 133, 133, 133, 255, 137, 137, 137, 255, 79,  79,  79,  255, 12,  12,  12,  255, 3,   3,   3,   255, 18,  18,  18,  255, 0,   0,   0,   255,
    0,   0,   0,   255, 12,  12,  12,  255, 0,   0,   0,   255, 2,   2,   2,   255, 0,   0,   0,   255, 4,   4,   4,   255, 0,   0,   0,   255, 15,
    15,  15,  255, 255, 255, 255, 255, 239, 239, 239, 255, 216, 216, 216, 255, 33,  33,  33,  255, 0,   0,   0,   255, 3,   3,   3,   255, 0,   0,
    0,   255, 0,   0,   0,   255, 2,   2,   2,   255, 0,   0,   0,   255, 12,  12,  12,  255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,
    255, 82,  82,  82,  255, 255, 255, 255, 255, 236, 236, 236, 255, 179, 179, 179, 255, 3,   3,   3,   255, 14,  14,  14,  255, 163, 163, 163, 255,
    16,  16,  16,  255, 6,   6,   6,   255, 0,   0,   0,   255, 12,  12,  12,  255, 3,   3,   3,   255, 0,   0,   0,   255, 0,   0,   0,   255, 179,
    179, 179, 255, 2,   2,   2,   255, 2,   2,   2,   255, 31,  31,  31,  255, 173, 173, 173, 255, 87,  87,  87,  255, 20,  20,  20,  255, 41,  41,
    41,  255, 172, 172, 172, 255, 58,  58,  58,  255, 6,   6,   6,   255, 0,   0,   0,   255, 193, 193, 193, 255, 72,  72,  72,  255, 38,  38,  38,
    255, 33,  33,  33,  255, 44,  44,  44,  255, 26,  26,  26,  255, 0,   0,   0,   255, 149, 149, 149, 255, 118, 118, 118, 255, 8,   8,   8,   255,
    38,  38,  38,  255, 135, 135, 135, 255, 206, 206, 206, 255, 16,  16,  16,  255, 5,   5,   5,   255, 171, 171, 171, 255, 16,  16,  16,  255, 7,
    7,   7,   255, 2,   2,   2,   255, 11,  11,  11,  255, 0,   0,   0,   255, 163, 163, 163, 255, 55,  55,  55,  255, 32,  32,  32,  255, 32,  32,
    32,  255, 48,  48,  48,  255, 28,  28,  28,  255, 65,  65,  65,  255, 54,  54,  54,  255, 55,  55,  55,  255, 23,  23,  23,  255, 45,  45,  45,
    255, 45,  45,  45,  255, 78,  78,  78,  255, 78,  78,  78,  255, 7,   7,   7,   255, 47,  47,  47,  255, 6,   6,   6,   255, 0,   0,   0,   255,
    6,   6,   6,   255, 0,   0,   0,   255, 0,   0,   0,   255, 238, 238, 238, 255, 128, 128, 128, 255, 6,   6,   6,   255, 0,   0,   0,   255, 0,
    0,   0,   255, 6,   6,   6,   255, 0,   0,   0,   255, 3,   3,   3,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 40,  40,
    40,  255, 133, 133, 133, 255, 79,  79,  79,  255, 37,  37,  37,  255, 3,   3,   3,   255, 0,   0,   0,   255, 2,   2,   2,   255, 1,   1,   1,
    255, 1,   1,   1,   255, 1,   1,   1,   255, 2,   2,   2,   255, 4,   4,   4,   255, 3,   3,   3,   255, 2,   2,   2,   255, 11,  11,  11,  255,
    0,   0,   0,   255, 16,  16,  16,  255, 93,  93,  93,  255, 115, 115, 115, 255, 122, 122, 122, 255, 158, 158, 158, 255, 166, 166, 166, 255, 54,
    54,  54,  255, 27,  27,  27,  255, 31,  31,  31,  255, 32,  32,  32,  255, 1,   1,   1,   255, 0,   0,   0,   255, 2,   2,   2,   255, 4,   4,
    4,   255, 4,   4,   4,   255, 0,   0,   0,   255, 2,   2,   2,   255, 0,   0,   0,   255, 26,  26,  26,  255, 254, 254, 254, 255, 89,  89,  89,
    255, 238, 238, 238, 255, 177, 177, 177, 255, 7,   7,   7,   255, 1,   1,   1,   255, 3,   3,   3,   255, 0,   0,   0,   255, 0,   0,   0,   255,
    7,   7,   7,   255, 0,   0,   0,   255, 4,   4,   4,   255, 0,   0,   0,   255, 27,  27,  27,  255, 240, 240, 240, 255, 149, 149, 149, 255, 164,
    164, 164, 255, 189, 189, 189, 255, 0,   0,   0,   255, 0,   0,   0,   255, 87,  87,  87,  255, 0,   0,   0,   255, 0,   0,   0,   255, 6,   6,
    6,   255, 0,   0,   0,   255, 0,   0,   0,   255, 5,   5,   5,   255, 0,   0,   0,   255, 97,  97,  97,  255, 0,   0,   0,   255, 0,   0,   0,
    255, 4,   4,   4,   255, 14,  14,  14,  255, 103, 103, 103, 255, 151, 151, 151, 255, 137, 137, 137, 255, 22,  22,  22,  255, 7,   7,   7,   255,
    1,   1,   1,   255, 36,  36,  36,  255, 111, 111, 111, 255, 119, 119, 119, 255, 114, 114, 114, 255, 116, 116, 116, 255, 116, 116, 116, 255, 82,
    82,  82,  255, 0,   0,   0,   255, 8,   8,   8,   255, 83,  83,  83,  255, 163, 163, 163, 255, 127, 127, 127, 255, 43,  43,  43,  255, 78,  78,
    78,  255, 5,   5,   5,   255, 0,   0,   0,   255, 70,  70,  70,  255, 7,   7,   7,   255, 5,   5,   5,   255, 0,   0,   0,   255, 0,   0,   0,
    255, 0,   0,   0,   255, 30,  30,  30,  255, 137, 137, 137, 255, 138, 138, 138, 255, 18,  18,  18,  255, 1,   1,   1,   255, 3,   3,   3,   255,
    7,   7,   7,   255, 20,  20,  20,  255, 37,  37,  37,  255, 25,  25,  25,  255, 33,  33,  33,  255, 29,  29,  29,  255, 31,  31,  31,  255, 17,
    17,  17,  255, 2,   2,   2,   255, 17,  17,  17,  255, 17,  17,  17,  255, 0,   0,   0,   255, 0,   0,   0,   255, 6,   6,   6,   255, 11,  11,
    11,  255, 214, 214, 214, 255, 113, 113, 113, 255, 0,   0,   0,   255, 4,   4,   4,   255, 0,   0,   0,   255, 5,   5,   5,   255, 0,   0,   0,
    255, 4,   4,   4,   255, 0,   0,   0,   255, 0,   0,   0,   255, 16,  16,  16,  255, 89,  89,  89,  255, 117, 117, 117, 255, 63,  63,  63,  255,
    13,  13,  13,  255, 5,   5,   5,   255, 0,   0,   0,   255, 0,   0,   0,   255, 2,   2,   2,   255, 3,   3,   3,   255, 1,   1,   1,   255, 0,
    0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 5,   5,   5,   255, 0,   0,   0,   255, 33,  33,
    33,  255, 114, 114, 114, 255, 155, 155, 155, 255, 149, 149, 149, 255, 126, 126, 126, 255, 157, 157, 157, 255, 136, 136, 136, 255, 51,  51,  51,
    255, 0,   0,   0,   255, 12,  12,  12,  255, 17,  17,  17,  255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255,
    0,   0,   0,   255, 7,   7,   7,   255, 13,  13,  13,  255, 244, 244, 244, 255, 99,  99,  99,  255, 67,  67,  67,  255, 255, 255, 255, 255, 93,
    93,  93,  255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 1,   1,   1,   255, 0,   0,   0,   255, 0,   0,   0,   255, 2,   2,
    2,   255, 0,   0,   0,   255, 190, 190, 190, 255, 213, 213, 213, 255, 12,  12,  12,  255, 188, 188, 188, 255, 178, 178, 178, 255, 2,   2,   2,
    255, 1,   1,   1,   255, 0,   0,   0,   255, 0,   0,   0,   255, 2,   2,   2,   255, 9,   9,   9,   255, 0,   0,   0,   255, 6,   6,   6,   255,
    5,   5,   5,   255, 25,  25,  25,  255, 60,  60,  60,  255, 62,  62,  62,  255, 47,  47,  47,  255, 0,   0,   0,   255, 0,   0,   0,   255, 1,
    1,   1,   255, 6,   6,   6,   255, 1,   1,   1,   255, 0,   0,   0,   255, 2,   2,   2,   255, 11,  11,  11,  255, 0,   0,   0,   255, 0,   0,
    0,   255, 12,  12,  12,  255, 0,   0,   0,   255, 9,   9,   9,   255, 0,   0,   0,   255, 3,   3,   3,   255, 0,   0,   0,   255, 0,   0,   0,
    255, 9,   9,   9,   255, 2,   2,   2,   255, 5,   5,   5,   255, 4,   4,   4,   255, 0,   0,   0,   255, 0,   0,   0,   255, 7,   7,   7,   255,
    7,   7,   7,   255, 0,   0,   0,   255, 2,   2,   2,   255, 15,  15,  15,  255, 34,  34,  34,  255, 45,  45,  45,  255, 15,  15,  15,  255, 0,
    0,   0,   255, 11,  11,  11,  255, 1,   1,   1,   255, 0,   0,   0,   255, 2,   2,   2,   255, 0,   0,   0,   255, 18,  18,  18,  255, 0,   0,
    0,   255, 7,   7,   7,   255, 0,   0,   0,   255, 9,   9,   9,   255, 0,   0,   0,   255, 3,   3,   3,   255, 0,   0,   0,   255, 12,  12,  12,
    255, 46,  46,  46,  255, 1,   1,   1,   255, 7,   7,   7,   255, 2,   2,   2,   255, 0,   0,   0,   255, 226, 226, 226, 255, 119, 119, 119, 255,
    4,   4,   4,   255, 0,   0,   0,   255, 10,  10,  10,  255, 8,   8,   8,   255, 0,   0,   0,   255, 13,  13,  13,  255, 3,   3,   3,   255, 0,
    0,   0,   255, 14,  14,  14,  255, 107, 107, 107, 255, 73,  73,  73,  255, 40,  40,  40,  255, 1,   1,   1,   255, 0,   0,   0,   255, 3,   3,
    3,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,
    255, 0,   0,   0,   255, 3,   3,   3,   255, 0,   0,   0,   255, 0,   0,   0,   255, 3,   3,   3,   255, 65,  65,  65,  255, 124, 124, 124, 255,
    136, 136, 136, 255, 170, 170, 170, 255, 155, 155, 155, 255, 131, 131, 131, 255, 39,  39,  39,  255, 32,  32,  32,  255, 32,  32,  32,  255, 34,
    34,  34,  255, 0,   0,   0,   255, 2,   2,   2,   255, 4,   4,   4,   255, 1,   1,   1,   255, 0,   0,   0,   255, 1,   1,   1,   255, 15,  15,
    15,  255, 249, 249, 249, 255, 78,  78,  78,  255, 11,  11,  11,  255, 156, 156, 156, 255, 235, 235, 235, 255, 34,  34,  34,  255, 0,   0,   0,
    255, 5,   5,   5,   255, 11,  11,  11,  255, 0,   0,   0,   255, 3,   3,   3,   255, 0,   0,   0,   255, 104, 104, 104, 255, 232, 232, 232, 255,
    82,  82,  82,  255, 0,   0,   0,   255, 172, 172, 172, 255, 188, 188, 188, 255, 0,   0,   0,   255, 11,  11,  11,  255, 0,   0,   0,   255, 4,
    4,   4,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 76,  76,  76,  255, 186, 186, 186, 255, 255, 255, 255, 255, 230, 230,
    230, 255, 255, 255, 255, 255, 240, 240, 240, 255, 218, 218, 218, 255, 120, 120, 120, 255, 0,   0,   0,   255, 0,   0,   0,   255, 8,   8,   8,
    255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 87,  87,  87,  255, 219, 219, 219, 255, 235, 235, 235, 255, 234, 234, 234, 255,
    235, 235, 235, 255, 222, 222, 222, 255, 242, 242, 242, 255, 242, 242, 242, 255, 228, 228, 228, 255, 231, 231, 231, 255, 231, 231, 231, 255, 241,
    241, 241, 255, 29,  29,  29,  255, 2,   2,   2,   255, 1,   1,   1,   255, 0,   0,   0,   255, 27,  27,  27,  255, 122, 122, 122, 255, 209, 209,
    209, 255, 255, 255, 255, 255, 254, 254, 254, 255, 241, 241, 241, 255, 255, 255, 255, 255, 211, 211, 211, 255, 87,  87,  87,  255, 3,   3,   3,
    255, 16,  16,  16,  255, 4,   4,   4,   255, 1,   1,   1,   255, 0,   0,   0,   255, 7,   7,   7,   255, 95,  95,  95,  255, 237, 237, 237, 255,
    0,   0,   0,   255, 4,   4,   4,   255, 38,  38,  38,  255, 172, 172, 172, 255, 254, 254, 254, 255, 237, 237, 237, 255, 7,   7,   7,   255, 0,
    0,   0,   255, 206, 206, 206, 255, 237, 237, 237, 255, 255, 255, 255, 255, 242, 242, 242, 255, 227, 227, 227, 255, 240, 240, 240, 255, 239, 239,
    239, 255, 227, 227, 227, 255, 91,  91,  91,  255, 0,   0,   0,   255, 0,   0,   0,   255, 3,   3,   3,   255, 29,  29,  29,  255, 86,  86,  86,
    255, 47,  47,  47,  255, 19,  19,  19,  255, 0,   0,   0,   255, 0,   0,   0,   255, 5,   5,   5,   255, 0,   0,   0,   255, 0,   0,   0,   255,
    0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,
    0,   0,   255, 0,   0,   0,   255, 7,   7,   7,   255, 0,   0,   0,   255, 71,  71,  71,  255, 162, 162, 162, 255, 136, 136, 136, 255, 140, 140,
    140, 255, 157, 157, 157, 255, 166, 166, 166, 255, 120, 120, 120, 255, 86,  86,  86,  255, 86,  86,  86,  255, 22,  22,  22,  255, 0,   0,   0,
    255, 0,   0,   0,   255, 3,   3,   3,   255, 0,   0,   0,   255, 0,   0,   0,   255, 19,  19,  19,  255, 255, 255, 255, 255, 77,  77,  77,  255,
    0,   0,   0,   255, 26,  26,  26,  255, 208, 208, 208, 255, 195, 195, 195, 255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,
    0,   0,   255, 5,   5,   5,   255, 36,  36,  36,  255, 238, 238, 238, 255, 146, 146, 146, 255, 0,   0,   0,   255, 0,   0,   0,   255, 172, 172,
    172, 255, 185, 185, 185, 255, 2,   2,   2,   255, 0,   0,   0,   255, 11,  11,  11,  255, 0,   0,   0,   255, 3,   3,   3,   255, 0,   0,   0,
    255, 150, 150, 150, 255, 250, 250, 250, 255, 167, 167, 167, 255, 58,  58,  58,  255, 14,  14,  14,  255, 15,  15,  15,  255, 44,  44,  44,  255,
    157, 157, 157, 255, 228, 228, 228, 255, 200, 200, 200, 255, 18,  18,  18,  255, 0,   0,   0,   255, 3,   3,   3,   255, 19,  19,  19,  255, 0,
    0,   0,   255, 28,  28,  28,  255, 82,  82,  82,  255, 57,  57,  57,  255, 72,  72,  72,  255, 70,  70,  70,  255, 73,  73,  73,  255, 57,  57,
    57,  255, 78,  78,  78,  255, 55,  55,  55,  255, 109, 109, 109, 255, 255, 255, 255, 255, 127, 127, 127, 255, 6,   6,   6,   255, 12,  12,  12,
    255, 0,   0,   0,   255, 4,   4,   4,   255, 150, 150, 150, 255, 224, 224, 224, 255, 117, 117, 117, 255, 53,  53,  53,  255, 38,  38,  38,  255,
    27,  27,  27,  255, 62,  62,  62,  255, 161, 161, 161, 255, 246, 246, 246, 255, 159, 159, 159, 255, 0,   0,   0,   255, 0,   0,   0,   255, 4,
    4,   4,   255, 13,  13,  13,  255, 0,   0,   0,   255, 80,  80,  80,  255, 231, 231, 231, 255, 20,  20,  20,  255, 81,  81,  81,  255, 250, 250,
    250, 255, 206, 206, 206, 255, 127, 127, 127, 255, 98,  98,  98,  255, 19,  19,  19,  255, 0,   0,   0,   255, 64,  64,  64,  255, 84,  84,  84,
    255, 220, 220, 220, 255, 162, 162, 162, 255, 88,  88,  88,  255, 78,  78,  78,  255, 73,  73,  73,  255, 74,  74,  74,  255, 15,  15,  15,  255,
    0,   0,   0,   255, 8,   8,   8,   255, 6,   6,   6,   255, 43,  43,  43,  255, 54,  54,  54,  255, 20,  20,  20,  255, 1,   1,   1,   255, 1,
    1,   1,   255, 4,   4,   4,   255, 3,   3,   3,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,
    0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 2,   2,   2,   255, 5,   5,   5,   255, 0,   0,   0,   255, 2,   2,   2,
    255, 0,   0,   0,   255, 15,  15,  15,  255, 96,  96,  96,  255, 140, 140, 140, 255, 163, 163, 163, 255, 154, 154, 154, 255, 142, 142, 142, 255,
    161, 161, 161, 255, 131, 131, 131, 255, 28,  28,  28,  255, 4,   4,   4,   255, 9,   9,   9,   255, 0,   0,   0,   255, 3,   3,   3,   255, 3,
    3,   3,   255, 0,   0,   0,   255, 15,  15,  15,  255, 255, 255, 255, 255, 84,  84,  84,  255, 0,   0,   0,   255, 0,   0,   0,   255, 61,  61,
    61,  255, 255, 255, 255, 255, 98,  98,  98,  255, 0,   0,   0,   255, 7,   7,   7,   255, 0,   0,   0,   255, 6,   6,   6,   255, 171, 171, 171,
    255, 215, 215, 215, 255, 14,  14,  14,  255, 0,   0,   0,   255, 8,   8,   8,   255, 179, 179, 179, 255, 182, 182, 182, 255, 4,   4,   4,   255,
    0,   0,   0,   255, 9,   9,   9,   255, 8,   8,   8,   255, 15,  15,  15,  255, 129, 129, 129, 255, 235, 235, 235, 255, 94,  94,  94,  255, 0,
    0,   0,   255, 0,   0,   0,   255, 3,   3,   3,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 68,  68,  68,  255, 239, 239,
    239, 255, 167, 167, 167, 255, 3,   3,   3,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 7,   7,   7,   255, 0,   0,   0,
    255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 4,   4,   4,   255, 0,   0,   0,   255, 0,   0,   0,   255, 22,  22,  22,  255,
    198, 198, 198, 255, 182, 182, 182, 255, 26,  26,  26,  255, 0,   0,   0,   255, 0,   0,   0,   255, 3,   3,   3,   255, 0,   0,   0,   255, 6,
    6,   6,   255, 13,  13,  13,  255, 0,   0,   0,   255, 8,   8,   8,   255, 0,   0,   0,   255, 11,  11,  11,  255, 0,   0,   0,   255, 0,   0,
    0,   255, 97,  97,  97,  255, 253, 253, 253, 255, 82,  82,  82,  255, 7,   7,   7,   255, 3,   3,   3,   255, 0,   0,   0,   255, 0,   0,   0,
    255, 112, 112, 112, 255, 240, 240, 240, 255, 43,  43,  43,  255, 253, 253, 253, 255, 108, 108, 108, 255, 17,  17,  17,  255, 0,   0,   0,   255,
    0,   0,   0,   255, 0,   0,   0,   255, 6,   6,   6,   255, 7,   7,   7,   255, 3,   3,   3,   255, 225, 225, 225, 255, 125, 125, 125, 255, 0,
    0,   0,   255, 0,   0,   0,   255, 11,  11,  11,  255, 4,   4,   4,   255, 0,   0,   0,   255, 14,  14,  14,  255, 0,   0,   0,   255, 2,   2,
    2,   255, 41,  41,  41,  255, 21,  21,  21,  255, 9,   9,   9,   255, 0,   0,   0,   255, 3,   3,   3,   255, 3,   3,   3,   255, 0,   0,   0,
    255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255,
    0,   0,   0,   255, 1,   1,   1,   255, 6,   6,   6,   255, 0,   0,   0,   255, 0,   0,   0,   255, 18,  18,  18,  255, 0,   0,   0,   255, 4,
    4,   4,   255, 122, 122, 122, 255, 160, 160, 160, 255, 147, 147, 147, 255, 138, 138, 138, 255, 167, 167, 167, 255, 95,  95,  95,  255, 6,   6,
    6,   255, 40,  40,  40,  255, 3,   3,   3,   255, 1,   1,   1,   255, 3,   3,   3,   255, 1,   1,   1,   255, 0,   0,   0,   255, 12,  12,  12,
    255, 250, 250, 250, 255, 77,  77,  77,  255, 2,   2,   2,   255, 0,   0,   0,   255, 3,   3,   3,   255, 131, 131, 131, 255, 240, 240, 240, 255,
    57,  57,  57,  255, 0,   0,   0,   255, 0,   0,   0,   255, 106, 106, 106, 255, 249, 249, 249, 255, 61,  61,  61,  255, 0,   0,   0,   255, 0,
    0,   0,   255, 0,   0,   0,   255, 176, 176, 176, 255, 191, 191, 191, 255, 0,   0,   0,   255, 11,  11,  11,  255, 0,   0,   0,   255, 0,   0,
    0,   255, 25,  25,  25,  255, 238, 238, 238, 255, 122, 122, 122, 255, 0,   0,   0,   255, 13,  13,  13,  255, 7,   7,   7,   255, 0,   0,   0,
    255, 1,   1,   1,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 91,  91,  91,  255, 255, 255, 255, 255, 94,  94,  94,  255,
    4,   4,   4,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 1,   1,   1,   255, 14,  14,  14,  255, 2,   2,   2,   255, 3,
    3,   3,   255, 8,   8,   8,   255, 3,   3,   3,   255, 5,   5,   5,   255, 188, 188, 188, 255, 216, 216, 216, 255, 27,  27,  27,  255, 0,   0,
    0,   255, 11,  11,  11,  255, 0,   0,   0,   255, 2,   2,   2,   255, 9,   9,   9,   255, 0,   0,   0,   255, 0,   0,   0,   255, 6,   6,   6,
    255, 1,   1,   1,   255, 7,   7,   7,   255, 0,   0,   0,   255, 3,   3,   3,   255, 3,   3,   3,   255, 0,   0,   0,   255, 193, 193, 193, 255,
    147, 147, 147, 255, 3,   3,   3,   255, 12,  12,  12,  255, 0,   0,   0,   255, 0,   0,   0,   255, 88,  88,  88,  255, 249, 249, 249, 255, 216,
    216, 216, 255, 90,  90,  90,  255, 8,   8,   8,   255, 0,   0,   0,   255, 6,   6,   6,   255, 8,   8,   8,   255, 0,   0,   0,   255, 3,   3,
    3,   255, 0,   0,   0,   255, 0,   0,   0,   255, 227, 227, 227, 255, 111, 111, 111, 255, 2,   2,   2,   255, 0,   0,   0,   255, 0,   0,   0,
    255, 8,   8,   8,   255, 0,   0,   0,   255, 0,   0,   0,   255, 5,   5,   5,   255, 0,   0,   0,   255, 27,  27,  27,  255, 0,   0,   0,   255,
    7,   7,   7,   255, 1,   1,   1,   255, 1,   1,   1,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,
    0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,
    0,   255, 9,   9,   9,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 40,  40,  40,  255, 98,  98,  98,
    255, 153, 153, 153, 255, 161, 161, 161, 255, 153, 153, 153, 255, 155, 155, 155, 255, 144, 144, 144, 255, 80,  80,  80,  255, 29,  29,  29,  255,
    7,   7,   7,   255, 0,   0,   0,   255, 0,   0,   0,   255, 1,   1,   1,   255, 20,  20,  20,  255, 252, 252, 252, 255, 73,  73,  73,  255, 0,
    0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 11,  11,  11,  255, 211, 211, 211, 255, 186, 186, 186, 255, 0,   0,   0,   255, 54,  54,
    54,  255, 242, 242, 242, 255, 128, 128, 128, 255, 0,   0,   0,   255, 0,   0,   0,   255, 7,   7,   7,   255, 0,   0,   0,   255, 173, 173, 173,
    255, 190, 190, 190, 255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 11,  11,  11,  255, 152, 152, 152, 255, 230, 230, 230, 255,
    17,  17,  17,  255, 14,  14,  14,  255, 0,   0,   0,   255, 0,   0,   0,   255, 1,   1,   1,   255, 1,   1,   1,   255, 0,   0,   0,   255, 11,
    11,  11,  255, 8,   8,   8,   255, 0,   0,   0,   255, 193, 193, 193, 255, 191, 191, 191, 255, 0,   0,   0,   255, 9,   9,   9,   255, 10,  10,
    10,  255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,
    255, 146, 146, 146, 255, 227, 227, 227, 255, 44,  44,  44,  255, 0,   0,   0,   255, 4,   4,   4,   255, 0,   0,   0,   255, 7,   7,   7,   255,
    0,   0,   0,   255, 0,   0,   0,   255, 2,   2,   2,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,
    0,   0,   255, 0,   0,   0,   255, 7,   7,   7,   255, 3,   3,   3,   255, 143, 143, 143, 255, 203, 203, 203, 255, 0,   0,   0,   255, 0,   0,
    0,   255, 0,   0,   0,   255, 6,   6,   6,   255, 86,  86,  86,  255, 255, 255, 255, 255, 208, 208, 208, 255, 0,   0,   0,   255, 6,   6,   6,
    255, 4,   4,   4,   255, 5,   5,   5,   255, 4,   4,   4,   255, 0,   0,   0,   255, 0,   0,   0,   255, 3,   3,   3,   255, 7,   7,   7,   255,
    226, 226, 226, 255, 116, 116, 116, 255, 16,  16,  16,  255, 5,   5,   5,   255, 0,   0,   0,   255, 12,  12,  12,  255, 0,   0,   0,   255, 0,
    0,   0,   255, 5,   5,   5,   255, 3,   3,   3,   255, 11,  11,  11,  255, 0,   0,   0,   255, 5,   5,   5,   255, 0,   0,   0,   255, 0,   0,
    0,   255, 0,   0,   0,   255, 3,   3,   3,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,
    255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 3,   3,   3,   255, 0,   0,   0,   255, 4,   4,   4,   255,
    0,   0,   0,   255, 0,   0,   0,   255, 16,  16,  16,  255, 0,   0,   0,   255, 54,  54,  54,  255, 141, 141, 141, 255, 141, 141, 141, 255, 139,
    139, 139, 255, 166, 166, 166, 255, 145, 145, 145, 255, 58,  58,  58,  255, 0,   0,   0,   255, 2,   2,   2,   255, 0,   0,   0,   255, 0,   0,
    0,   255, 1,   1,   1,   255, 22,  22,  22,  255, 255, 255, 255, 255, 78,  78,  78,  255, 0,   0,   0,   255, 12,  12,  12,  255, 0,   0,   0,
    255, 0,   0,   0,   255, 61,  61,  61,  255, 240, 240, 240, 255, 134, 134, 134, 255, 178, 178, 178, 255, 197, 197, 197, 255, 0,   0,   0,   255,
    9,   9,   9,   255, 0,   0,   0,   255, 11,  11,  11,  255, 3,   3,   3,   255, 176, 176, 176, 255, 183, 183, 183, 255, 0,   0,   0,   255, 6,
    6,   6,   255, 0,   0,   0,   255, 0,   0,   0,   255, 205, 205, 205, 255, 160, 160, 160, 255, 10,  10,  10,  255, 0,   0,   0,   255, 5,   5,
    5,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 9,   9,   9,   255, 2,   2,   2,   255, 0,   0,   0,   255, 0,   0,   0,
    255, 119, 119, 119, 255, 255, 255, 255, 255, 5,   5,   5,   255, 0,   0,   0,   255, 0,   0,   0,   255, 8,   8,   8,   255, 6,   6,   6,   255,
    0,   0,   0,   255, 7,   7,   7,   255, 0,   0,   0,   255, 5,   5,   5,   255, 108, 108, 108, 255, 243, 243, 243, 255, 78,  78,  78,  255, 0,
    0,   0,   255, 0,   0,   0,   255, 6,   6,   6,   255, 9,   9,   9,   255, 0,   0,   0,   255, 2,   2,   2,   255, 13,  13,  13,  255, 2,   2,
    2,   255, 35,  35,  35,  255, 104, 104, 104, 255, 153, 153, 153, 255, 189, 189, 189, 255, 174, 174, 174, 255, 168, 168, 168, 255, 151, 151, 151,
    255, 89,  89,  89,  255, 144, 144, 144, 255, 224, 224, 224, 255, 5,   5,   5,   255, 1,   1,   1,   255, 9,   9,   9,   255, 1,   1,   1,   255,
    96,  96,  96,  255, 250, 250, 250, 255, 95,  95,  95,  255, 4,   4,   4,   255, 0,   0,   0,   255, 5,   5,   5,   255, 0,   0,   0,   255, 0,
    0,   0,   255, 11,  11,  11,  255, 0,   0,   0,   255, 0,   0,   0,   255, 3,   3,   3,   255, 216, 216, 216, 255, 121, 121, 121, 255, 0,   0,
    0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 2,   2,   2,   255, 9,   9,   9,   255, 4,   4,   4,   255, 3,   3,   3,
    255, 0,   0,   0,   255, 0,   0,   0,   255, 6,   6,   6,   255, 0,   0,   0,   255, 0,   0,   0,   255, 2,   2,   2,   255, 3,   3,   3,   255,
    0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,
    0,   0,   255, 4,   4,   4,   255, 6,   6,   6,   255, 0,   0,   0,   255, 4,   4,   4,   255, 6,   6,   6,   255, 0,   0,   0,   255, 3,   3,
    3,   255, 0,   0,   0,   255, 2,   2,   2,   255, 68,  68,  68,  255, 145, 145, 145, 255, 166, 166, 166, 255, 126, 126, 126, 255, 135, 135, 135,
    255, 177, 177, 177, 255, 81,  81,  81,  255, 0,   0,   0,   255, 2,   2,   2,   255, 3,   3,   3,   255, 0,   0,   0,   255, 11,  11,  11,  255,
    250, 250, 250, 255, 77,  77,  77,  255, 2,   2,   2,   255, 0,   0,   0,   255, 4,   4,   4,   255, 13,  13,  13,  255, 0,   0,   0,   255, 135,
    135, 135, 255, 242, 242, 242, 255, 247, 247, 247, 255, 41,  41,  41,  255, 4,   4,   4,   255, 0,   0,   0,   255, 0,   0,   0,   255, 1,   1,
    1,   255, 0,   0,   0,   255, 176, 176, 176, 255, 185, 185, 185, 255, 3,   3,   3,   255, 0,   0,   0,   255, 9,   9,   9,   255, 1,   1,   1,
    255, 237, 237, 237, 255, 133, 133, 133, 255, 0,   0,   0,   255, 0,   0,   0,   255, 1,   1,   1,   255, 4,   4,   4,   255, 0,   0,   0,   255,
    2,   2,   2,   255, 5,   5,   5,   255, 0,   0,   0,   255, 1,   1,   1,   255, 8,   8,   8,   255, 73,  73,  73,  255, 249, 249, 249, 255, 49,
    49,  49,  255, 5,   5,   5,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 9,   9,   9,   255, 0,   0,   0,   255, 0,   0,
    0,   255, 73,  73,  73,  255, 241, 241, 241, 255, 112, 112, 112, 255, 0,   0,   0,   255, 10,  10,  10,  255, 9,   9,   9,   255, 0,   0,   0,
    255, 0,   0,   0,   255, 12,  12,  12,  255, 0,   0,   0,   255, 0,   0,   0,   255, 116, 116, 116, 255, 241, 241, 241, 255, 206, 206, 206, 255,
    164, 164, 164, 255, 127, 127, 127, 255, 129, 129, 129, 255, 143, 143, 143, 255, 179, 179, 179, 255, 207, 207, 207, 255, 255, 255, 255, 255, 211,
    211, 211, 255, 0,   0,   0,   255, 3,   3,   3,   255, 0,   0,   0,   255, 2,   2,   2,   255, 91,  91,  91,  255, 255, 255, 255, 255, 32,  32,
    32,  255, 0,   0,   0,   255, 2,   2,   2,   255, 0,   0,   0,   255, 6,   6,   6,   255, 0,   0,   0,   255, 5,   5,   5,   255, 0,   0,   0,
    255, 0,   0,   0,   255, 1,   1,   1,   255, 227, 227, 227, 255, 118, 118, 118, 255, 0,   0,   0,   255, 9,   9,   9,   255, 3,   3,   3,   255,
    0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 4,   4,   4,   255, 9,
    9,   9,   255, 0,   0,   0,   255, 0,   0,   0,   255, 3,   3,   3,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,
    0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 5,   5,   5,   255, 0,   0,   0,
    255, 5,   5,   5,   255, 1,   1,   1,   255, 0,   0,   0,   255, 6,   6,   6,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255,
    14,  14,  14,  255, 102, 102, 102, 255, 115, 115, 115, 255, 158, 158, 158, 255, 159, 159, 159, 255, 146, 146, 146, 255, 126, 126, 126, 255, 0,
    0,   0,   255, 2,   2,   2,   255, 2,   2,   2,   255, 0,   0,   0,   255, 18,  18,  18,  255, 250, 250, 250, 255, 85,  85,  85,  255, 0,   0,
    0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 15,  15,  15,  255, 189, 189, 189, 255, 113, 113, 113,
    255, 4,   4,   4,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 2,   2,   2,   255, 0,   0,   0,   255, 178, 178, 178, 255,
    187, 187, 187, 255, 0,   0,   0,   255, 5,   5,   5,   255, 0,   0,   0,   255, 0,   0,   0,   255, 249, 249, 249, 255, 127, 127, 127, 255, 0,
    0,   0,   255, 9,   9,   9,   255, 0,   0,   0,   255, 7,   7,   7,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 2,   2,
    2,   255, 0,   0,   0,   255, 10,  10,  10,  255, 75,  75,  75,  255, 255, 255, 255, 255, 31,  31,  31,  255, 0,   0,   0,   255, 8,   8,   8,
    255, 0,   0,   0,   255, 0,   0,   0,   255, 4,   4,   4,   255, 0,   0,   0,   255, 45,  45,  45,  255, 240, 240, 240, 255, 136, 136, 136, 255,
    0,   0,   0,   255, 11,  11,  11,  255, 0,   0,   0,   255, 0,   0,   0,   255, 3,   3,   3,   255, 8,   8,   8,   255, 0,   0,   0,   255, 1,
    1,   1,   255, 94,  94,  94,  255, 239, 239, 239, 255, 123, 123, 123, 255, 4,   4,   4,   255, 7,   7,   7,   255, 0,   0,   0,   255, 3,   3,
    3,   255, 0,   0,   0,   255, 0,   0,   0,   255, 13,  13,  13,  255, 119, 119, 119, 255, 211, 211, 211, 255, 9,   9,   9,   255, 0,   0,   0,
    255, 18,  18,  18,  255, 0,   0,   0,   255, 96,  96,  96,  255, 252, 252, 252, 255, 1,   1,   1,   255, 0,   0,   0,   255, 6,   6,   6,   255,
    0,   0,   0,   255, 5,   5,   5,   255, 0,   0,   0,   255, 4,   4,   4,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 226,
    226, 226, 255, 119, 119, 119, 255, 0,   0,   0,   255, 0,   0,   0,   255, 2,   2,   2,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,
    0,   255, 7,   7,   7,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,
    255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255,
    0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,
    0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 6,   6,   6,   255, 0,   0,   0,   255, 17,  17,  17,  255, 115, 115,
    115, 255, 147, 147, 147, 255, 133, 133, 133, 255, 118, 118, 118, 255, 148, 148, 148, 255, 5,   5,   5,   255, 0,   0,   0,   255, 2,   2,   2,
    255, 11,  11,  11,  255, 17,  17,  17,  255, 255, 255, 255, 255, 66,  66,  66,  255, 8,   8,   8,   255, 5,   5,   5,   255, 0,   0,   0,   255,
    8,   8,   8,   255, 10,  10,  10,  255, 0,   0,   0,   255, 36,  36,  36,  255, 4,   4,   4,   255, 0,   0,   0,   255, 4,   4,   4,   255, 7,
    7,   7,   255, 2,   2,   2,   255, 11,  11,  11,  255, 3,   3,   3,   255, 168, 168, 168, 255, 176, 176, 176, 255, 7,   7,   7,   255, 0,   0,
    0,   255, 7,   7,   7,   255, 8,   8,   8,   255, 194, 194, 194, 255, 180, 180, 180, 255, 21,  21,  21,  255, 0,   0,   0,   255, 10,  10,  10,
    255, 0,   0,   0,   255, 8,   8,   8,   255, 6,   6,   6,   255, 0,   0,   0,   255, 0,   0,   0,   255, 11,  11,  11,  255, 0,   0,   0,   255,
    129, 129, 129, 255, 232, 232, 232, 255, 5,   5,   5,   255, 7,   7,   7,   255, 0,   0,   0,   255, 9,   9,   9,   255, 0,   0,   0,   255, 0,
    0,   0,   255, 21,  21,  21,  255, 220, 220, 220, 255, 165, 165, 165, 255, 17,  17,  17,  255, 0,   0,   0,   255, 13,  13,  13,  255, 0,   0,
    0,   255, 16,  16,  16,  255, 0,   0,   0,   255, 0,   0,   0,   255, 5,   5,   5,   255, 0,   0,   0,   255, 222, 222, 222, 255, 180, 180, 180,
    255, 0,   0,   0,   255, 15,  15,  15,  255, 0,   0,   0,   255, 0,   0,   0,   255, 7,   7,   7,   255, 1,   1,   1,   255, 0,   0,   0,   255,
    0,   0,   0,   255, 117, 117, 117, 255, 233, 233, 233, 255, 0,   0,   0,   255, 1,   1,   1,   255, 9,   9,   9,   255, 2,   2,   2,   255, 87,
    87,  87,  255, 250, 250, 250, 255, 8,   8,   8,   255, 8,   8,   8,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,
    0,   255, 2,   2,   2,   255, 3,   3,   3,   255, 6,   6,   6,   255, 0,   0,   0,   255, 224, 224, 224, 255, 126, 126, 126, 255, 0,   0,   0,
    255, 2,   2,   2,   255, 4,   4,   4,   255, 0,   0,   0,   255, 6,   6,   6,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255,
    0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,
    0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,
    0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,
    255, 0,   0,   0,   255, 3,   3,   3,   255, 0,   0,   0,   255, 10,  10,  10,  255, 31,  31,  31,  255, 104, 104, 104, 255, 129, 129, 129, 255,
    151, 151, 151, 255, 136, 136, 136, 255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 11,  11,  11,  255, 253,
    253, 253, 255, 73,  73,  73,  255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 11,  11,  11,  255, 6,   6,   6,   255, 0,   0,
    0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 7,   7,   7,   255, 0,   0,   0,   255, 4,   4,   4,   255, 0,   0,   0,   255, 0,   0,   0,
    255, 0,   0,   0,   255, 179, 179, 179, 255, 185, 185, 185, 255, 0,   0,   0,   255, 0,   0,   0,   255, 8,   8,   8,   255, 0,   0,   0,   255,
    132, 132, 132, 255, 246, 246, 246, 255, 16,  16,  16,  255, 0,   0,   0,   255, 0,   0,   0,   255, 12,  12,  12,  255, 0,   0,   0,   255, 0,
    0,   0,   255, 3,   3,   3,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 199, 199, 199, 255, 186, 186, 186, 255, 0,   0,
    0,   255, 8,   8,   8,   255, 8,   8,   8,   255, 0,   0,   0,   255, 6,   6,   6,   255, 8,   8,   8,   255, 187, 187, 187, 255, 199, 199, 199,
    255, 27,  27,  27,  255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 7,   7,   7,   255, 0,   0,   0,   255, 0,   0,   0,   255,
    0,   0,   0,   255, 2,   2,   2,   255, 18,  18,  18,  255, 241, 241, 241, 255, 98,  98,  98,  255, 10,  10,  10,  255, 0,   0,   0,   255, 4,
    4,   4,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 3,   3,   3,   255, 19,  19,  19,  255, 131, 131, 131, 255, 209, 209,
    209, 255, 5,   5,   5,   255, 5,   5,   5,   255, 0,   0,   0,   255, 1,   1,   1,   255, 95,  95,  95,  255, 247, 247, 247, 255, 0,   0,   0,
    255, 0,   0,   0,   255, 0,   0,   0,   255, 5,   5,   5,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255,
    4,   4,   4,   255, 0,   0,   0,   255, 224, 224, 224, 255, 122, 122, 122, 255, 3,   3,   3,   255, 0,   0,   0,   255, 5,   5,   5,   255, 1,
    1,   1,   255, 1,   1,   1,   255, 11,  11,  11,  255, 4,   4,   4,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,
    0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,
    255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255,
    0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 7,
    7,   7,   255, 0,   0,   0,   255, 0,   0,   0,   255, 41,  41,  41,  255, 118, 118, 118, 255, 141, 141, 141, 255, 123, 123, 123, 255, 0,   0,
    0,   255, 14,  14,  14,  255, 0,   0,   0,   255, 0,   0,   0,   255, 19,  19,  19,  255, 246, 246, 246, 255, 90,  90,  90,  255, 0,   0,   0,
    255, 2,   2,   2,   255, 4,   4,   4,   255, 0,   0,   0,   255, 0,   0,   0,   255, 4,   4,   4,   255, 6,   6,   6,   255, 10,  10,  10,  255,
    0,   0,   0,   255, 0,   0,   0,   255, 2,   2,   2,   255, 2,   2,   2,   255, 0,   0,   0,   255, 0,   0,   0,   255, 182, 182, 182, 255, 196,
    196, 196, 255, 0,   0,   0,   255, 1,   1,   1,   255, 1,   1,   1,   255, 0,   0,   0,   255, 28,  28,  28,  255, 236, 236, 236, 255, 163, 163,
    163, 255, 10,  10,  10,  255, 5,   5,   5,   255, 4,   4,   4,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 6,   6,   6,
    255, 6,   6,   6,   255, 105, 105, 105, 255, 255, 255, 255, 255, 57,  57,  57,  255, 4,   4,   4,   255, 0,   0,   0,   255, 6,   6,   6,   255,
    3,   3,   3,   255, 0,   0,   0,   255, 159, 159, 159, 255, 229, 229, 229, 255, 39,  39,  39,  255, 0,   0,   0,   255, 4,   4,   4,   255, 15,
    15,  15,  255, 0,   0,   0,   255, 1,   1,   1,   255, 11,  11,  11,  255, 0,   0,   0,   255, 15,  15,  15,  255, 0,   0,   0,   255, 0,   0,
    0,   255, 242, 242, 242, 255, 141, 141, 141, 255, 0,   0,   0,   255, 0,   0,   0,   255, 6,   6,   6,   255, 0,   0,   0,   255, 18,  18,  18,
    255, 0,   0,   0,   255, 1,   1,   1,   255, 13,  13,  13,  255, 223, 223, 223, 255, 223, 223, 223, 255, 4,   4,   4,   255, 4,   4,   4,   255,
    1,   1,   1,   255, 0,   0,   0,   255, 104, 104, 104, 255, 243, 243, 243, 255, 0,   0,   0,   255, 0,   0,   0,   255, 10,  10,  10,  255, 1,
    1,   1,   255, 0,   0,   0,   255, 7,   7,   7,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 2,   2,   2,   255, 220, 220,
    220, 255, 127, 127, 127, 255, 0,   0,   0,   255, 1,   1,   1,   255, 9,   9,   9,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,
    255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255,
    0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,
    0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,
    0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 11,  11,  11,  255, 0,   0,   0,   255, 3,   3,   3,
    255, 6,   6,   6,   255, 68,  68,  68,  255, 103, 103, 103, 255, 131, 131, 131, 255, 0,   0,   0,   255, 5,   5,   5,   255, 0,   0,   0,   255,
    10,  10,  10,  255, 18,  18,  18,  255, 241, 241, 241, 255, 76,  76,  76,  255, 5,   5,   5,   255, 1,   1,   1,   255, 5,   5,   5,   255, 0,
    0,   0,   255, 0,   0,   0,   255, 2,   2,   2,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 8,   8,   8,   255, 0,   0,
    0,   255, 6,   6,   6,   255, 8,   8,   8,   255, 0,   0,   0,   255, 163, 163, 163, 255, 189, 189, 189, 255, 0,   0,   0,   255, 0,   0,   0,
    255, 1,   1,   1,   255, 4,   4,   4,   255, 5,   5,   5,   255, 106, 106, 106, 255, 247, 247, 247, 255, 125, 125, 125, 255, 0,   0,   0,   255,
    0,   0,   0,   255, 0,   0,   0,   255, 5,   5,   5,   255, 29,  29,  29,  255, 0,   0,   0,   255, 64,  64,  64,  255, 247, 247, 247, 255, 134,
    134, 134, 255, 0,   0,   0,   255, 11,  11,  11,  255, 6,   6,   6,   255, 0,   0,   0,   255, 8,   8,   8,   255, 111, 111, 111, 255, 225, 225,
    225, 255, 75,  75,  75,  255, 0,   0,   0,   255, 4,   4,   4,   255, 0,   0,   0,   255, 0,   0,   0,   255, 3,   3,   3,   255, 0,   0,   0,
    255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 10,  10,  10,  255, 4,   4,   4,   255, 150, 150, 150, 255, 237, 237, 237, 255,
    28,  28,  28,  255, 1,   1,   1,   255, 0,   0,   0,   255, 0,   0,   0,   255, 4,   4,   4,   255, 9,   9,   9,   255, 15,  15,  15,  255, 190,
    190, 190, 255, 231, 231, 231, 255, 209, 209, 209, 255, 1,   1,   1,   255, 0,   0,   0,   255, 12,  12,  12,  255, 0,   0,   0,   255, 88,  88,
    88,  255, 246, 246, 246, 255, 1,   1,   1,   255, 3,   3,   3,   255, 1,   1,   1,   255, 0,   0,   0,   255, 0,   0,   0,   255, 7,   7,   7,
    255, 1,   1,   1,   255, 0,   0,   0,   255, 4,   4,   4,   255, 6,   6,   6,   255, 175, 175, 175, 255, 188, 188, 188, 255, 4,   4,   4,   255,
    10,  10,  10,  255, 0,   0,   0,   255, 0,   0,   0,   255, 18,  18,  18,  255, 0,   0,   0,   255, 3,   3,   3,   255, 0,   0,   0,   255, 0,
    0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,
    0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,
    255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255,
    0,   0,   0,   255, 5,   5,   5,   255, 0,   0,   0,   255, 6,   6,   6,   255, 0,   0,   0,   255, 4,   4,   4,   255, 5,   5,   5,   255, 72,
    72,  72,  255, 127, 127, 127, 255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 2,   2,   2,   255, 14,  14,  14,  255, 255, 255,
    255, 255, 74,  74,  74,  255, 0,   0,   0,   255, 0,   0,   0,   255, 4,   4,   4,   255, 0,   0,   0,   255, 8,   8,   8,   255, 0,   0,   0,
    255, 2,   2,   2,   255, 0,   0,   0,   255, 9,   9,   9,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255,
    5,   5,   5,   255, 172, 172, 172, 255, 192, 192, 192, 255, 0,   0,   0,   255, 8,   8,   8,   255, 6,   6,   6,   255, 0,   0,   0,   255, 0,
    0,   0,   255, 0,   0,   0,   255, 120, 120, 120, 255, 253, 253, 253, 255, 205, 205, 205, 255, 111, 111, 111, 255, 36,  36,  36,  255, 41,  41,
    41,  255, 70,  70,  70,  255, 162, 162, 162, 255, 255, 255, 255, 255, 146, 146, 146, 255, 12,  12,  12,  255, 4,   4,   4,   255, 0,   0,   0,
    255, 5,   5,   5,   255, 0,   0,   0,   255, 74,  74,  74,  255, 255, 255, 255, 255, 189, 189, 189, 255, 100, 100, 100, 255, 108, 108, 108, 255,
    97,  97,  97,  255, 106, 106, 106, 255, 98,  98,  98,  255, 98,  98,  98,  255, 107, 107, 107, 255, 97,  97,  97,  255, 102, 102, 102, 255, 8,
    8,   8,   255, 4,   4,   4,   255, 0,   0,   0,   255, 27,  27,  27,  255, 218, 218, 218, 255, 237, 237, 237, 255, 127, 127, 127, 255, 64,  64,
    64,  255, 39,  39,  39,  255, 51,  51,  51,  255, 126, 126, 126, 255, 218, 218, 218, 255, 151, 151, 151, 255, 147, 147, 147, 255, 215, 215, 215,
    255, 4,   4,   4,   255, 1,   1,   1,   255, 0,   0,   0,   255, 0,   0,   0,   255, 93,  93,  93,  255, 255, 255, 255, 255, 6,   6,   6,   255,
    0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 1,   1,   1,   255, 4,
    4,   4,   255, 0,   0,   0,   255, 78,  78,  78,  255, 250, 250, 250, 255, 162, 162, 162, 255, 69,  69,  69,  255, 60,  60,  60,  255, 104, 104,
    104, 255, 50,  50,  50,  255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,
    255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255,
    0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,
    0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 2,   2,   2,   255, 0,   0,
    0,   255, 1,   1,   1,   255, 4,   4,   4,   255, 0,   0,   0,   255, 0,   0,   0,   255, 28,  28,  28,  255, 71,  71,  71,  255, 3,   3,   3,
    255, 7,   7,   7,   255, 6,   6,   6,   255, 0,   0,   0,   255, 13,  13,  13,  255, 193, 193, 193, 255, 65,  65,  65,  255, 0,   0,   0,   255,
    0,   0,   0,   255, 3,   3,   3,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 6,   6,   6,   255, 0,   0,   0,   255, 0,
    0,   0,   255, 0,   0,   0,   255, 9,   9,   9,   255, 1,   1,   1,   255, 0,   0,   0,   255, 14,  14,  14,  255, 132, 132, 132, 255, 137, 137,
    137, 255, 4,   4,   4,   255, 0,   0,   0,   255, 1,   1,   1,   255, 19,  19,  19,  255, 0,   0,   0,   255, 12,  12,  12,  255, 0,   0,   0,
    255, 55,  55,  55,  255, 165, 165, 165, 255, 222, 222, 222, 255, 255, 255, 255, 255, 254, 254, 254, 255, 248, 248, 248, 255, 178, 178, 178, 255,
    59,  59,  59,  255, 7,   7,   7,   255, 0,   0,   0,   255, 3,   3,   3,   255, 4,   4,   4,   255, 0,   0,   0,   255, 12,  12,  12,  255, 158,
    158, 158, 255, 203, 203, 203, 255, 192, 192, 192, 255, 198, 198, 198, 255, 185, 185, 185, 255, 211, 211, 211, 255, 200, 200, 200, 255, 216, 216,
    216, 255, 203, 203, 203, 255, 189, 189, 189, 255, 222, 222, 222, 255, 196, 196, 196, 255, 41,  41,  41,  255, 0,   0,   0,   255, 0,   0,   0,
    255, 7,   7,   7,   255, 3,   3,   3,   255, 140, 140, 140, 255, 222, 222, 222, 255, 239, 239, 239, 255, 253, 253, 253, 255, 249, 249, 249, 255,
    197, 197, 197, 255, 104, 104, 104, 255, 2,   2,   2,   255, 83,  83,  83,  255, 180, 180, 180, 255, 0,   0,   0,   255, 13,  13,  13,  255, 0,
    0,   0,   255, 5,   5,   5,   255, 78,  78,  78,  255, 174, 174, 174, 255, 12,  12,  12,  255, 0,   0,   0,   255, 3,   3,   3,   255, 1,   1,
    1,   255, 2,   2,   2,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 5,   5,   5,
    255, 82,  82,  82,  255, 225, 225, 225, 255, 238, 238, 238, 255, 253, 253, 253, 255, 212, 212, 212, 255, 32,  32,  32,  255, 0,   0,   0,   255,
    4,   4,   4,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,
    0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,
    0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,
    255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 3,   3,   3,   255, 0,   0,   0,   255, 16,  16,  16,  255,
    0,   0,   0,   255, 4,   4,   4,   255, 0,   0,   0,   255, 14,  14,  14,  255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 2,
    2,   2,   255, 0,   0,   0,   255, 8,   8,   8,   255, 8,   8,   8,   255, 0,   0,   0,   255, 4,   4,   4,   255, 0,   0,   0,   255, 1,   1,
    1,   255, 2,   2,   2,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 7,   7,   7,   255, 0,   0,   0,   255, 5,   5,   5,
    255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 6,   6,   6,   255, 8,   8,   8,   255, 0,   0,   0,   255, 3,   3,   3,   255,
    4,   4,   4,   255, 0,   0,   0,   255, 5,   5,   5,   255, 3,   3,   3,   255, 7,   7,   7,   255, 0,   0,   0,   255, 0,   0,   0,   255, 20,
    20,  20,  255, 13,  13,  13,  255, 41,  41,  41,  255, 0,   0,   0,   255, 15,  15,  15,  255, 3,   3,   3,   255, 0,   0,   0,   255, 3,   3,
    3,   255, 0,   0,   0,   255, 18,  18,  18,  255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 3,   3,   3,   255, 7,   7,   7,
    255, 1,   1,   1,   255, 16,  16,  16,  255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 1,   1,   1,   255, 11,  11,  11,  255,
    0,   0,   0,   255, 4,   4,   4,   255, 2,   2,   2,   255, 0,   0,   0,   255, 10,  10,  10,  255, 0,   0,   0,   255, 0,   0,   0,   255, 2,
    2,   2,   255, 0,   0,   0,   255, 30,  30,  30,  255, 33,  33,  33,  255, 11,  11,  11,  255, 0,   0,   0,   255, 0,   0,   0,   255, 9,   9,
    9,   255, 0,   0,   0,   255, 0,   0,   0,   255, 6,   6,   6,   255, 0,   0,   0,   255, 5,   5,   5,   255, 0,   0,   0,   255, 3,   3,   3,
    255, 6,   6,   6,   255, 0,   0,   0,   255, 0,   0,   0,   255, 2,   2,   2,   255, 0,   0,   0,   255, 4,   4,   4,   255, 0,   0,   0,   255,
    2,   2,   2,   255, 0,   0,   0,   255, 4,   4,   4,   255, 10,  10,  10,  255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 19,
    19,  19,  255, 14,  14,  14,  255, 3,   3,   3,   255, 0,   0,   0,   255, 6,   6,   6,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,
    0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,
    255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255,
    0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,
    0,   0,   255, 7,   7,   7,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 6,   6,   6,   255, 0,   0,   0,   255, 4,   4,
    4,   255, 5,   5,   5,   255, 0,   0,   0,   255, 5,   5,   5,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 1,   1,   1,
    255, 0,   0,   0,   255, 0,   0,   0,   255, 8,   8,   8,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255,
    8,   8,   8,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 9,   9,   9,   255, 0,   0,   0,   255, 8,   8,   8,   255, 0,
    0,   0,   255, 9,   9,   9,   255, 0,   0,   0,   255, 2,   2,   2,   255, 0,   0,   0,   255, 0,   0,   0,   255, 2,   2,   2,   255, 0,   0,
    0,   255, 34,  34,  34,  255, 48,  48,  48,  255, 5,   5,   5,   255, 0,   0,   0,   255, 0,   0,   0,   255, 8,   8,   8,   255, 2,   2,   2,
    255, 65,  65,  65,  255, 12,  12,  12,  255, 17,  17,  17,  255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 7,   7,   7,   255,
    11,  11,  11,  255, 0,   0,   0,   255, 5,   5,   5,   255, 0,   0,   0,   255, 0,   0,   0,   255, 7,   7,   7,   255, 0,   0,   0,   255, 5,
    5,   5,   255, 0,   0,   0,   255, 0,   0,   0,   255, 3,   3,   3,   255, 6,   6,   6,   255, 1,   1,   1,   255, 0,   0,   0,   255, 3,   3,
    3,   255, 0,   0,   0,   255, 0,   0,   0,   255, 1,   1,   1,   255, 4,   4,   4,   255, 0,   0,   0,   255, 11,  11,  11,  255, 10,  10,  10,
    255, 9,   9,   9,   255, 0,   0,   0,   255, 4,   4,   4,   255, 0,   0,   0,   255, 10,  10,  10,  255, 0,   0,   0,   255, 0,   0,   0,   255,
    4,   4,   4,   255, 0,   0,   0,   255, 14,  14,  14,  255, 0,   0,   0,   255, 0,   0,   0,   255, 10,  10,  10,  255, 0,   0,   0,   255, 9,
    9,   9,   255, 0,   0,   0,   255, 4,   4,   4,   255, 4,   4,   4,   255, 0,   0,   0,   255, 0,   0,   0,   255, 4,   4,   4,   255, 0,   0,
    0,   255, 4,   4,   4,   255, 0,   0,   0,   255, 6,   6,   6,   255, 0,   0,   0,   255, 33,  33,  33,  255, 1,   1,   1,   255, 0,   0,   0,
    255, 0,   0,   0,   255, 5,   5,   5,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 15,  15,  15,  255,
    0,   0,   0,   255, 0,   0,   0,   255, 8,   8,   8,   255, 0,   0,   0,   255, 0,   0,   0,   255, 4,   4,   4,   255, 0,   0,   0,   255, 0,
    0,   0,   255, 6,   6,   6,   255, 0,   0,   0,   255, 1,   1,   1,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,
    0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,
    255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 3,   3,   3,   255,
    0,   0,   0,   255, 0,   0,   0,   255, 6,   6,   6,   255, 6,   6,   6,   255, 37,  37,  37,  255, 0,   0,   0,   255, 8,   8,   8,   255, 0,
    0,   0,   255, 42,  42,  42,  255, 13,  13,  13,  255, 0,   0,   0,   255, 12,  12,  12,  255, 0,   0,   0,   255, 5,   5,   5,   255, 10,  10,
    10,  255, 0,   0,   0,   255, 10,  10,  10,  255, 0,   0,   0,   255, 2,   2,   2,   255, 7,   7,   7,   255, 0,   0,   0,   255, 8,   8,   8,
    255, 0,   0,   0,   255, 0,   0,   0,   255, 15,  15,  15,  255, 0,   0,   0,   255, 2,   2,   2,   255, 81,  81,  81,  255, 199, 199, 199, 255,
    32,  32,  32,  255, 0,   0,   0,   255, 6,   6,   6,   255, 2,   2,   2,   255, 38,  38,  38,  255, 227, 227, 227, 255, 38,  38,  38,  255, 0,
    0,   0,   255, 0,   0,   0,   255, 3,   3,   3,   255, 13,  13,  13,  255, 0,   0,   0,   255, 0,   0,   0,   255, 8,   8,   8,   255, 10,  10,
    10,  255, 0,   0,   0,   255, 4,   4,   4,   255, 0,   0,   0,   255, 0,   0,   0,   255, 1,   1,   1,   255, 6,   6,   6,   255, 0,   0,   0,
    255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 6,   6,   6,   255, 0,   0,   0,   255,
    6,   6,   6,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 147, 147, 147, 255, 0,   0,   0,   255, 20,  20,  20,  255, 3,
    3,   3,   255, 61,  61,  61,  255, 0,   0,   0,   255, 6,   6,   6,   255, 1,   1,   1,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,
    0,   255, 16,  16,  16,  255, 74,  74,  74,  255, 0,   0,   0,   255, 48,  48,  48,  255, 58,  58,  58,  255, 97,  97,  97,  255, 60,  60,  60,
    255, 53,  53,  53,  255, 36,  36,  36,  255, 65,  65,  65,  255, 51,  51,  51,  255, 96,  96,  96,  255, 18,  18,  18,  255, 89,  89,  89,  255,
    47,  47,  47,  255, 74,  74,  74,  255, 96,  96,  96,  255, 32,  32,  32,  255, 0,   0,   0,   255, 4,   4,   4,   255, 0,   0,   0,   255, 1,
    1,   1,   255, 4,   4,   4,   255, 2,   2,   2,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 4,   4,   4,   255, 0,   0,
    0,   255, 5,   5,   5,   255, 0,   0,   0,   255, 8,   8,   8,   255, 0,   0,   0,   255, 4,   4,   4,   255, 6,   6,   6,   255, 2,   2,   2,
    255, 4,   4,   4,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255,
    0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,
    0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 3,   3,   3,   255, 2,   2,   2,   255, 0,   0,
    0,   255, 0,   0,   0,   255, 166, 166, 166, 255, 33,  33,  33,  255, 0,   0,   0,   255, 77,  77,  77,  255, 113, 113, 113, 255, 1,   1,   1,
    255, 22,  22,  22,  255, 43,  43,  43,  255, 0,   0,   0,   255, 3,   3,   3,   255, 10,  10,  10,  255, 19,  19,  19,  255, 26,  26,  26,  255,
    6,   6,   6,   255, 14,  14,  14,  255, 28,  28,  28,  255, 1,   1,   1,   255, 8,   8,   8,   255, 8,   8,   8,   255, 16,  16,  16,  255, 106,
    106, 106, 255, 34,  34,  34,  255, 0,   0,   0,   255, 76,  76,  76,  255, 107, 107, 107, 255, 127, 127, 127, 255, 8,   8,   8,   255, 0,   0,
    0,   255, 7,   7,   7,   255, 167, 167, 167, 255, 120, 120, 120, 255, 41,  41,  41,  255, 10,  10,  10,  255, 5,   5,   5,   255, 31,  31,  31,
    255, 102, 102, 102, 255, 96,  96,  96,  255, 41,  41,  41,  255, 0,   0,   0,   255, 3,   3,   3,   255, 52,  52,  52,  255, 94,  94,  94,  255,
    77,  77,  77,  255, 91,  91,  91,  255, 74,  74,  74,  255, 9,   9,   9,   255, 15,  15,  15,  255, 48,  48,  48,  255, 107, 107, 107, 255, 85,
    85,  85,  255, 22,  22,  22,  255, 4,   4,   4,   255, 0,   0,   0,   255, 46,  46,  46,  255, 0,   0,   0,   255, 88,  88,  88,  255, 35,  35,
    35,  255, 83,  83,  83,  255, 169, 169, 169, 255, 88,  88,  88,  255, 34,  34,  34,  255, 8,   8,   8,   255, 249, 249, 249, 255, 67,  67,  67,
    255, 3,   3,   3,   255, 0,   0,   0,   255, 2,   2,   2,   255, 0,   0,   0,   255, 7,   7,   7,   255, 91,  91,  91,  255, 230, 230, 230, 255,
    16,  16,  16,  255, 54,  54,  54,  255, 0,   0,   0,   255, 43,  43,  43,  255, 59,  59,  59,  255, 44,  44,  44,  255, 32,  32,  32,  255, 67,
    67,  67,  255, 44,  44,  44,  255, 22,  22,  22,  255, 66,  66,  66,  255, 36,  36,  36,  255, 66,  66,  66,  255, 53,  53,  53,  255, 51,  51,
    51,  255, 0,   0,   0,   255, 13,  13,  13,  255, 0,   0,   0,   255, 0,   0,   0,   255, 4,   4,   4,   255, 1,   1,   1,   255, 0,   0,   0,
    255, 9,   9,   9,   255, 0,   0,   0,   255, 4,   4,   4,   255, 3,   3,   3,   255, 1,   1,   1,   255, 0,   0,   0,   255, 0,   0,   0,   255,
    0,   0,   0,   255, 0,   0,   0,   255, 4,   4,   4,   255, 155, 155, 155, 255, 0,   0,   0,   255, 8,   8,   8,   255, 0,   0,   0,   255, 0,
    0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,
    0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,
    255, 0,   0,   0,   255, 11,  11,  11,  255, 0,   0,   0,   255, 0,   0,   0,   255, 10,  10,  10,  255, 0,   0,   0,   255, 88,  88,  88,  255,
    112, 112, 112, 255, 44,  44,  44,  255, 66,  66,  66,  255, 88,  88,  88,  255, 24,  24,  24,  255, 92,  92,  92,  255, 26,  26,  26,  255, 121,
    121, 121, 255, 5,   5,   5,   255, 48,  48,  48,  255, 60,  60,  60,  255, 119, 119, 119, 255, 0,   0,   0,   255, 65,  65,  65,  255, 55,  55,
    55,  255, 77,  77,  77,  255, 54,  54,  54,  255, 111, 111, 111, 255, 39,  39,  39,  255, 100, 100, 100, 255, 50,  50,  50,  255, 0,   0,   0,
    255, 79,  79,  79,  255, 66,  66,  66,  255, 119, 119, 119, 255, 76,  76,  76,  255, 7,   7,   7,   255, 120, 120, 120, 255, 48,  48,  48,  255,
    130, 130, 130, 255, 38,  38,  38,  255, 0,   0,   0,   255, 77,  77,  77,  255, 140, 140, 140, 255, 33,  33,  33,  255, 52,  52,  52,  255, 157,
    157, 157, 255, 29,  29,  29,  255, 1,   1,   1,   255, 34,  34,  34,  255, 46,  46,  46,  255, 57,  57,  57,  255, 81,  81,  81,  255, 165, 165,
    165, 255, 3,   3,   3,   255, 12,  12,  12,  255, 96,  96,  96,  255, 38,  38,  38,  255, 54,  54,  54,  255, 168, 168, 168, 255, 0,   0,   0,
    255, 8,   8,   8,   255, 140, 140, 140, 255, 152, 152, 152, 255, 87,  87,  87,  255, 19,  19,  19,  255, 34,  34,  34,  255, 153, 153, 153, 255,
    46,  46,  46,  255, 31,  31,  31,  255, 13,  13,  13,  255, 198, 198, 198, 255, 184, 184, 184, 255, 7,   7,   7,   255, 13,  13,  13,  255, 0,
    0,   0,   255, 2,   2,   2,   255, 26,  26,  26,  255, 179, 179, 179, 255, 177, 177, 177, 255, 0,   0,   0,   255, 3,   3,   3,   255, 16,  16,
    16,  255, 14,  14,  14,  255, 8,   8,   8,   255, 2,   2,   2,   255, 43,  43,  43,  255, 13,  13,  13,  255, 35,  35,  35,  255, 31,  31,  31,
    255, 26,  26,  26,  255, 36,  36,  36,  255, 24,  24,  24,  255, 0,   0,   0,   255, 4,   4,   4,   255, 33,  33,  33,  255, 11,  11,  11,  255,
    0,   0,   0,   255, 16,  16,  16,  255, 2,   2,   2,   255, 2,   2,   2,   255, 17,  17,  17,  255, 0,   0,   0,   255, 3,   3,   3,   255, 3,
    3,   3,   255, 0,   0,   0,   255, 0,   0,   0,   255, 18,  18,  18,  255, 7,   7,   7,   255, 5,   5,   5,   255, 0,   0,   0,   255, 0,   0,
    0,   255, 172, 172, 172, 255, 0,   0,   0,   255, 0,   0,   0,   255, 9,   9,   9,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,
    255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255,
    0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 17,
    17,  17,  255, 0,   0,   0,   255, 8,   8,   8,   255, 6,   6,   6,   255, 83,  83,  83,  255, 7,   7,   7,   255, 112, 112, 112, 255, 11,  11,
    11,  255, 84,  84,  84,  255, 82,  82,  82,  255, 15,  15,  15,  255, 10,  10,  10,  255, 52,  52,  52,  255, 34,  34,  34,  255, 3,   3,   3,
    255, 102, 102, 102, 255, 0,   0,   0,   255, 28,  28,  28,  255, 103, 103, 103, 255, 70,  70,  70,  255, 115, 115, 115, 255, 49,  49,  49,  255,
    45,  45,  45,  255, 10,  10,  10,  255, 73,  73,  73,  255, 11,  11,  11,  255, 11,  11,  11,  255, 60,  60,  60,  255, 79,  79,  79,  255, 7,
    7,   7,   255, 142, 142, 142, 255, 63,  63,  63,  255, 124, 124, 124, 255, 15,  15,  15,  255, 114, 114, 114, 255, 21,  21,  21,  255, 11,  11,
    11,  255, 162, 162, 162, 255, 2,   2,   2,   255, 0,   0,   0,   255, 11,  11,  11,  255, 3,   3,   3,   255, 171, 171, 171, 255, 0,   0,   0,
    255, 0,   0,   0,   255, 14,  14,  14,  255, 6,   6,   6,   255, 153, 153, 153, 255, 16,  16,  16,  255, 0,   0,   0,   255, 20,  20,  20,  255,
    9,   9,   9,   255, 43,  43,  43,  255, 28,  28,  28,  255, 101, 101, 101, 255, 63,  63,  63,  255, 0,   0,   0,   255, 201, 201, 201, 255, 35,
    35,  35,  255, 0,   0,   0,   255, 5,   5,   5,   255, 27,  27,  27,  255, 131, 131, 131, 255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,
    0,   255, 164, 164, 164, 255, 56,  56,  56,  255, 154, 154, 154, 255, 0,   0,   0,   255, 0,   0,   0,   255, 7,   7,   7,   255, 170, 170, 170,
    255, 30,  30,  30,  255, 195, 195, 195, 255, 0,   0,   0,   255, 9,   9,   9,   255, 0,   0,   0,   255, 56,  56,  56,  255, 173, 173, 173, 255,
    167, 167, 167, 255, 163, 163, 163, 255, 110, 110, 110, 255, 0,   0,   0,   255, 24,  24,  24,  255, 0,   0,   0,   255, 158, 158, 158, 255, 156,
    156, 156, 255, 161, 161, 161, 255, 160, 160, 160, 255, 181, 181, 181, 255, 103, 103, 103, 255, 0,   0,   0,   255, 28,  28,  28,  255, 146, 146,
    146, 255, 165, 165, 165, 255, 157, 157, 157, 255, 147, 147, 147, 255, 36,  36,  36,  255, 4,   4,   4,   255, 3,   3,   3,   255, 136, 136, 136,
    255, 7,   7,   7,   255, 124, 124, 124, 255, 190, 190, 190, 255, 18,  18,  18,  255, 147, 147, 147, 255, 219, 219, 219, 255, 165, 165, 165, 255,
    156, 156, 156, 255, 23,  23,  23,  255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,
    0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,
    0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 6,   6,   6,
    255, 10,  10,  10,  255, 77,  77,  77,  255, 14,  14,  14,  255, 2,   2,   2,   255, 0,   0,   0,   255, 93,  93,  93,  255, 33,  33,  33,  255,
    71,  71,  71,  255, 0,   0,   0,   255, 105, 105, 105, 255, 6,   6,   6,   255, 96,  96,  96,  255, 15,  15,  15,  255, 0,   0,   0,   255, 81,
    81,  81,  255, 7,   7,   7,   255, 20,  20,  20,  255, 97,  97,  97,  255, 46,  46,  46,  255, 44,  44,  44,  255, 9,   9,   9,   255, 68,  68,
    68,  255, 6,   6,   6,   255, 0,   0,   0,   255, 74,  74,  74,  255, 68,  68,  68,  255, 0,   0,   0,   255, 42,  42,  42,  255, 185, 185, 185,
    255, 10,  10,  10,  255, 0,   0,   0,   255, 123, 123, 123, 255, 27,  27,  27,  255, 25,  25,  25,  255, 139, 139, 139, 255, 0,   0,   0,   255,
    15,  15,  15,  255, 0,   0,   0,   255, 16,  16,  16,  255, 140, 140, 140, 255, 8,   8,   8,   255, 6,   6,   6,   255, 0,   0,   0,   255, 150,
    150, 150, 255, 36,  36,  36,  255, 0,   0,   0,   255, 9,   9,   9,   255, 54,  54,  54,  255, 131, 131, 131, 255, 97,  97,  97,  255, 129, 129,
    129, 255, 167, 167, 167, 255, 56,  56,  56,  255, 0,   0,   0,   255, 162, 162, 162, 255, 8,   8,   8,   255, 0,   0,   0,   255, 0,   0,   0,
    255, 0,   0,   0,   255, 139, 139, 139, 255, 8,   8,   8,   255, 4,   4,   4,   255, 19,  19,  19,  255, 159, 159, 159, 255, 11,  11,  11,  255,
    144, 144, 144, 255, 68,  68,  68,  255, 10,  10,  10,  255, 104, 104, 104, 255, 97,  97,  97,  255, 0,   0,   0,   255, 189, 189, 189, 255, 0,
    0,   0,   255, 0,   0,   0,   255, 42,  42,  42,  255, 174, 174, 174, 255, 10,  10,  10,  255, 7,   7,   7,   255, 7,   7,   7,   255, 113, 113,
    113, 255, 118, 118, 118, 255, 3,   3,   3,   255, 0,   0,   0,   255, 10,  10,  10,  255, 1,   1,   1,   255, 0,   0,   0,   255, 18,  18,  18,
    255, 177, 177, 177, 255, 37,  37,  37,  255, 9,   9,   9,   255, 12,  12,  12,  255, 14,  14,  14,  255, 0,   0,   0,   255, 9,   9,   9,   255,
    46,  46,  46,  255, 175, 175, 175, 255, 0,   0,   0,   255, 0,   0,   0,   255, 173, 173, 173, 255, 138, 138, 138, 255, 76,  76,  76,  255, 0,
    0,   0,   255, 0,   0,   0,   255, 9,   9,   9,   255, 160, 160, 160, 255, 0,   0,   0,   255, 6,   6,   6,   255, 10,  10,  10,  255, 0,   0,
    0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,
    255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255,
    0,   0,   0,   255, 13,  13,  13,  255, 0,   0,   0,   255, 0,   0,   0,   255, 8,   8,   8,   255, 0,   0,   0,   255, 52,  52,  52,  255, 0,
    0,   0,   255, 0,   0,   0,   255, 2,   2,   2,   255, 23,  23,  23,  255, 10,  10,  10,  255, 52,  52,  52,  255, 79,  79,  79,  255, 27,  27,
    27,  255, 15,  15,  15,  255, 63,  63,  63,  255, 75,  75,  75,  255, 71,  71,  71,  255, 0,   0,   0,   255, 80,  80,  80,  255, 56,  56,  56,
    255, 49,  49,  49,  255, 24,  24,  24,  255, 0,   0,   0,   255, 0,   0,   0,   255, 14,  14,  14,  255, 84,  84,  84,  255, 15,  15,  15,  255,
    84,  84,  84,  255, 60,  60,  60,  255, 14,  14,  14,  255, 0,   0,   0,   255, 3,   3,   3,   255, 6,   6,   6,   255, 0,   0,   0,   255, 120,
    120, 120, 255, 33,  33,  33,  255, 0,   0,   0,   255, 161, 161, 161, 255, 17,  17,  17,  255, 0,   0,   0,   255, 0,   0,   0,   255, 15,  15,
    15,  255, 144, 144, 144, 255, 0,   0,   0,   255, 6,   6,   6,   255, 124, 124, 124, 255, 61,  61,  61,  255, 6,   6,   6,   255, 1,   1,   1,
    255, 0,   0,   0,   255, 165, 165, 165, 255, 19,  19,  19,  255, 0,   0,   0,   255, 0,   0,   0,   255, 101, 101, 101, 255, 53,  53,  53,  255,
    20,  20,  20,  255, 143, 143, 143, 255, 0,   0,   0,   255, 0,   0,   0,   255, 8,   8,   8,   255, 14,  14,  14,  255, 127, 127, 127, 255, 0,
    0,   0,   255, 9,   9,   9,   255, 0,   0,   0,   255, 176, 176, 176, 255, 0,   0,   0,   255, 4,   4,   4,   255, 185, 185, 185, 255, 52,  52,
    52,  255, 177, 177, 177, 255, 0,   0,   0,   255, 9,   9,   9,   255, 182, 182, 182, 255, 0,   0,   0,   255, 5,   5,   5,   255, 185, 185, 185,
    255, 19,  19,  19,  255, 2,   2,   2,   255, 0,   0,   0,   255, 0,   0,   0,   255, 12,  12,  12,  255, 197, 197, 197, 255, 15,  15,  15,  255,
    0,   0,   0,   255, 2,   2,   2,   255, 0,   0,   0,   255, 7,   7,   7,   255, 165, 165, 165, 255, 28,  28,  28,  255, 0,   0,   0,   255, 9,
    9,   9,   255, 0,   0,   0,   255, 17,  17,  17,  255, 34,  34,  34,  255, 49,  49,  49,  255, 8,   8,   8,   255, 160, 160, 160, 255, 19,  19,
    19,  255, 8,   8,   8,   255, 141, 141, 141, 255, 129, 129, 129, 255, 4,   4,   4,   255, 0,   0,   0,   255, 19,  19,  19,  255, 0,   0,   0,
    255, 175, 175, 175, 255, 13,  13,  13,  255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255,
    0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,
    0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 1,   1,   1,   255, 0,   0,
    0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 4,   4,   4,   255, 0,   0,   0,   255, 14,  14,  14,  255, 0,   0,   0,   255, 8,   8,   8,
    255, 0,   0,   0,   255, 1,   1,   1,   255, 0,   0,   0,   255, 0,   0,   0,   255, 4,   4,   4,   255, 0,   0,   0,   255, 7,   7,   7,   255,
    0,   0,   0,   255, 0,   0,   0,   255, 2,   2,   2,   255, 8,   8,   8,   255, 0,   0,   0,   255, 0,   0,   0,   255, 2,   2,   2,   255, 5,
    5,   5,   255, 13,  13,  13,  255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 65,  65,  65,  255, 79,  79,  79,  255, 0,   0,
    0,   255, 2,   2,   2,   255, 7,   7,   7,   255, 0,   0,   0,   255, 1,   1,   1,   255, 120, 120, 120, 255, 22,  22,  22,  255, 14,  14,  14,
    255, 78,  78,  78,  255, 127, 127, 127, 255, 18,  18,  18,  255, 26,  26,  26,  255, 145, 145, 145, 255, 58,  58,  58,  255, 4,   4,   4,   255,
    94,  94,  94,  255, 108, 108, 108, 255, 24,  24,  24,  255, 22,  22,  22,  255, 17,  17,  17,  255, 17,  17,  17,  255, 127, 127, 127, 255, 66,
    66,  66,  255, 17,  17,  17,  255, 50,  50,  50,  255, 189, 189, 189, 255, 57,  57,  57,  255, 0,   0,   0,   255, 149, 149, 149, 255, 2,   2,
    2,   255, 2,   2,   2,   255, 0,   0,   0,   255, 9,   9,   9,   255, 161, 161, 161, 255, 22,  22,  22,  255, 19,  19,  19,  255, 11,  11,  11,
    255, 167, 167, 167, 255, 0,   0,   0,   255, 0,   0,   0,   255, 63,  63,  63,  255, 219, 219, 219, 255, 25,  25,  25,  255, 8,   8,   8,   255,
    0,   0,   0,   255, 181, 181, 181, 255, 6,   6,   6,   255, 0,   0,   0,   255, 190, 190, 190, 255, 1,   1,   1,   255, 0,   0,   0,   255, 7,
    7,   7,   255, 2,   2,   2,   255, 0,   0,   0,   255, 141, 141, 141, 255, 50,  50,  50,  255, 5,   5,   5,   255, 3,   3,   3,   255, 0,   0,
    0,   255, 141, 141, 141, 255, 78,  78,  78,  255, 6,   6,   6,   255, 3,   3,   3,   255, 1,   1,   1,   255, 52,  52,  52,  255, 178, 178, 178,
    255, 119, 119, 119, 255, 122, 122, 122, 255, 136, 136, 136, 255, 226, 226, 226, 255, 8,   8,   8,   255, 3,   3,   3,   255, 159, 159, 159, 255,
    32,  32,  32,  255, 2,   2,   2,   255, 0,   0,   0,   255, 0,   0,   0,   255, 4,   4,   4,   255, 166, 166, 166, 255, 0,   0,   0,   255, 11,
    11,  11,  255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,
    0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,
    255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 3,   3,   3,   255, 0,   0,   0,   255, 0,   0,   0,   255, 1,   1,   1,   255,
    5,   5,   5,   255, 0,   0,   0,   255, 6,   6,   6,   255, 0,   0,   0,   255, 3,   3,   3,   255, 4,   4,   4,   255, 0,   0,   0,   255, 1,
    1,   1,   255, 0,   0,   0,   255, 1,   1,   1,   255, 0,   0,   0,   255, 4,   4,   4,   255, 0,   0,   0,   255, 0,   0,   0,   255, 3,   3,
    3,   255, 0,   0,   0,   255, 9,   9,   9,   255, 0,   0,   0,   255, 3,   3,   3,   255, 5,   5,   5,   255, 9,   9,   9,   255, 0,   0,   0,
    255, 0,   0,   0,   255, 0,   0,   0,   255, 42,  42,  42,  255, 22,  22,  22,  255, 0,   0,   0,   255, 4,   4,   4,   255, 0,   0,   0,   255,
    6,   6,   6,   255, 0,   0,   0,   255, 53,  53,  53,  255, 9,   9,   9,   255, 0,   0,   0,   255, 3,   3,   3,   255, 49,  49,  49,  255, 121,
    121, 121, 255, 124, 124, 124, 255, 28,  28,  28,  255, 7,   7,   7,   255, 8,   8,   8,   255, 75,  75,  75,  255, 108, 108, 108, 255, 96,  96,
    96,  255, 108, 108, 108, 255, 92,  92,  92,  255, 17,  17,  17,  255, 2,   2,   2,   255, 87,  87,  87,  255, 132, 132, 132, 255, 90,  90,  90,
    255, 40,  40,  40,  255, 23,  23,  23,  255, 11,  11,  11,  255, 46,  46,  46,  255, 3,   3,   3,   255, 0,   0,   0,   255, 0,   0,   0,   255,
    8,   8,   8,   255, 44,  44,  44,  255, 122, 122, 122, 255, 60,  60,  60,  255, 24,  24,  24,  255, 163, 163, 163, 255, 2,   2,   2,   255, 4,
    4,   4,   255, 0,   0,   0,   255, 34,  34,  34,  255, 2,   2,   2,   255, 0,   0,   0,   255, 7,   7,   7,   255, 182, 182, 182, 255, 0,   0,
    0,   255, 1,   1,   1,   255, 177, 177, 177, 255, 15,  15,  15,  255, 1,   1,   1,   255, 0,   0,   0,   255, 0,   0,   0,   255, 8,   8,   8,
    255, 146, 146, 146, 255, 26,  26,  26,  255, 10,  10,  10,  255, 0,   0,   0,   255, 96,  96,  96,  255, 125, 125, 125, 255, 0,   0,   0,   255,
    0,   0,   0,   255, 0,   0,   0,   255, 3,   3,   3,   255, 188, 188, 188, 255, 10,  10,  10,  255, 0,   0,   0,   255, 7,   7,   7,   255, 0,
    0,   0,   255, 164, 164, 164, 255, 13,  13,  13,  255, 0,   0,   0,   255, 159, 159, 159, 255, 18,  18,  18,  255, 2,   2,   2,   255, 0,   0,
    0,   255, 1,   1,   1,   255, 0,   0,   0,   255, 167, 167, 167, 255, 0,   0,   0,   255, 5,   5,   5,   255, 2,   2,   2,   255, 11,  11,  11,
    255, 0,   0,   0,   255, 7,   7,   7,   255, 1,   1,   1,   255, 0,   0,   0,   255, 4,   4,   4,   255, 0,   0,   0,   255, 8,   8,   8,   255,
    0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,
    0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 19,  19,  19,  255, 0,   0,   0,   255, 13,  13,  13,  255, 48,  48,  48,  255, 41,  41,
    41,  255, 9,   9,   9,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 4,   4,   4,   255, 0,   0,   0,   255, 13,  13,  13,
    255, 0,   0,   0,   255, 1,   1,   1,   255, 79,  79,  79,  255, 27,  27,  27,  255, 2,   2,   2,   255, 70,  70,  70,  255, 24,  24,  24,  255,
    73,  73,  73,  255, 37,  37,  37,  255, 19,  19,  19,  255, 39,  39,  39,  255, 43,  43,  43,  255, 43,  43,  43,  255, 52,  52,  52,  255, 52,
    52,  52,  255, 12,  12,  12,  255, 17,  17,  17,  255, 0,   0,   0,   255, 6,   6,   6,   255, 0,   0,   0,   255, 3,   3,   3,   255, 10,  10,
    10,  255, 0,   0,   0,   255, 12,  12,  12,  255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 4,   4,   4,   255, 7,   7,   7,
    255, 2,   2,   2,   255, 0,   0,   0,   255, 13,  13,  13,  255, 0,   0,   0,   255, 5,   5,   5,   255, 0,   0,   0,   255, 5,   5,   5,   255,
    5,   5,   5,   255, 8,   8,   8,   255, 8,   8,   8,   255, 0,   0,   0,   255, 13,  13,  13,  255, 0,   0,   0,   255, 0,   0,   0,   255, 0,
    0,   0,   255, 9,   9,   9,   255, 0,   0,   0,   255, 2,   2,   2,   255, 0,   0,   0,   255, 0,   0,   0,   255, 9,   9,   9,   255, 1,   1,
    1,   255, 7,   7,   7,   255, 0,   0,   0,   255, 155, 155, 155, 255, 2,   2,   2,   255, 0,   0,   0,   255, 13,  13,  13,  255, 0,   0,   0,
    255, 1,   1,   1,   255, 5,   5,   5,   255, 0,   0,   0,   255, 185, 185, 185, 255, 0,   0,   0,   255, 8,   8,   8,   255, 109, 109, 109, 255,
    119, 119, 119, 255, 3,   3,   3,   255, 0,   0,   0,   255, 2,   2,   2,   255, 55,  55,  55,  255, 176, 176, 176, 255, 9,   9,   9,   255, 0,
    0,   0,   255, 76,  76,  76,  255, 152, 152, 152, 255, 3,   3,   3,   255, 0,   0,   0,   255, 0,   0,   0,   255, 8,   8,   8,   255, 0,   0,
    0,   255, 196, 196, 196, 255, 1,   1,   1,   255, 10,  10,  10,  255, 0,   0,   0,   255, 22,  22,  22,  255, 214, 214, 214, 255, 12,  12,  12,
    255, 0,   0,   0,   255, 178, 178, 178, 255, 11,  11,  11,  255, 0,   0,   0,   255, 12,  12,  12,  255, 0,   0,   0,   255, 1,   1,   1,   255,
    189, 189, 189, 255, 0,   0,   0,   255, 6,   6,   6,   255, 0,   0,   0,   255, 0,   0,   0,   255, 2,   2,   2,   255, 12,  12,  12,  255, 0,
    0,   0,   255, 6,   6,   6,   255, 4,   4,   4,   255, 10,  10,  10,  255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,
    0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 6,   6,   6,   255, 0,   0,   0,
    255, 11,  11,  11,  255, 0,   0,   0,   255, 0,   0,   0,   255, 144, 144, 144, 255, 222, 222, 222, 255, 9,   9,   9,   255, 0,   0,   0,   255,
    11,  11,  11,  255, 6,   6,   6,   255, 0,   0,   0,   255, 0,   0,   0,   255, 2,   2,   2,   255, 10,  10,  10,  255, 47,  47,  47,  255, 240,
    240, 240, 255, 82,  82,  82,  255, 1,   1,   1,   255, 41,  41,  41,  255, 59,  59,  59,  255, 69,  69,  69,  255, 47,  47,  47,  255, 56,  56,
    56,  255, 62,  62,  62,  255, 60,  60,  60,  255, 70,  70,  70,  255, 43,  43,  43,  255, 66,  66,  66,  255, 0,   0,   0,   255, 0,   0,   0,
    255, 2,   2,   2,   255, 0,   0,   0,   255, 10,  10,  10,  255, 4,   4,   4,   255, 0,   0,   0,   255, 0,   0,   0,   255, 8,   8,   8,   255,
    0,   0,   0,   255, 3,   3,   3,   255, 0,   0,   0,   255, 14,  14,  14,  255, 0,   0,   0,   255, 1,   1,   1,   255, 1,   1,   1,   255, 0,
    0,   0,   255, 12,  12,  12,  255, 0,   0,   0,   255, 0,   0,   0,   255, 9,   9,   9,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,
    0,   255, 10,  10,  10,  255, 0,   0,   0,   255, 4,   4,   4,   255, 20,  20,  20,  255, 0,   0,   0,   255, 0,   0,   0,   255, 11,  11,  11,
    255, 163, 163, 163, 255, 36,  36,  36,  255, 0,   0,   0,   255, 1,   1,   1,   255, 0,   0,   0,   255, 5,   5,   5,   255, 10,  10,  10,  255,
    172, 172, 172, 255, 16,  16,  16,  255, 0,   0,   0,   255, 0,   0,   0,   255, 20,  20,  20,  255, 0,   0,   0,   255, 4,   4,   4,   255, 0,
    0,   0,   255, 178, 178, 178, 255, 3,   3,   3,   255, 0,   0,   0,   255, 4,   4,   4,   255, 128, 128, 128, 255, 176, 176, 176, 255, 99,  99,
    99,  255, 129, 129, 129, 255, 157, 157, 157, 255, 20,  20,  20,  255, 0,   0,   0,   255, 38,  38,  38,  255, 217, 217, 217, 255, 139, 139, 139,
    255, 113, 113, 113, 255, 144, 144, 144, 255, 129, 129, 129, 255, 89,  89,  89,  255, 13,  13,  13,  255, 68,  68,  68,  255, 186, 186, 186, 255,
    103, 103, 103, 255, 124, 124, 124, 255, 161, 161, 161, 255, 183, 183, 183, 255, 15,  15,  15,  255, 0,   0,   0,   255, 143, 143, 143, 255, 26,
    26,  26,  255, 0,   0,   0,   255, 0,   0,   0,   255, 17,  17,  17,  255, 0,   0,   0,   255, 121, 121, 121, 255, 151, 151, 151, 255, 107, 107,
    107, 255, 45,  45,  45,  255, 7,   7,   7,   255, 11,  11,  11,  255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 2,   2,   2,
    255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255,
    0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 12,  12,  12,  255, 0,   0,   0,   255, 0,   0,   0,   255, 8,
    8,   8,   255, 141, 141, 141, 255, 219, 219, 219, 255, 154, 154, 154, 255, 12,  12,  12,  255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,
    0,   255, 19,  19,  19,  255, 0,   0,   0,   255, 0,   0,   0,   255, 205, 205, 205, 255, 227, 227, 227, 255, 77,  77,  77,  255, 0,   0,   0,
    255, 6,   6,   6,   255, 0,   0,   0,   255, 3,   3,   3,   255, 13,  13,  13,  255, 5,   5,   5,   255, 28,  28,  28,  255, 6,   6,   6,   255,
    13,  13,  13,  255, 11,  11,  11,  255, 0,   0,   0,   255, 15,  15,  15,  255, 3,   3,   3,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,
    0,   0,   255, 2,   2,   2,   255, 12,  12,  12,  255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,
    0,   255, 0,   0,   0,   255, 11,  11,  11,  255, 0,   0,   0,   255, 6,   6,   6,   255, 5,   5,   5,   255, 1,   1,   1,   255, 0,   0,   0,
    255, 0,   0,   0,   255, 0,   0,   0,   255, 26,  26,  26,  255, 0,   0,   0,   255, 0,   0,   0,   255, 10,  10,  10,  255, 10,  10,  10,  255,
    0,   0,   0,   255, 0,   0,   0,   255, 6,   6,   6,   255, 10,  10,  10,  255, 0,   0,   0,   255, 210, 210, 210, 255, 28,  28,  28,  255, 0,
    0,   0,   255, 2,   2,   2,   255, 2,   2,   2,   255, 0,   0,   0,   255, 0,   0,   0,   255, 19,  19,  19,  255, 0,   0,   0,   255, 20,  20,
    20,  255, 0,   0,   0,   255, 0,   0,   0,   255, 7,   7,   7,   255, 0,   0,   0,   255, 0,   0,   0,   255, 19,  19,  19,  255, 9,   9,   9,
    255, 0,   0,   0,   255, 0,   0,   0,   255, 9,   9,   9,   255, 8,   8,   8,   255, 73,  73,  73,  255, 42,  42,  42,  255, 9,   9,   9,   255,
    0,   0,   0,   255, 3,   3,   3,   255, 18,  18,  18,  255, 31,  31,  31,  255, 25,  25,  25,  255, 27,  27,  27,  255, 26,  26,  26,  255, 30,
    30,  30,  255, 9,   9,   9,   255, 1,   1,   1,   255, 0,   0,   0,   255, 16,  16,  16,  255, 68,  68,  68,  255, 41,  41,  41,  255, 0,   0,
    0,   255, 11,  11,  11,  255, 0,   0,   0,   255, 11,  11,  11,  255, 28,  28,  28,  255, 0,   0,   0,   255, 3,   3,   3,   255, 2,   2,   2,
    255, 0,   0,   0,   255, 1,   1,   1,   255, 0,   0,   0,   255, 53,  53,  53,  255, 43,  43,  43,  255, 0,   0,   0,   255, 0,   0,   0,   255,
    0,   0,   0,   255, 0,   0,   0,   255, 9,   9,   9,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 11,  11,  11,  255, 0,
    0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,
    0,   255, 0,   0,   0,   255, 8,   8,   8,   255, 0,   0,   0,   255, 0,   0,   0,   255, 14,  14,  14,  255, 128, 128, 128, 255, 98,  98,  98,
    255, 202, 202, 202, 255, 79,  79,  79,  255, 0,   0,   0,   255, 0,   0,   0,   255, 8,   8,   8,   255, 0,   0,   0,   255, 0,   0,   0,   255,
    143, 143, 143, 255, 146, 146, 146, 255, 153, 153, 153, 255, 96,  96,  96,  255, 13,  13,  13,  255, 0,   0,   0,   255, 3,   3,   3,   255, 0,
    0,   0,   255, 9,   9,   9,   255, 3,   3,   3,   255, 27,  27,  27,  255, 33,  33,  33,  255, 4,   4,   4,   255, 0,   0,   0,   255, 4,   4,
    4,   255, 0,   0,   0,   255, 9,   9,   9,   255, 9,   9,   9,   255, 13,  13,  13,  255, 4,   4,   4,   255, 2,   2,   2,   255, 0,   0,   0,
    255, 6,   6,   6,   255, 12,  12,  12,  255, 12,  12,  12,  255, 0,   0,   0,   255, 17,  17,  17,  255, 0,   0,   0,   255, 2,   2,   2,   255,
    0,   0,   0,   255, 13,  13,  13,  255, 18,  18,  18,  255, 15,  15,  15,  255, 4,   4,   4,   255, 11,  11,  11,  255, 4,   4,   4,   255, 0,
    0,   0,   255, 5,   5,   5,   255, 6,   6,   6,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 26,  26,  26,  255, 16,  16,
    16,  255, 0,   0,   0,   255, 10,  10,  10,  255, 203, 203, 203, 255, 31,  31,  31,  255, 4,   4,   4,   255, 7,   7,   7,   255, 10,  10,  10,
    255, 10,  10,  10,  255, 75,  75,  75,  255, 11,  11,  11,  255, 15,  15,  15,  255, 19,  19,  19,  255, 56,  56,  56,  255, 0,   0,   0,   255,
    0,   0,   0,   255, 7,   7,   7,   255, 3,   3,   3,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 12,  12,  12,  255, 0,
    0,   0,   255, 9,   9,   9,   255, 0,   0,   0,   255, 5,   5,   5,   255, 0,   0,   0,   255, 6,   6,   6,   255, 3,   3,   3,   255, 24,  24,
    24,  255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 90,  90,  90,  255, 27,  27,  27,  255, 8,   8,   8,   255, 1,   1,   1,
    255, 6,   6,   6,   255, 62,  62,  62,  255, 75,  75,  75,  255, 0,   0,   0,   255, 9,   9,   9,   255, 5,   5,   5,   255, 17,  17,  17,  255,
    0,   0,   0,   255, 0,   0,   0,   255, 2,   2,   2,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 2,   2,   2,   255, 2,
    2,   2,   255, 0,   0,   0,   255, 1,   1,   1,   255, 6,   6,   6,   255, 0,   0,   0,   255, 0,   0,   0,   255, 8,   8,   8,   255, 0,   0,
    0,   255, 3,   3,   3,   255, 10,  10,  10,  255, 47,  47,  47,  255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,
    255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 5,   5,   5,   255, 0,   0,   0,   255,
    3,   3,   3,   255, 0,   0,   0,   255, 0,   0,   0,   255, 152, 152, 152, 255, 94,  94,  94,  255, 57,  57,  57,  255, 210, 210, 210, 255, 23,
    23,  23,  255, 0,   0,   0,   255, 1,   1,   1,   255, 6,   6,   6,   255, 42,  42,  42,  255, 210, 210, 210, 255, 8,   8,   8,   255, 166, 166,
    166, 255, 74,  74,  74,  255, 0,   0,   0,   255, 0,   0,   0,   255, 8,   8,   8,   255, 20,  20,  20,  255, 115, 115, 115, 255, 219, 219, 219,
    255, 190, 190, 190, 255, 196, 196, 196, 255, 217, 217, 217, 255, 88,  88,  88,  255, 4,   4,   4,   255, 12,  12,  12,  255, 0,   0,   0,   255,
    20,  20,  20,  255, 196, 196, 196, 255, 224, 224, 224, 255, 208, 208, 208, 255, 202, 202, 202, 255, 214, 214, 214, 255, 193, 193, 193, 255, 236,
    236, 236, 255, 119, 119, 119, 255, 0,   0,   0,   255, 15,  15,  15,  255, 91,  91,  91,  255, 181, 181, 181, 255, 220, 220, 220, 255, 193, 193,
    193, 255, 205, 205, 205, 255, 183, 183, 183, 255, 22,  22,  22,  255, 0,   0,   0,   255, 14,  14,  14,  255, 0,   0,   0,   255, 121, 121, 121,
    255, 108, 108, 108, 255, 14,  14,  14,  255, 166, 166, 166, 255, 229, 229, 229, 255, 108, 108, 108, 255, 34,  34,  34,  255, 212, 212, 212, 255,
    244, 244, 244, 255, 211, 211, 211, 255, 201, 201, 201, 255, 209, 209, 209, 255, 67,  67,  67,  255, 14,  14,  14,  255, 141, 141, 141, 255, 20,
    20,  20,  255, 0,   0,   0,   255, 101, 101, 101, 255, 79,  79,  79,  255, 14,  14,  14,  255, 49,  49,  49,  255, 72,  72,  72,  255, 30,  30,
    30,  255, 7,   7,   7,   255, 80,  80,  80,  255, 84,  84,  84,  255, 33,  33,  33,  255, 23,  23,  23,  255, 63,  63,  63,  255, 68,  68,  68,
    255, 4,   4,   4,   255, 26,  26,  26,  255, 32,  32,  32,  255, 37,  37,  37,  255, 142, 142, 142, 255, 78,  78,  78,  255, 4,   4,   4,   255,
    3,   3,   3,   255, 122, 122, 122, 255, 136, 136, 136, 255, 1,   1,   1,   255, 0,   0,   0,   255, 3,   3,   3,   255, 135, 135, 135, 255, 99,
    99,  99,  255, 10,  10,  10,  255, 0,   0,   0,   255, 11,  11,  11,  255, 27,  27,  27,  255, 0,   0,   0,   255, 23,  23,  23,  255, 0,   0,
    0,   255, 7,   7,   7,   255, 22,  22,  22,  255, 8,   8,   8,   255, 11,  11,  11,  255, 0,   0,   0,   255, 6,   6,   6,   255, 33,  33,  33,
    255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 3,   3,   3,   255, 20,  20,  20,  255, 11,  11,  11,  255, 38,  38,  38,  255,
    96,  96,  96,  255, 15,  15,  15,  255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,
    0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 6,   6,   6,   255, 0,   0,
    0,   255, 135, 135, 135, 255, 96,  96,  96,  255, 0,   0,   0,   255, 123, 123, 123, 255, 162, 162, 162, 255, 0,   0,   0,   255, 5,   5,   5,
    255, 4,   4,   4,   255, 231, 231, 231, 255, 47,  47,  47,  255, 7,   7,   7,   255, 160, 160, 160, 255, 85,  85,  85,  255, 2,   2,   2,   255,
    8,   8,   8,   255, 0,   0,   0,   255, 186, 186, 186, 255, 137, 137, 137, 255, 18,  18,  18,  255, 0,   0,   0,   255, 4,   4,   4,   255, 36,
    36,  36,  255, 193, 193, 193, 255, 120, 120, 120, 255, 0,   0,   0,   255, 7,   7,   7,   255, 8,   8,   8,   255, 4,   4,   4,   255, 0,   0,
    0,   255, 0,   0,   0,   255, 17,  17,  17,  255, 0,   0,   0,   255, 92,  92,  92,  255, 172, 172, 172, 255, 17,  17,  17,  255, 5,   5,   5,
    255, 0,   0,   0,   255, 52,  52,  52,  255, 36,  36,  36,  255, 0,   0,   0,   255, 0,   0,   0,   255, 16,  16,  16,  255, 78,  78,  78,  255,
    225, 225, 225, 255, 13,  13,  13,  255, 0,   0,   0,   255, 0,   0,   0,   255, 116, 116, 116, 255, 128, 128, 128, 255, 197, 197, 197, 255, 101,
    101, 101, 255, 10,  10,  10,  255, 11,  11,  11,  255, 0,   0,   0,   255, 1,   1,   1,   255, 205, 205, 205, 255, 29,  29,  29,  255, 0,   0,
    0,   255, 5,   5,   5,   255, 0,   0,   0,   255, 26,  26,  26,  255, 71,  71,  71,  255, 119, 119, 119, 255, 72,  72,  72,  255, 29,  29,  29,
    255, 91,  91,  91,  255, 51,  51,  51,  255, 53,  53,  53,  255, 0,   0,   0,   255, 105, 105, 105, 255, 0,   0,   0,   255, 3,   3,   3,   255,
    48,  48,  48,  255, 80,  80,  80,  255, 3,   3,   3,   255, 29,  29,  29,  255, 31,  31,  31,  255, 75,  75,  75,  255, 90,  90,  90,  255, 81,
    81,  81,  255, 5,   5,   5,   255, 77,  77,  77,  255, 8,   8,   8,   255, 0,   0,   0,   255, 0,   0,   0,   255, 111, 111, 111, 255, 33,  33,
    33,  255, 115, 115, 115, 255, 1,   1,   1,   255, 111, 111, 111, 255, 42,  42,  42,  255, 110, 110, 110, 255, 0,   0,   0,   255, 89,  89,  89,
    255, 107, 107, 107, 255, 80,  80,  80,  255, 138, 138, 138, 255, 2,   2,   2,   255, 28,  28,  28,  255, 93,  93,  93,  255, 72,  72,  72,  255,
    150, 150, 150, 255, 96,  96,  96,  255, 15,  15,  15,  255, 98,  98,  98,  255, 88,  88,  88,  255, 122, 122, 122, 255, 29,  29,  29,  255, 15,
    15,  15,  255, 126, 126, 126, 255, 117, 117, 117, 255, 60,  60,  60,  255, 80,  80,  80,  255, 144, 144, 144, 255, 87,  87,  87,  255, 0,   0,
    0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,
    255, 9,   9,   9,   255, 0,   0,   0,   255, 16,  16,  16,  255, 0,   0,   0,   255, 1,   1,   1,   255, 143, 143, 143, 255, 97,  97,  97,  255,
    0,   0,   0,   255, 1,   1,   1,   255, 200, 200, 200, 255, 84,  84,  84,  255, 0,   0,   0,   255, 149, 149, 149, 255, 124, 124, 124, 255, 0,
    0,   0,   255, 7,   7,   7,   255, 163, 163, 163, 255, 83,  83,  83,  255, 0,   0,   0,   255, 1,   1,   1,   255, 98,  98,  98,  255, 169, 169,
    169, 255, 9,   9,   9,   255, 0,   0,   0,   255, 1,   1,   1,   255, 4,   4,   4,   255, 6,   6,   6,   255, 12,  12,  12,  255, 234, 234, 234,
    255, 32,  32,  32,  255, 1,   1,   1,   255, 0,   0,   0,   255, 0,   0,   0,   255, 8,   8,   8,   255, 3,   3,   3,   255, 0,   0,   0,   255,
    47,  47,  47,  255, 204, 204, 204, 255, 35,  35,  35,  255, 0,   0,   0,   255, 6,   6,   6,   255, 0,   0,   0,   255, 2,   2,   2,   255, 6,
    6,   6,   255, 0,   0,   0,   255, 0,   0,   0,   255, 8,   8,   8,   255, 1,   1,   1,   255, 162, 162, 162, 255, 70,  70,  70,  255, 1,   1,
    1,   255, 0,   0,   0,   255, 119, 119, 119, 255, 226, 226, 226, 255, 69,  69,  69,  255, 10,  10,  10,  255, 4,   4,   4,   255, 0,   0,   0,
    255, 3,   3,   3,   255, 0,   0,   0,   255, 198, 198, 198, 255, 29,  29,  29,  255, 11,  11,  11,  255, 0,   0,   0,   255, 0,   0,   0,   255,
    31,  31,  31,  255, 48,  48,  48,  255, 29,  29,  29,  255, 73,  73,  73,  255, 0,   0,   0,   255, 85,  85,  85,  255, 93,  93,  93,  255, 6,
    6,   6,   255, 0,   0,   0,   255, 88,  88,  88,  255, 10,  10,  10,  255, 33,  33,  33,  255, 72,  72,  72,  255, 0,   0,   0,   255, 76,  76,
    76,  255, 75,  75,  75,  255, 71,  71,  71,  255, 75,  75,  75,  255, 99,  99,  99,  255, 0,   0,   0,   255, 0,   0,   0,   255, 93,  93,  93,
    255, 0,   0,   0,   255, 1,   1,   1,   255, 4,   4,   4,   255, 102, 102, 102, 255, 5,   5,   5,   255, 88,  88,  88,  255, 106, 106, 106, 255,
    68,  68,  68,  255, 16,  16,  16,  255, 95,  95,  95,  255, 22,  22,  22,  255, 109, 109, 109, 255, 0,   0,   0,   255, 4,   4,   4,   255, 25,
    25,  25,  255, 104, 104, 104, 255, 2,   2,   2,   255, 1,   1,   1,   255, 39,  39,  39,  255, 102, 102, 102, 255, 2,   2,   2,   255, 0,   0,
    0,   255, 37,  37,  37,  255, 61,  61,  61,  255, 70,  70,  70,  255, 108, 108, 108, 255, 0,   0,   0,   255, 176, 176, 176, 255, 4,   4,   4,
    255, 2,   2,   2,   255, 21,  21,  21,  255, 92,  92,  92,  255, 2,   2,   2,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255,
    0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 4,   4,   4,   255, 1,   1,   1,   255, 7,
    7,   7,   255, 0,   0,   0,   255, 3,   3,   3,   255, 140, 140, 140, 255, 92,  92,  92,  255, 1,   1,   1,   255, 6,   6,   6,   255, 30,  30,
    30,  255, 221, 221, 221, 255, 92,  92,  92,  255, 200, 200, 200, 255, 0,   0,   0,   255, 10,  10,  10,  255, 0,   0,   0,   255, 171, 171, 171,
    255, 82,  82,  82,  255, 0,   0,   0,   255, 2,   2,   2,   255, 177, 177, 177, 255, 65,  65,  65,  255, 5,   5,   5,   255, 0,   0,   0,   255,
    2,   2,   2,   255, 4,   4,   4,   255, 0,   0,   0,   255, 0,   0,   0,   255, 155, 155, 155, 255, 108, 108, 108, 255, 0,   0,   0,   255, 8,
    8,   8,   255, 0,   0,   0,   255, 15,  15,  15,  255, 0,   0,   0,   255, 17,  17,  17,  255, 219, 219, 219, 255, 51,  51,  51,  255, 0,   0,
    0,   255, 6,   6,   6,   255, 0,   0,   0,   255, 1,   1,   1,   255, 0,   0,   0,   255, 41,  41,  41,  255, 104, 104, 104, 255, 116, 116, 116,
    255, 99,  99,  99,  255, 75,  75,  75,  255, 138, 138, 138, 255, 99,  99,  99,  255, 10,  10,  10,  255, 0,   0,   0,   255, 125, 125, 125, 255,
    200, 200, 200, 255, 0,   0,   0,   255, 0,   0,   0,   255, 5,   5,   5,   255, 0,   0,   0,   255, 1,   1,   1,   255, 2,   2,   2,   255, 198,
    198, 198, 255, 34,  34,  34,  255, 0,   0,   0,   255, 5,   5,   5,   255, 0,   0,   0,   255, 17,  17,  17,  255, 65,  65,  65,  255, 0,   0,
    0,   255, 7,   7,   7,   255, 10,  10,  10,  255, 75,  75,  75,  255, 45,  45,  45,  255, 91,  91,  91,  255, 37,  37,  37,  255, 93,  93,  93,
    255, 17,  17,  17,  255, 119, 119, 119, 255, 51,  51,  51,  255, 43,  43,  43,  255, 83,  83,  83,  255, 58,  58,  58,  255, 55,  55,  55,  255,
    88,  88,  88,  255, 89,  89,  89,  255, 1,   1,   1,   255, 0,   0,   0,   255, 90,  90,  90,  255, 50,  50,  50,  255, 0,   0,   0,   255, 0,
    0,   0,   255, 114, 114, 114, 255, 0,   0,   0,   255, 9,   9,   9,   255, 92,  92,  92,  255, 0,   0,   0,   255, 18,  18,  18,  255, 105, 105,
    105, 255, 20,  20,  20,  255, 111, 111, 111, 255, 4,   4,   4,   255, 0,   0,   0,   255, 0,   0,   0,   255, 130, 130, 130, 255, 0,   0,   0,
    255, 9,   9,   9,   255, 125, 125, 125, 255, 0,   0,   0,   255, 0,   0,   0,   255, 69,  69,  69,  255, 95,  95,  95,  255, 31,  31,  31,  255,
    53,  53,  53,  255, 110, 110, 110, 255, 0,   0,   0,   255, 126, 126, 126, 255, 0,   0,   0,   255, 0,   0,   0,   255, 27,  27,  27,  255, 97,
    97,  97,  255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,
    0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,
    255, 139, 139, 139, 255, 94,  94,  94,  255, 4,   4,   4,   255, 0,   0,   0,   255, 0,   0,   0,   255, 111, 111, 111, 255, 227, 227, 227, 255,
    47,  47,  47,  255, 3,   3,   3,   255, 0,   0,   0,   255, 4,   4,   4,   255, 155, 155, 155, 255, 73,  73,  73,  255, 6,   6,   6,   255, 8,
    8,   8,   255, 216, 216, 216, 255, 42,  42,  42,  255, 0,   0,   0,   255, 10,  10,  10,  255, 0,   0,   0,   255, 18,  18,  18,  255, 0,   0,
    0,   255, 4,   4,   4,   255, 100, 100, 100, 255, 149, 149, 149, 255, 6,   6,   6,   255, 0,   0,   0,   255, 7,   7,   7,   255, 0,   0,   0,
    255, 20,  20,  20,  255, 196, 196, 196, 255, 66,  66,  66,  255, 3,   3,   3,   255, 0,   0,   0,   255, 2,   2,   2,   255, 2,   2,   2,   255,
    6,   6,   6,   255, 153, 153, 153, 255, 203, 203, 203, 255, 104, 104, 104, 255, 88,  88,  88,  255, 122, 122, 122, 255, 135, 135, 135, 255, 219,
    219, 219, 255, 96,  96,  96,  255, 0,   0,   0,   255, 14,  14,  14,  255, 103, 103, 103, 255, 136, 136, 136, 255, 0,   0,   0,   255, 10,  10,
    10,  255, 0,   0,   0,   255, 18,  18,  18,  255, 1,   1,   1,   255, 0,   0,   0,   255, 195, 195, 195, 255, 22,  22,  22,  255, 5,   5,   5,
    255, 0,   0,   0,   255, 1,   1,   1,   255, 0,   0,   0,   255, 21,  21,  21,  255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255,
    17,  17,  17,  255, 2,   2,   2,   255, 12,  12,  12,  255, 43,  43,  43,  255, 3,   3,   3,   255, 16,  16,  16,  255, 25,  25,  25,  255, 27,
    27,  27,  255, 4,   4,   4,   255, 12,  12,  12,  255, 25,  25,  25,  255, 33,  33,  33,  255, 1,   1,   1,   255, 2,   2,   2,   255, 8,   8,
    8,   255, 0,   0,   0,   255, 9,   9,   9,   255, 26,  26,  26,  255, 6,   6,   6,   255, 0,   0,   0,   255, 102, 102, 102, 255, 20,  20,  20,
    255, 0,   0,   0,   255, 6,   6,   6,   255, 0,   0,   0,   255, 18,  18,  18,  255, 103, 103, 103, 255, 0,   0,   0,   255, 123, 123, 123, 255,
    18,  18,  18,  255, 2,   2,   2,   255, 90,  90,  90,  255, 47,  47,  47,  255, 12,  12,  12,  255, 127, 127, 127, 255, 2,   2,   2,   255, 9,
    9,   9,   255, 2,   2,   2,   255, 103, 103, 103, 255, 11,  11,  11,  255, 13,  13,  13,  255, 57,  57,  57,  255, 105, 105, 105, 255, 0,   0,
    0,   255, 118, 118, 118, 255, 4,   4,   4,   255, 13,  13,  13,  255, 14,  14,  14,  255, 86,  86,  86,  255, 7,   7,   7,   255, 0,   0,   0,
    255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255,
    3,   3,   3,   255, 1,   1,   1,   255, 3,   3,   3,   255, 8,   8,   8,   255, 0,   0,   0,   255, 141, 141, 141, 255, 97,  97,  97,  255, 0,
    0,   0,   255, 3,   3,   3,   255, 3,   3,   3,   255, 1,   1,   1,   255, 71,  71,  71,  255, 11,  11,  11,  255, 0,   0,   0,   255, 0,   0,
    0,   255, 1,   1,   1,   255, 175, 175, 175, 255, 86,  86,  86,  255, 0,   0,   0,   255, 0,   0,   0,   255, 190, 190, 190, 255, 63,  63,  63,
    255, 11,  11,  11,  255, 0,   0,   0,   255, 12,  12,  12,  255, 0,   0,   0,   255, 0,   0,   0,   255, 16,  16,  16,  255, 123, 123, 123, 255,
    109, 109, 109, 255, 10,  10,  10,  255, 8,   8,   8,   255, 4,   4,   4,   255, 0,   0,   0,   255, 164, 164, 164, 255, 123, 123, 123, 255, 3,
    3,   3,   255, 13,  13,  13,  255, 0,   0,   0,   255, 1,   1,   1,   255, 11,  11,  11,  255, 88,  88,  88,  255, 166, 166, 166, 255, 12,  12,
    12,  255, 0,   0,   0,   255, 0,   0,   0,   255, 2,   2,   2,   255, 0,   0,   0,   255, 122, 122, 122, 255, 97,  97,  97,  255, 3,   3,   3,
    255, 0,   0,   0,   255, 113, 113, 113, 255, 131, 131, 131, 255, 0,   0,   0,   255, 0,   0,   0,   255, 2,   2,   2,   255, 0,   0,   0,   255,
    0,   0,   0,   255, 7,   7,   7,   255, 192, 192, 192, 255, 37,  37,  37,  255, 15,  15,  15,  255, 0,   0,   0,   255, 1,   1,   1,   255, 0,
    0,   0,   255, 0,   0,   0,   255, 5,   5,   5,   255, 3,   3,   3,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,
    0,   255, 2,   2,   2,   255, 8,   8,   8,   255, 0,   0,   0,   255, 0,   0,   0,   255, 27,  27,  27,  255, 0,   0,   0,   255, 3,   3,   3,
    255, 3,   3,   3,   255, 3,   3,   3,   255, 0,   0,   0,   255, 0,   0,   0,   255, 18,  18,  18,  255, 0,   0,   0,   255, 0,   0,   0,   255,
    4,   4,   4,   255, 0,   0,   0,   255, 0,   0,   0,   255, 65,  65,  65,  255, 0,   0,   0,   255, 4,   4,   4,   255, 0,   0,   0,   255, 26,
    26,  26,  255, 8,   8,   8,   255, 61,  61,  61,  255, 4,   4,   4,   255, 35,  35,  35,  255, 94,  94,  94,  255, 110, 110, 110, 255, 63,  63,
    63,  255, 0,   0,   0,   255, 39,  39,  39,  255, 120, 120, 120, 255, 99,  99,  99,  255, 96,  96,  96,  255, 57,  57,  57,  255, 9,   9,   9,
    255, 122, 122, 122, 255, 103, 103, 103, 255, 67,  67,  67,  255, 59,  59,  59,  255, 0,   0,   0,   255, 70,  70,  70,  255, 0,   0,   0,   255,
    0,   0,   0,   255, 1,   1,   1,   255, 101, 101, 101, 255, 107, 107, 107, 255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,
    0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,
    0,   255, 3,   3,   3,   255, 0,   0,   0,   255, 139, 139, 139, 255, 96,  96,  96,  255, 0,   0,   0,   255, 0,   0,   0,   255, 11,  11,  11,
    255, 0,   0,   0,   255, 0,   0,   0,   255, 4,   4,   4,   255, 0,   0,   0,   255, 16,  16,  16,  255, 0,   0,   0,   255, 157, 157, 157, 255,
    93,  93,  93,  255, 0,   0,   0,   255, 1,   1,   1,   255, 141, 141, 141, 255, 125, 125, 125, 255, 3,   3,   3,   255, 11,  11,  11,  255, 0,
    0,   0,   255, 4,   4,   4,   255, 5,   5,   5,   255, 5,   5,   5,   255, 200, 200, 200, 255, 68,  68,  68,  255, 0,   0,   0,   255, 0,   0,
    0,   255, 0,   0,   0,   255, 140, 140, 140, 255, 151, 151, 151, 255, 1,   1,   1,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,
    255, 8,   8,   8,   255, 0,   0,   0,   255, 138, 138, 138, 255, 124, 124, 124, 255, 0,   0,   0,   255, 4,   4,   4,   255, 0,   0,   0,   255,
    4,   4,   4,   255, 0,   0,   0,   255, 157, 157, 157, 255, 84,  84,  84,  255, 2,   2,   2,   255, 6,   6,   6,   255, 108, 108, 108, 255, 108,
    108, 108, 255, 3,   3,   3,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 15,  15,  15,  255, 191, 191,
    191, 255, 30,  30,  30,  255, 0,   0,   0,   255, 5,   5,   5,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,
    255, 0,   0,   0,   255, 4,   4,   4,   255, 0,   0,   0,   255, 0,   0,   0,   255, 9,   9,   9,   255, 6,   6,   6,   255, 45,  45,  45,  255,
    2,   2,   2,   255, 46,  46,  46,  255, 0,   0,   0,   255, 17,  17,  17,  255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 11,
    11,  11,  255, 0,   0,   0,   255, 0,   0,   0,   255, 3,   3,   3,   255, 15,  15,  15,  255, 20,  20,  20,  255, 8,   8,   8,   255, 2,   2,
    2,   255, 0,   0,   0,   255, 0,   0,   0,   255, 12,  12,  12,  255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,
    255, 10,  10,  10,  255, 0,   0,   0,   255, 0,   0,   0,   255, 7,   7,   7,   255, 3,   3,   3,   255, 1,   1,   1,   255, 3,   3,   3,   255,
    0,   0,   0,   255, 0,   0,   0,   255, 8,   8,   8,   255, 7,   7,   7,   255, 0,   0,   0,   255, 0,   0,   0,   255, 4,   4,   4,   255, 0,
    0,   0,   255, 4,   4,   4,   255, 0,   0,   0,   255, 5,   5,   5,   255, 8,   8,   8,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,
    0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,
    255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 3,   3,   3,   255, 3,   3,   3,   255,
    143, 143, 143, 255, 107, 107, 107, 255, 1,   1,   1,   255, 0,   0,   0,   255, 5,   5,   5,   255, 0,   0,   0,   255, 22,  22,  22,  255, 0,
    0,   0,   255, 7,   7,   7,   255, 2,   2,   2,   255, 0,   0,   0,   255, 169, 169, 169, 255, 85,  85,  85,  255, 10,  10,  10,  255, 4,   4,
    4,   255, 13,  13,  13,  255, 223, 223, 223, 255, 83,  83,  83,  255, 0,   0,   0,   255, 1,   1,   1,   255, 5,   5,   5,   255, 0,   0,   0,
    255, 123, 123, 123, 255, 168, 168, 168, 255, 12,  12,  12,  255, 2,   2,   2,   255, 5,   5,   5,   255, 95,  95,  95,  255, 180, 180, 180, 255,
    13,  13,  13,  255, 4,   4,   4,   255, 0,   0,   0,   255, 0,   0,   0,   255, 7,   7,   7,   255, 0,   0,   0,   255, 1,   1,   1,   255, 84,
    84,  84,  255, 195, 195, 195, 255, 0,   0,   0,   255, 3,   3,   3,   255, 2,   2,   2,   255, 0,   0,   0,   255, 64,  64,  64,  255, 234, 234,
    234, 255, 113, 113, 113, 255, 0,   0,   0,   255, 0,   0,   0,   255, 125, 125, 125, 255, 115, 115, 115, 255, 0,   0,   0,   255, 7,   7,   7,
    255, 0,   0,   0,   255, 20,  20,  20,  255, 0,   0,   0,   255, 0,   0,   0,   255, 196, 196, 196, 255, 61,  61,  61,  255, 10,  10,  10,  255,
    5,   5,   5,   255, 12,  12,  12,  255, 6,   6,   6,   255, 0,   0,   0,   255, 0,   0,   0,   255, 2,   2,   2,   255, 0,   0,   0,   255, 0,
    0,   0,   255, 2,   2,   2,   255, 0,   0,   0,   255, 0,   0,   0,   255, 68,  68,  68,  255, 59,  59,  59,  255, 86,  86,  86,  255, 58,  58,
    58,  255, 62,  62,  62,  255, 64,  64,  64,  255, 34,  34,  34,  255, 75,  75,  75,  255, 33,  33,  33,  255, 62,  62,  62,  255, 41,  41,  41,
    255, 100, 100, 100, 255, 33,  33,  33,  255, 89,  89,  89,  255, 1,   1,   1,   255, 24,  24,  24,  255, 27,  27,  27,  255, 4,   4,   4,   255,
    58,  58,  58,  255, 0,   0,   0,   255, 2,   2,   2,   255, 5,   5,   5,   255, 9,   9,   9,   255, 0,   0,   0,   255, 3,   3,   3,   255, 13,
    13,  13,  255, 0,   0,   0,   255, 0,   0,   0,   255, 11,  11,  11,  255, 24,  24,  24,  255, 0,   0,   0,   255, 25,  25,  25,  255, 0,   0,
    0,   255, 3,   3,   3,   255, 15,  15,  15,  255, 0,   0,   0,   255, 0,   0,   0,   255, 1,   1,   1,   255, 3,   3,   3,   255, 3,   3,   3,
    255, 0,   0,   0,   255, 3,   3,   3,   255, 0,   0,   0,   255, 12,  12,  12,  255, 0,   0,   0,   255, 1,   1,   1,   255, 0,   0,   0,   255,
    0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 2,
    2,   2,   255, 5,   5,   5,   255, 0,   0,   0,   255, 7,   7,   7,   255, 11,  11,  11,  255, 114, 114, 114, 255, 89,  89,  89,  255, 9,   9,
    9,   255, 7,   7,   7,   255, 1,   1,   1,   255, 0,   0,   0,   255, 0,   0,   0,   255, 2,   2,   2,   255, 0,   0,   0,   255, 0,   0,   0,
    255, 3,   3,   3,   255, 164, 164, 164, 255, 61,  61,  61,  255, 5,   5,   5,   255, 0,   0,   0,   255, 0,   0,   0,   255, 35,  35,  35,  255,
    210, 210, 210, 255, 170, 170, 170, 255, 114, 114, 114, 255, 108, 108, 108, 255, 198, 198, 198, 255, 166, 166, 166, 255, 0,   0,   0,   255, 4,
    4,   4,   255, 0,   0,   0,   255, 49,  49,  49,  255, 249, 249, 249, 255, 180, 180, 180, 255, 133, 133, 133, 255, 140, 140, 140, 255, 156, 156,
    156, 255, 160, 160, 160, 255, 145, 145, 145, 255, 93,  93,  93,  255, 0,   0,   0,   255, 10,  10,  10,  255, 149, 149, 149, 255, 203, 203, 203,
    255, 128, 128, 128, 255, 98,  98,  98,  255, 159, 159, 159, 255, 178, 178, 178, 255, 131, 131, 131, 255, 98,  98,  98,  255, 7,   7,   7,   255,
    0,   0,   0,   255, 114, 114, 114, 255, 118, 118, 118, 255, 0,   0,   0,   255, 3,   3,   3,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,
    0,   0,   255, 13,  13,  13,  255, 78,  78,  78,  255, 222, 222, 222, 255, 113, 113, 113, 255, 139, 139, 139, 255, 37,  37,  37,  255, 4,   4,
    4,   255, 0,   0,   0,   255, 0,   0,   0,   255, 13,  13,  13,  255, 0,   0,   0,   255, 0,   0,   0,   255, 5,   5,   5,   255, 2,   2,   2,
    255, 0,   0,   0,   255, 62,  62,  62,  255, 35,  35,  35,  255, 28,  28,  28,  255, 63,  63,  63,  255, 17,  17,  17,  255, 55,  55,  55,  255,
    24,  24,  24,  255, 48,  48,  48,  255, 47,  47,  47,  255, 39,  39,  39,  255, 81,  81,  81,  255, 51,  51,  51,  255, 4,   4,   4,   255, 50,
    50,  50,  255, 0,   0,   0,   255, 58,  58,  58,  255, 79,  79,  79,  255, 27,  27,  27,  255, 93,  93,  93,  255, 44,  44,  44,  255, 44,  44,
    44,  255, 45,  45,  45,  255, 42,  42,  42,  255, 76,  76,  76,  255, 21,  21,  21,  255, 46,  46,  46,  255, 55,  55,  55,  255, 48,  48,  48,
    255, 56,  56,  56,  255, 89,  89,  89,  255, 20,  20,  20,  255, 9,   9,   9,   255, 0,   0,   0,   255, 0,   0,   0,   255, 1,   1,   1,   255,
    0,   0,   0,   255, 5,   5,   5,   255, 2,   2,   2,   255, 0,   0,   0,   255, 8,   8,   8,   255, 10,  10,  10,  255, 2,   2,   2,   255, 0,
    0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 1,   1,   1,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,
    0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,
    255, 1,   1,   1,   255, 0,   0,   0,   255, 42,  42,  42,  255, 30,  30,  30,  255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255,
    20,  20,  20,  255, 5,   5,   5,   255, 0,   0,   0,   255, 0,   0,   0,   255, 7,   7,   7,   255, 0,   0,   0,   255, 38,  38,  38,  255, 26,
    26,  26,  255, 7,   7,   7,   255, 2,   2,   2,   255, 0,   0,   0,   255, 14,  14,  14,  255, 0,   0,   0,   255, 72,  72,  72,  255, 107, 107,
    107, 255, 103, 103, 103, 255, 29,  29,  29,  255, 18,  18,  18,  255, 8,   8,   8,   255, 0,   0,   0,   255, 0,   0,   0,   255, 19,  19,  19,
    255, 55,  55,  55,  255, 45,  45,  45,  255, 67,  67,  67,  255, 65,  65,  65,  255, 50,  50,  50,  255, 55,  55,  55,  255, 61,  61,  61,  255,
    26,  26,  26,  255, 12,  12,  12,  255, 0,   0,   0,   255, 6,   6,   6,   255, 43,  43,  43,  255, 111, 111, 111, 255, 103, 103, 103, 255, 68,
    68,  68,  255, 0,   0,   0,   255, 42,  42,  42,  255, 18,  18,  18,  255, 0,   0,   0,   255, 9,   9,   9,   255, 31,  31,  31,  255, 31,  31,
    31,  255, 1,   1,   1,   255, 0,   0,   0,   255, 0,   0,   0,   255, 7,   7,   7,   255, 10,  10,  10,  255, 0,   0,   0,   255, 0,   0,   0,
    255, 35,  35,  35,  255, 107, 107, 107, 255, 72,  72,  72,  255, 20,  20,  20,  255, 0,   0,   0,   255, 0,   0,   0,   255, 2,   2,   2,   255,
    2,   2,   2,   255, 0,   0,   0,   255, 1,   1,   1,   255, 0,   0,   0,   255, 0,   0,   0,   255, 12,  12,  12,  255, 13,  13,  13,  255, 2,
    2,   2,   255, 14,  14,  14,  255, 16,  16,  16,  255, 36,  36,  36,  255, 41,  41,  41,  255, 33,  33,  33,  255, 49,  49,  49,  255, 18,  18,
    18,  255, 58,  58,  58,  255, 10,  10,  10,  255, 33,  33,  33,  255, 0,   0,   0,   255, 43,  43,  43,  255, 7,   7,   7,   255, 60,  60,  60,
    255, 19,  19,  19,  255, 62,  62,  62,  255, 62,  62,  62,  255, 57,  57,  57,  255, 18,  18,  18,  255, 61,  61,  61,  255, 16,  16,  16,  255,
    59,  59,  59,  255, 31,  31,  31,  255, 50,  50,  50,  255, 91,  91,  91,  255, 70,  70,  70,  255, 0,   0,   0,   255, 62,  62,  62,  255, 10,
    10,  10,  255, 0,   0,   0,   255, 7,   7,   7,   255, 12,  12,  12,  255, 6,   6,   6,   255, 5,   5,   5,   255, 0,   0,   0,   255, 0,   0,
    0,   255, 1,   1,   1,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 7,   7,   7,   255, 5,   5,   5,   255, 7,   7,   7,
    255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255,
    0,   0,   0,   255, 0,   0,   0,   255, 3,   3,   3,   255, 0,   0,   0,   255, 5,   5,   5,   255, 8,   8,   8,   255, 0,   0,   0,   255, 0,
    0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 2,   2,   2,   255, 0,   0,   0,   255, 0,   0,   0,   255, 2,   2,   2,   255, 0,   0,
    0,   255, 3,   3,   3,   255, 0,   0,   0,   255, 0,   0,   0,   255, 2,   2,   2,   255, 0,   0,   0,   255, 0,   0,   0,   255, 14,  14,  14,
    255, 1,   1,   1,   255, 3,   3,   3,   255, 0,   0,   0,   255, 0,   0,   0,   255, 14,  14,  14,  255, 0,   0,   0,   255, 6,   6,   6,   255,
    0,   0,   0,   255, 1,   1,   1,   255, 0,   0,   0,   255, 0,   0,   0,   255, 2,   2,   2,   255, 5,   5,   5,   255, 2,   2,   2,   255, 0,
    0,   0,   255, 4,   4,   4,   255, 0,   0,   0,   255, 5,   5,   5,   255, 0,   0,   0,   255, 3,   3,   3,   255, 0,   0,   0,   255, 3,   3,
    3,   255, 4,   4,   4,   255, 0,   0,   0,   255, 0,   0,   0,   255, 6,   6,   6,   255, 0,   0,   0,   255, 9,   9,   9,   255, 0,   0,   0,
    255, 13,  13,  13,  255, 0,   0,   0,   255, 4,   4,   4,   255, 2,   2,   2,   255, 0,   0,   0,   255, 0,   0,   0,   255, 5,   5,   5,   255,
    1,   1,   1,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 10,  10,  10,  255, 0,   0,   0,   255, 35,
    35,  35,  255, 1,   1,   1,   255, 7,   7,   7,   255, 21,  21,  21,  255, 16,  16,  16,  255, 0,   0,   0,   255, 1,   1,   1,   255, 11,  11,
    11,  255, 0,   0,   0,   255, 3,   3,   3,   255, 0,   0,   0,   255, 4,   4,   4,   255, 0,   0,   0,   255, 3,   3,   3,   255, 0,   0,   0,
    255, 0,   0,   0,   255, 11,  11,  11,  255, 0,   0,   0,   255, 0,   0,   0,   255, 8,   8,   8,   255, 0,   0,   0,   255, 7,   7,   7,   255,
    0,   0,   0,   255, 3,   3,   3,   255, 1,   1,   1,   255, 0,   0,   0,   255, 32,  32,  32,  255, 9,   9,   9,   255, 2,   2,   2,   255, 46,
    46,  46,  255, 28,  28,  28,  255, 50,  50,  50,  255, 49,  49,  49,  255, 69,  69,  69,  255, 49,  49,  49,  255, 40,  40,  40,  255, 60,  60,
    60,  255, 67,  67,  67,  255, 32,  32,  32,  255, 5,   5,   5,   255, 45,  45,  45,  255, 23,  23,  23,  255, 8,   8,   8,   255, 0,   0,   0,
    255, 3,   3,   3,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 4,   4,   4,   255, 1,   1,   1,   255, 0,   0,   0,   255,
    2,   2,   2,   255, 9,   9,   9,   255, 0,   0,   0,   255, 2,   2,   2,   255, 0,   0,   0,   255, 2,   2,   2,   255, 0,   0,   0,   255, 0,
    0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,
    0,   255, 0,   0,   0,   255, 7,   7,   7,   255, 9,   9,   9,   255, 0,   0,   0,   255, 61,  61,  61,  255, 0,   0,   0,   255, 42,  42,  42,
    255, 23,  23,  23,  255, 0,   0,   0,   255, 0,   0,   0,   255, 4,   4,   4,   255, 0,   0,   0,   255, 10,  10,  10,  255, 0,   0,   0,   255,
    3,   3,   3,   255, 5,   5,   5,   255, 4,   4,   4,   255, 18,  18,  18,  255, 76,  76,  76,  255, 101, 101, 101, 255, 0,   0,   0,   255, 12,
    12,  12,  255, 40,  40,  40,  255, 147, 147, 147, 255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 8,   8,   8,   255, 4,   4,
    4,   255, 0,   0,   0,   255, 4,   4,   4,   255, 10,  10,  10,  255, 0,   0,   0,   255, 8,   8,   8,   255, 4,   4,   4,   255, 0,   0,   0,
    255, 1,   1,   1,   255, 0,   0,   0,   255, 2,   2,   2,   255, 3,   3,   3,   255, 0,   0,   0,   255, 85,  85,  85,  255, 4,   4,   4,   255,
    0,   0,   0,   255, 0,   0,   0,   255, 7,   7,   7,   255, 13,  13,  13,  255, 20,  20,  20,  255, 0,   0,   0,   255, 0,   0,   0,   255, 4,
    4,   4,   255, 5,   5,   5,   255, 0,   0,   0,   255, 2,   2,   2,   255, 0,   0,   0,   255, 0,   0,   0,   255, 12,  12,  12,  255, 0,   0,
    0,   255, 0,   0,   0,   255, 6,   6,   6,   255, 21,  21,  21,  255, 3,   3,   3,   255, 73,  73,  73,  255, 68,  68,  68,  255, 5,   5,   5,
    255, 121, 121, 121, 255, 25,  25,  25,  255, 39,  39,  39,  255, 65,  65,  65,  255, 6,   6,   6,   255, 40,  40,  40,  255, 64,  64,  64,  255,
    44,  44,  44,  255, 32,  32,  32,  255, 55,  55,  55,  255, 13,  13,  13,  255, 22,  22,  22,  255, 48,  48,  48,  255, 95,  95,  95,  255, 44,
    44,  44,  255, 12,  12,  12,  255, 0,   0,   0,   255, 0,   0,   0,   255, 11,  11,  11,  255, 0,   0,   0,   255, 0,   0,   0,   255, 4,   4,
    4,   255, 0,   0,   0,   255, 7,   7,   7,   255, 6,   6,   6,   255, 0,   0,   0,   255, 4,   4,   4,   255, 5,   5,   5,   255, 0,   0,   0,
    255, 5,   5,   5,   255, 0,   0,   0,   255, 0,   0,   0,   255, 2,   2,   2,   255, 4,   4,   4,   255, 1,   1,   1,   255, 0,   0,   0,   255,
    3,   3,   3,   255, 0,   0,   0,   255, 0,   0,   0,   255, 2,   2,   2,   255, 0,   0,   0,   255, 5,   5,   5,   255, 0,   0,   0,   255, 3,
    3,   3,   255, 0,   0,   0,   255, 4,   4,   4,   255, 0,   0,   0,   255, 9,   9,   9,   255, 0,   0,   0,   255, 4,   4,   4,   255, 0,   0,
    0,   255, 1,   1,   1,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 2,   2,   2,   255, 0,   0,   0,
    255, 1,   1,   1,   255, 5,   5,   5,   255, 0,   0,   0,   255, 2,   2,   2,   255, 7,   7,   7,   255, 2,   2,   2,   255, 0,   0,   0,   255,
    7,   7,   7,   255, 0,   0,   0,   255, 70,  70,  70,  255, 70,  70,  70,  255, 61,  61,  61,  255, 56,  56,  56,  255, 83,  83,  83,  255, 62,
    62,  62,  255, 35,  35,  35,  255, 90,  90,  90,  255, 20,  20,  20,  255, 77,  77,  77,  255, 46,  46,  46,  255, 80,  80,  80,  255, 49,  49,
    49,  255, 88,  88,  88,  255, 71,  71,  71,  255, 101, 101, 101, 255, 52,  52,  52,  255, 0,   0,   0,   255, 109, 109, 109, 255, 95,  95,  95,
    255, 1,   1,   1,   255, 65,  65,  65,  255, 94,  94,  94,  255, 85,  85,  85,  255, 16,  16,  16,  255, 29,  29,  29,  255, 85,  85,  85,  255,
    84,  84,  84,  255, 132, 132, 132, 255, 0,   0,   0,   255, 71,  71,  71,  255, 86,  86,  86,  255, 84,  84,  84,  255, 12,  12,  12,  255, 58,
    58,  58,  255, 81,  81,  81,  255, 56,  56,  56,  255, 145, 145, 145, 255, 86,  86,  86,  255, 33,  33,  33,  255, 3,   3,   3,   255, 9,   9,
    9,   255, 149, 149, 149, 255, 209, 209, 209, 255, 14,  14,  14,  255, 0,   0,   0,   255, 1,   1,   1,   255, 0,   0,   0,   255, 24,  24,  24,
    255, 0,   0,   0,   255, 7,   7,   7,   255, 0,   0,   0,   255, 6,   6,   6,   255, 5,   5,   5,   255, 7,   7,   7,   255, 77,  77,  77,  255,
    255, 255, 255, 255, 37,  37,  37,  255, 79,  79,  79,  255, 37,  37,  37,  255, 110, 110, 110, 255, 52,  52,  52,  255, 28,  28,  28,  255, 62,
    62,  62,  255, 11,  11,  11,  255, 79,  79,  79,  255, 0,   0,   0,   255, 37,  37,  37,  255, 28,  28,  28,  255, 48,  48,  48,  255, 68,  68,
    68,  255, 70,  70,  70,  255, 108, 108, 108, 255, 14,  14,  14,  255, 69,  69,  69,  255, 0,   0,   0,   255, 0,   0,   0,   255, 10,  10,  10,
    255, 63,  63,  63,  255, 27,  27,  27,  255, 51,  51,  51,  255, 30,  30,  30,  255, 14,  14,  14,  255, 44,  44,  44,  255, 16,  16,  16,  255,
    13,  13,  13,  255, 34,  34,  34,  255, 39,  39,  39,  255, 0,   0,   0,   255, 13,  13,  13,  255, 1,   1,   1,   255, 0,   0,   0,   255, 0,
    0,   0,   255, 12,  12,  12,  255, 0,   0,   0,   255, 0,   0,   0,   255, 2,   2,   2,   255, 0,   0,   0,   255, 2,   2,   2,   255, 2,   2,
    2,   255, 11,  11,  11,  255, 18,  18,  18,  255, 2,   2,   2,   255, 0,   0,   0,   255, 2,   2,   2,   255, 0,   0,   0,   255, 2,   2,   2,
    255, 0,   0,   0,   255, 0,   0,   0,   255, 4,   4,   4,   255, 11,  11,  11,  255, 111, 111, 111, 255, 3,   3,   3,   255, 7,   7,   7,   255,
    0,   0,   0,   255, 7,   7,   7,   255, 5,   5,   5,   255, 1,   1,   1,   255, 2,   2,   2,   255, 0,   0,   0,   255, 0,   0,   0,   255, 9,
    9,   9,   255, 0,   0,   0,   255, 0,   0,   0,   255, 3,   3,   3,   255, 0,   0,   0,   255, 11,  11,  11,  255, 0,   0,   0,   255, 46,  46,
    46,  255, 42,  42,  42,  255, 12,  12,  12,  255, 61,  61,  61,  255, 33,  33,  33,  255, 59,  59,  59,  255, 30,  30,  30,  255, 40,  40,  40,
    255, 59,  59,  59,  255, 47,  47,  47,  255, 61,  61,  61,  255, 58,  58,  58,  255, 1,   1,   1,   255, 56,  56,  56,  255, 56,  56,  56,  255,
    28,  28,  28,  255, 95,  95,  95,  255, 101, 101, 101, 255, 17,  17,  17,  255, 104, 104, 104, 255, 14,  14,  14,  255, 91,  91,  91,  255, 0,
    0,   0,   255, 22,  22,  22,  255, 89,  89,  89,  255, 11,  11,  11,  255, 0,   0,   0,   255, 68,  68,  68,  255, 43,  43,  43,  255, 5,   5,
    5,   255, 12,  12,  12,  255, 72,  72,  72,  255, 110, 110, 110, 255, 3,   3,   3,   255, 130, 130, 130, 255, 17,  17,  17,  255, 11,  11,  11,
    255, 88,  88,  88,  255, 1,   1,   1,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 164, 164, 164, 255, 255, 255, 255, 255,
    148, 148, 148, 255, 0,   0,   0,   255, 1,   1,   1,   255, 9,   9,   9,   255, 0,   0,   0,   255, 6,   6,   6,   255, 0,   0,   0,   255, 4,
    4,   4,   255, 0,   0,   0,   255, 0,   0,   0,   255, 32,  32,  32,  255, 238, 238, 238, 255, 249, 249, 249, 255, 66,  66,  66,  255, 57,  57,
    57,  255, 10,  10,  10,  255, 3,   3,   3,   255, 49,  49,  49,  255, 27,  27,  27,  255, 85,  85,  85,  255, 0,   0,   0,   255, 73,  73,  73,
    255, 51,  51,  51,  255, 61,  61,  61,  255, 0,   0,   0,   255, 74,  74,  74,  255, 10,  10,  10,  255, 93,  93,  93,  255, 58,  58,  58,  255,
    0,   0,   0,   255, 79,  79,  79,  255, 12,  12,  12,  255, 16,  16,  16,  255, 6,   6,   6,   255, 54,  54,  54,  255, 51,  51,  51,  255, 76,
    76,  76,  255, 24,  24,  24,  255, 46,  46,  46,  255, 53,  53,  53,  255, 52,  52,  52,  255, 63,  63,  63,  255, 65,  65,  65,  255, 65,  65,
    65,  255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 8,   8,   8,   255, 8,   8,   8,   255, 0,   0,   0,   255, 10,  10,  10,
    255, 11,  11,  11,  255, 0,   0,   0,   255, 0,   0,   0,   255, 5,   5,   5,   255, 1,   1,   1,   255, 85,  85,  85,  255, 84,  84,  84,  255,
    40,  40,  40,  255, 52,  52,  52,  255, 27,  27,  27,  255, 57,  57,  57,  255, 46,  46,  46,  255, 39,  39,  39,  255, 53,  53,  53,  255, 76,
    76,  76,  255, 52,  52,  52,  255, 249, 249, 249, 255, 2,   2,   2,   255, 0,   0,   0,   255, 10,  10,  10,  255, 0,   0,   0,   255, 7,   7,
    7,   255, 0,   0,   0,   255, 0,   0,   0,   255, 2,   2,   2,   255, 0,   0,   0,   255, 8,   8,   8,   255, 0,   0,   0,   255, 0,   0,   0,
    255, 2,   2,   2,   255, 2,   2,   2,   255, 0,   0,   0,   255, 2,   2,   2,   255, 18,  18,  18,  255, 0,   0,   0,   255, 8,   8,   8,   255,
    15,  15,  15,  255, 45,  45,  45,  255, 15,  15,  15,  255, 38,  38,  38,  255, 61,  61,  61,  255, 11,  11,  11,  255, 46,  46,  46,  255, 31,
    31,  31,  255, 7,   7,   7,   255, 8,   8,   8,   255, 28,  28,  28,  255, 91,  91,  91,  255, 27,  27,  27,  255, 17,  17,  17,  255, 72,  72,
    72,  255, 0,   0,   0,   255, 107, 107, 107, 255, 37,  37,  37,  255, 69,  69,  69,  255, 11,  11,  11,  255, 1,   1,   1,   255, 109, 109, 109,
    255, 2,   2,   2,   255, 35,  35,  35,  255, 75,  75,  75,  255, 0,   0,   0,   255, 32,  32,  32,  255, 111, 111, 111, 255, 11,  11,  11,  255,
    111, 111, 111, 255, 22,  22,  22,  255, 88,  88,  88,  255, 7,   7,   7,   255, 0,   0,   0,   255, 78,  78,  78,  255, 5,   5,   5,   255, 7,
    7,   7,   255, 1,   1,   1,   255, 1,   1,   1,   255, 158, 158, 158, 255, 162, 162, 162, 255, 247, 247, 247, 255, 74,  74,  74,  255, 0,   0,
    0,   255, 7,   7,   7,   255, 0,   0,   0,   255, 5,   5,   5,   255, 0,   0,   0,   255, 3,   3,   3,   255, 3,   3,   3,   255, 5,   5,   5,
    255, 169, 169, 169, 255, 171, 171, 171, 255, 244, 244, 244, 255, 31,  31,  31,  255, 34,  34,  34,  255, 4,   4,   4,   255, 10,  10,  10,  255,
    11,  11,  11,  255, 12,  12,  12,  255, 41,  41,  41,  255, 68,  68,  68,  255, 18,  18,  18,  255, 45,  45,  45,  255, 46,  46,  46,  255, 42,
    42,  42,  255, 26,  26,  26,  255, 88,  88,  88,  255, 8,   8,   8,   255, 13,  13,  13,  255, 19,  19,  19,  255, 11,  11,  11,  255, 36,  36,
    36,  255, 3,   3,   3,   255, 0,   0,   0,   255, 19,  19,  19,  255, 9,   9,   9,   255, 18,  18,  18,  255, 40,  40,  40,  255, 40,  40,  40,
    255, 37,  37,  37,  255, 35,  35,  35,  255, 28,  28,  28,  255, 15,  15,  15,  255, 34,  34,  34,  255, 4,   4,   4,   255, 0,   0,   0,   255,
    15,  15,  15,  255, 0,   0,   0,   255, 0,   0,   0,   255, 9,   9,   9,   255, 0,   0,   0,   255, 1,   1,   1,   255, 0,   0,   0,   255, 9,
    9,   9,   255, 0,   0,   0,   255, 1,   1,   1,   255, 54,  54,  54,  255, 41,  41,  41,  255, 52,  52,  52,  255, 47,  47,  47,  255, 63,  63,
    63,  255, 33,  33,  33,  255, 88,  88,  88,  255, 76,  76,  76,  255, 31,  31,  31,  255, 38,  38,  38,  255, 32,  32,  32,  255, 240, 240, 240,
    255, 0,   0,   0,   255, 8,   8,   8,   255, 0,   0,   0,   255, 0,   0,   0,   255, 12,  12,  12,  255, 0,   0,   0,   255, 0,   0,   0,   255,
    13,  13,  13,  255, 0,   0,   0,   255, 0,   0,   0,   255, 9,   9,   9,   255, 0,   0,   0,   255, 1,   1,   1,   255, 2,   2,   2,   255, 0,
    0,   0,   255, 3,   3,   3,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 4,   4,   4,   255, 0,   0,   0,   255, 10,  10,
    10,  255, 5,   5,   5,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 10,  10,  10,  255, 2,   2,   2,
    255, 0,   0,   0,   255, 60,  60,  60,  255, 31,  31,  31,  255, 0,   0,   0,   255, 0,   0,   0,   255, 7,   7,   7,   255, 104, 104, 104, 255,
    0,   0,   0,   255, 119, 119, 119, 255, 49,  49,  49,  255, 75,  75,  75,  255, 60,  60,  60,  255, 19,  19,  19,  255, 144, 144, 144, 255, 50,
    50,  50,  255, 54,  54,  54,  255, 28,  28,  28,  255, 109, 109, 109, 255, 55,  55,  55,  255, 140, 140, 140, 255, 12,  12,  12,  255, 100, 100,
    100, 255, 0,   0,   0,   255, 3,   3,   3,   255, 81,  81,  81,  255, 57,  57,  57,  255, 18,  18,  18,  255, 0,   0,   0,   255, 1,   1,   1,
    255, 152, 152, 152, 255, 132, 132, 132, 255, 126, 126, 126, 255, 217, 217, 217, 255, 16,  16,  16,  255, 0,   0,   0,   255, 3,   3,   3,   255,
    0,   0,   0,   255, 6,   6,   6,   255, 0,   0,   0,   255, 6,   6,   6,   255, 94,  94,  94,  255, 224, 224, 224, 255, 46,  46,  46,  255, 241,
    241, 241, 255, 47,  47,  47,  255, 3,   3,   3,   255, 0,   0,   0,   255, 0,   0,   0,   255, 3,   3,   3,   255, 1,   1,   1,   255, 0,   0,
    0,   255, 15,  15,  15,  255, 0,   0,   0,   255, 28,  28,  28,  255, 33,  33,  33,  255, 1,   1,   1,   255, 3,   3,   3,   255, 0,   0,   0,
    255, 0,   0,   0,   255, 11,  11,  11,  255, 3,   3,   3,   255, 2,   2,   2,   255, 6,   6,   6,   255, 7,   7,   7,   255, 0,   0,   0,   255,
    1,   1,   1,   255, 8,   8,   8,   255, 0,   0,   0,   255, 17,  17,  17,  255, 0,   0,   0,   255, 0,   0,   0,   255, 18,  18,  18,  255, 8,
    8,   8,   255, 7,   7,   7,   255, 0,   0,   0,   255, 0,   0,   0,   255, 11,  11,  11,  255, 0,   0,   0,   255, 16,  16,  16,  255, 0,   0,
    0,   255, 17,  17,  17,  255, 6,   6,   6,   255, 0,   0,   0,   255, 15,  15,  15,  255, 1,   1,   1,   255, 0,   0,   0,   255, 0,   0,   0,
    255, 0,   0,   0,   255, 1,   1,   1,   255, 1,   1,   1,   255, 0,   0,   0,   255, 5,   5,   5,   255, 14,  14,  14,  255, 0,   0,   0,   255,
    0,   0,   0,   255, 9,   9,   9,   255, 10,  10,  10,  255, 45,  45,  45,  255, 242, 242, 242, 255, 16,  16,  16,  255, 0,   0,   0,   255, 2,
    2,   2,   255, 0,   0,   0,   255, 0,   0,   0,   255, 16,  16,  16,  255, 0,   0,   0,   255, 0,   0,   0,   255, 8,   8,   8,   255, 0,   0,
    0,   255, 1,   1,   1,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 7,   7,   7,   255, 1,   1,   1,   255, 0,   0,   0,
    255, 84,  84,  84,  255, 7,   7,   7,   255, 4,   4,   4,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 26,  26,  26,  255,
    71,  71,  71,  255, 9,   9,   9,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 2,   2,   2,   255, 24,  24,  24,  255, 0,
    0,   0,   255, 4,   4,   4,   255, 14,  14,  14,  255, 0,   0,   0,   255, 21,  21,  21,  255, 6,   6,   6,   255, 0,   0,   0,   255, 34,  34,
    34,  255, 24,  24,  24,  255, 11,  11,  11,  255, 8,   8,   8,   255, 34,  34,  34,  255, 27,  27,  27,  255, 48,  48,  48,  255, 0,   0,   0,
    255, 19,  19,  19,  255, 40,  40,  40,  255, 5,   5,   5,   255, 14,  14,  14,  255, 9,   9,   9,   255, 30,  30,  30,  255, 0,   0,   0,   255,
    15,  15,  15,  255, 38,  38,  38,  255, 0,   0,   0,   255, 9,   9,   9,   255, 7,   7,   7,   255, 157, 157, 157, 255, 139, 139, 139, 255, 0,
    0,   0,   255, 192, 192, 192, 255, 160, 160, 160, 255, 0,   0,   0,   255, 0,   0,   0,   255, 2,   2,   2,   255, 0,   0,   0,   255, 0,   0,
    0,   255, 28,  28,  28,  255, 226, 226, 226, 255, 80,  80,  80,  255, 11,  11,  11,  255, 242, 242, 242, 255, 46,  46,  46,  255, 0,   0,   0,
    255, 5,   5,   5,   255, 11,  11,  11,  255, 0,   0,   0,   255, 0,   0,   0,   255, 56,  56,  56,  255, 178, 178, 178, 255, 224, 224, 224, 255,
    255, 255, 255, 255, 240, 240, 240, 255, 201, 201, 201, 255, 117, 117, 117, 255, 1,   1,   1,   255, 0,   0,   0,   255, 7,   7,   7,   255, 0,
    0,   0,   255, 3,   3,   3,   255, 101, 101, 101, 255, 210, 210, 210, 255, 213, 213, 213, 255, 215, 215, 215, 255, 217, 217, 217, 255, 200, 200,
    200, 255, 204, 204, 204, 255, 224, 224, 224, 255, 223, 223, 223, 255, 196, 196, 196, 255, 12,  12,  12,  255, 0,   0,   0,   255, 14,  14,  14,
    255, 32,  32,  32,  255, 115, 115, 115, 255, 206, 206, 206, 255, 233, 233, 233, 255, 255, 255, 255, 255, 233, 233, 233, 255, 172, 172, 172, 255,
    74,  74,  74,  255, 2,   2,   2,   255, 4,   4,   4,   255, 0,   0,   0,   255, 4,   4,   4,   255, 3,   3,   3,   255, 164, 164, 164, 255, 86,
    86,  86,  255, 3,   3,   3,   255, 41,  41,  41,  255, 178, 178, 178, 255, 234, 234, 234, 255, 123, 123, 123, 255, 0,   0,   0,   255, 180, 180,
    180, 255, 215, 215, 215, 255, 250, 250, 250, 255, 202, 202, 202, 255, 211, 211, 211, 255, 209, 209, 209, 255, 206, 206, 206, 255, 8,   8,   8,
    255, 0,   0,   0,   255, 10,  10,  10,  255, 7,   7,   7,   255, 6,   6,   6,   255, 0,   0,   0,   255, 7,   7,   7,   255, 7,   7,   7,   255,
    0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 12,  12,  12,  255, 171, 171, 171, 255, 110, 110, 110, 255, 0,
    0,   0,   255, 25,  25,  25,  255, 0,   0,   0,   255, 2,   2,   2,   255, 158, 158, 158, 255, 140, 140, 140, 255, 0,   0,   0,   255, 6,   6,
    6,   255, 2,   2,   2,   255, 12,  12,  12,  255, 0,   0,   0,   255, 0,   0,   0,   255, 2,   2,   2,   255, 8,   8,   8,   255, 0,   0,   0,
    255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 1,   1,   1,   255, 10,  10,  10,  255, 0,   0,   0,   255, 3,   3,   3,   255,
    0,   0,   0,   255, 0,   0,   0,   255, 2,   2,   2,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 11,  11,  11,  255, 10,
    10,  10,  255, 0,   0,   0,   255, 1,   1,   1,   255, 144, 144, 144, 255, 13,  13,  13,  255, 0,   0,   0,   255, 5,   5,   5,   255, 6,   6,
    6,   255, 0,   0,   0,   255, 0,   0,   0,   255, 163, 163, 163, 255, 121, 121, 121, 255, 4,   4,   4,   255, 35,  35,  35,  255, 239, 239, 239,
    255, 73,  73,  73,  255, 5,   5,   5,   255, 0,   0,   0,   255, 0,   0,   0,   255, 4,   4,   4,   255, 195, 195, 195, 255, 148, 148, 148, 255,
    9,   9,   9,   255, 0,   0,   0,   255, 253, 253, 253, 255, 65,  65,  65,  255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,
    0,   0,   255, 98,  98,  98,  255, 240, 240, 240, 255, 118, 118, 118, 255, 45,  45,  45,  255, 0,   0,   0,   255, 20,  20,  20,  255, 85,  85,
    85,  255, 226, 226, 226, 255, 183, 183, 183, 255, 14,  14,  14,  255, 0,   0,   0,   255, 2,   2,   2,   255, 4,   4,   4,   255, 32,  32,  32,
    255, 44,  44,  44,  255, 36,  36,  36,  255, 53,  53,  53,  255, 44,  44,  44,  255, 58,  58,  58,  255, 44,  44,  44,  255, 63,  63,  63,  255,
    229, 229, 229, 255, 120, 120, 120, 255, 17,  17,  17,  255, 0,   0,   0,   255, 0,   0,   0,   255, 92,  92,  92,  255, 162, 162, 162, 255, 73,
    73,  73,  255, 34,  34,  34,  255, 6,   6,   6,   255, 34,  34,  34,  255, 129, 129, 129, 255, 235, 235, 235, 255, 84,  84,  84,  255, 11,  11,
    11,  255, 0,   0,   0,   255, 1,   1,   1,   255, 0,   0,   0,   255, 183, 183, 183, 255, 78,  78,  78,  255, 86,  86,  86,  255, 247, 247, 247,
    255, 145, 145, 145, 255, 70,  70,  70,  255, 22,  22,  22,  255, 11,  11,  11,  255, 30,  30,  30,  255, 81,  81,  81,  255, 243, 243, 243, 255,
    61,  61,  61,  255, 52,  52,  52,  255, 54,  54,  54,  255, 53,  53,  53,  255, 0,   0,   0,   255, 14,  14,  14,  255, 6,   6,   6,   255, 0,
    0,   0,   255, 9,   9,   9,   255, 9,   9,   9,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 13,  13,  13,  255, 0,   0,
    0,   255, 0,   0,   0,   255, 2,   2,   2,   255, 147, 147, 147, 255, 149, 149, 149, 255, 42,  42,  42,  255, 0,   0,   0,   255, 0,   0,   0,
    255, 81,  81,  81,  255, 98,  98,  98,  255, 146, 146, 146, 255, 0,   0,   0,   255, 5,   5,   5,   255, 12,  12,  12,  255, 75,  75,  75,  255,
    131, 131, 131, 255, 63,  63,  63,  255, 0,   0,   0,   255, 0,   0,   0,   255, 23,  23,  23,  255, 95,  95,  95,  255, 86,  86,  86,  255, 89,
    89,  89,  255, 87,  87,  87,  255, 35,  35,  35,  255, 2,   2,   2,   255, 29,  29,  29,  255, 84,  84,  84,  255, 111, 111, 111, 255, 47,  47,
    47,  255, 6,   6,   6,   255, 0,   0,   0,   255, 41,  41,  41,  255, 8,   8,   8,   255, 44,  44,  44,  255, 75,  75,  75,  255, 39,  39,  39,
    255, 177, 177, 177, 255, 81,  81,  81,  255, 92,  92,  92,  255, 0,   0,   0,   255, 6,   6,   6,   255, 1,   1,   1,   255, 4,   4,   4,   255,
    155, 155, 155, 255, 128, 128, 128, 255, 10,  10,  10,  255, 0,   0,   0,   255, 98,  98,  98,  255, 239, 239, 239, 255, 14,  14,  14,  255, 0,
    0,   0,   255, 8,   8,   8,   255, 104, 104, 104, 255, 210, 210, 210, 255, 23,  23,  23,  255, 0,   0,   0,   255, 15,  15,  15,  255, 223, 223,
    223, 255, 52,  52,  52,  255, 0,   0,   0,   255, 10,  10,  10,  255, 0,   0,   0,   255, 63,  63,  63,  255, 238, 238, 238, 255, 64,  64,  64,
    255, 9,   9,   9,   255, 0,   0,   0,   255, 3,   3,   3,   255, 0,   0,   0,   255, 0,   0,   0,   255, 21,  21,  21,  255, 211, 211, 211, 255,
    141, 141, 141, 255, 6,   6,   6,   255, 3,   3,   3,   255, 0,   0,   0,   255, 0,   0,   0,   255, 4,   4,   4,   255, 7,   7,   7,   255, 0,
    0,   0,   255, 4,   4,   4,   255, 0,   0,   0,   255, 10,  10,  10,  255, 170, 170, 170, 255, 166, 166, 166, 255, 2,   2,   2,   255, 0,   0,
    0,   255, 8,   8,   8,   255, 0,   0,   0,   255, 11,  11,  11,  255, 1,   1,   1,   255, 2,   2,   2,   255, 0,   0,   0,   255, 16,  16,  16,
    255, 0,   0,   0,   255, 3,   3,   3,   255, 93,  93,  93,  255, 226, 226, 226, 255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255,
    9,   9,   9,   255, 180, 180, 180, 255, 146, 146, 146, 255, 222, 222, 222, 255, 35,  35,  35,  255, 9,   9,   9,   255, 0,   0,   0,   255, 5,
    5,   5,   255, 0,   0,   0,   255, 1,   1,   1,   255, 40,  40,  40,  255, 237, 237, 237, 255, 2,   2,   2,   255, 2,   2,   2,   255, 0,   0,
    0,   255, 0,   0,   0,   255, 3,   3,   3,   255, 1,   1,   1,   255, 0,   0,   0,   255, 5,   5,   5,   255, 2,   2,   2,   255, 0,   0,   0,
    255, 7,   7,   7,   255, 0,   0,   0,   255, 2,   2,   2,   255, 0,   0,   0,   255, 0,   0,   0,   255, 4,   4,   4,   255, 1,   1,   1,   255,
    141, 141, 141, 255, 23,  23,  23,  255, 165, 165, 165, 255, 0,   0,   0,   255, 30,  30,  30,  255, 146, 146, 146, 255, 0,   0,   0,   255, 148,
    148, 148, 255, 1,   1,   1,   255, 13,  13,  13,  255, 155, 155, 155, 255, 64,  64,  64,  255, 25,  25,  25,  255, 112, 112, 112, 255, 115, 115,
    115, 255, 5,   5,   5,   255, 13,  13,  13,  255, 47,  47,  47,  255, 48,  48,  48,  255, 51,  51,  51,  255, 175, 175, 175, 255, 33,  33,  33,
    255, 9,   9,   9,   255, 82,  82,  82,  255, 50,  50,  50,  255, 29,  29,  29,  255, 121, 121, 121, 255, 85,  85,  85,  255, 9,   9,   9,   255,
    99,  99,  99,  255, 129, 129, 129, 255, 121, 121, 121, 255, 35,  35,  35,  255, 26,  26,  26,  255, 163, 163, 163, 255, 52,  52,  52,  255, 38,
    38,  38,  255, 1,   1,   1,   255, 2,   2,   2,   255, 1,   1,   1,   255, 2,   2,   2,   255, 158, 158, 158, 255, 130, 130, 130, 255, 0,   0,
    0,   255, 0,   0,   0,   255, 10,  10,  10,  255, 176, 176, 176, 255, 163, 163, 163, 255, 8,   8,   8,   255, 25,  25,  25,  255, 238, 238, 238,
    255, 69,  69,  69,  255, 0,   0,   0,   255, 3,   3,   3,   255, 7,   7,   7,   255, 246, 246, 246, 255, 46,  46,  46,  255, 5,   5,   5,   255,
    0,   0,   0,   255, 8,   8,   8,   255, 180, 180, 180, 255, 144, 144, 144, 255, 3,   3,   3,   255, 0,   0,   0,   255, 7,   7,   7,   255, 0,
    0,   0,   255, 3,   3,   3,   255, 0,   0,   0,   255, 0,   0,   0,   255, 55,  55,  55,  255, 255, 255, 255, 255, 30,  30,  30,  255, 0,   0,
    0,   255, 9,   9,   9,   255, 0,   0,   0,   255, 1,   1,   1,   255, 1,   1,   1,   255, 0,   0,   0,   255, 11,  11,  11,  255, 0,   0,   0,
    255, 134, 134, 134, 255, 207, 207, 207, 255, 17,  17,  17,  255, 0,   0,   0,   255, 0,   0,   0,   255, 9,   9,   9,   255, 0,   0,   0,   255,
    1,   1,   1,   255, 0,   0,   0,   255, 3,   3,   3,   255, 3,   3,   3,   255, 0,   0,   0,   255, 1,   1,   1,   255, 0,   0,   0,   255, 16,
    16,  16,  255, 232, 232, 232, 255, 56,  56,  56,  255, 0,   0,   0,   255, 3,   3,   3,   255, 0,   0,   0,   255, 188, 188, 188, 255, 244, 244,
    244, 255, 53,  53,  53,  255, 3,   3,   3,   255, 1,   1,   1,   255, 0,   0,   0,   255, 7,   7,   7,   255, 0,   0,   0,   255, 4,   4,   4,
    255, 41,  41,  41,  255, 246, 246, 246, 255, 18,  18,  18,  255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255,
    2,   2,   2,   255, 0,   0,   0,   255, 0,   0,   0,   255, 3,   3,   3,   255, 4,   4,   4,   255, 0,   0,   0,   255, 0,   0,   0,   255, 3,
    3,   3,   255, 1,   1,   1,   255, 2,   2,   2,   255, 3,   3,   3,   255, 0,   0,   0,   255, 139, 139, 139, 255, 5,   5,   5,   255, 60,  60,
    60,  255, 128, 128, 128, 255, 148, 148, 148, 255, 19,  19,  19,  255, 27,  27,  27,  255, 128, 128, 128, 255, 4,   4,   4,   255, 112, 112, 112,
    255, 53,  53,  53,  255, 0,   0,   0,   255, 0,   0,   0,   255, 2,   2,   2,   255, 141, 141, 141, 255, 32,  32,  32,  255, 3,   3,   3,   255,
    0,   0,   0,   255, 0,   0,   0,   255, 128, 128, 128, 255, 58,  58,  58,  255, 5,   5,   5,   255, 0,   0,   0,   255, 0,   0,   0,   255, 25,
    25,  25,  255, 49,  49,  49,  255, 25,  25,  25,  255, 145, 145, 145, 255, 0,   0,   0,   255, 104, 104, 104, 255, 123, 123, 123, 255, 0,   0,
    0,   255, 4,   4,   4,   255, 1,   1,   1,   255, 143, 143, 143, 255, 0,   0,   0,   255, 0,   0,   0,   255, 5,   5,   5,   255, 8,   8,   8,
    255, 0,   0,   0,   255, 0,   0,   0,   255, 158, 158, 158, 255, 132, 132, 132, 255, 8,   8,   8,   255, 0,   0,   0,   255, 0,   0,   0,   255,
    27,  27,  27,  255, 228, 228, 228, 255, 80,  80,  80,  255, 197, 197, 197, 255, 127, 127, 127, 255, 22,  22,  22,  255, 0,   0,   0,   255, 0,
    0,   0,   255, 4,   4,   4,   255, 245, 245, 245, 255, 44,  44,  44,  255, 1,   1,   1,   255, 0,   0,   0,   255, 13,  13,  13,  255, 237, 237,
    237, 255, 71,  71,  71,  255, 0,   0,   0,   255, 0,   0,   0,   255, 2,   2,   2,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,
    255, 8,   8,   8,   255, 5,   5,   5,   255, 202, 202, 202, 255, 124, 124, 124, 255, 3,   3,   3,   255, 0,   0,   0,   255, 1,   1,   1,   255,
    0,   0,   0,   255, 11,  11,  11,  255, 4,   4,   4,   255, 0,   0,   0,   255, 127, 127, 127, 255, 219, 219, 219, 255, 23,  23,  23,  255, 0,
    0,   0,   255, 2,   2,   2,   255, 0,   0,   0,   255, 3,   3,   3,   255, 11,  11,  11,  255, 0,   0,   0,   255, 14,  14,  14,  255, 61,  61,
    61,  255, 107, 107, 107, 255, 126, 126, 126, 255, 119, 119, 119, 255, 88,  88,  88,  255, 25,  25,  25,  255, 210, 210, 210, 255, 64,  64,  64,
    255, 3,   3,   3,   255, 2,   2,   2,   255, 0,   0,   0,   255, 180, 180, 180, 255, 192, 192, 192, 255, 21,  21,  21,  255, 0,   0,   0,   255,
    0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 12,  12,  12,  255, 0,   0,   0,   255, 38,  38,  38,  255, 226, 226, 226, 255, 5,
    5,   5,   255, 0,   0,   0,   255, 0,   0,   0,   255, 4,   4,   4,   255, 4,   4,   4,   255, 3,   3,   3,   255, 0,   0,   0,   255, 0,   0,
    0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 4,   4,   4,   255, 0,   0,   0,   255, 0,   0,   0,   255, 1,   1,   1,   255, 0,   0,   0,
    255, 0,   0,   0,   255, 0,   0,   0,   255, 143, 143, 143, 255, 0,   0,   0,   255, 0,   0,   0,   255, 129, 129, 129, 255, 87,  87,  87,  255,
    1,   1,   1,   255, 1,   1,   1,   255, 147, 147, 147, 255, 0,   0,   0,   255, 168, 168, 168, 255, 19,  19,  19,  255, 0,   0,   0,   255, 0,
    0,   0,   255, 9,   9,   9,   255, 88,  88,  88,  255, 68,  68,  68,  255, 0,   0,   0,   255, 6,   6,   6,   255, 88,  88,  88,  255, 88,  88,
    88,  255, 15,  15,  15,  255, 0,   0,   0,   255, 6,   6,   6,   255, 153, 153, 153, 255, 128, 128, 128, 255, 86,  86,  86,  255, 124, 124, 124,
    255, 143, 143, 143, 255, 13,  13,  13,  255, 110, 110, 110, 255, 48,  48,  48,  255, 0,   0,   0,   255, 11,  11,  11,  255, 0,   0,   0,   255,
    138, 138, 138, 255, 5,   5,   5,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 3,   3,   3,   255, 10,  10,  10,  255, 144,
    144, 144, 255, 122, 122, 122, 255, 5,   5,   5,   255, 1,   1,   1,   255, 0,   0,   0,   255, 5,   5,   5,   255, 104, 104, 104, 255, 244, 244,
    244, 255, 210, 210, 210, 255, 24,  24,  24,  255, 0,   0,   0,   255, 0,   0,   0,   255, 3,   3,   3,   255, 5,   5,   5,   255, 246, 246, 246,
    255, 46,  46,  46,  255, 3,   3,   3,   255, 0,   0,   0,   255, 49,  49,  49,  255, 255, 255, 255, 255, 9,   9,   9,   255, 0,   0,   0,   255,
    0,   0,   0,   255, 15,  15,  15,  255, 7,   7,   7,   255, 0,   0,   0,   255, 11,  11,  11,  255, 0,   0,   0,   255, 0,   0,   0,   255, 167,
    167, 167, 255, 149, 149, 149, 255, 0,   0,   0,   255, 6,   6,   6,   255, 7,   7,   7,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,
    0,   255, 76,  76,  76,  255, 213, 213, 213, 255, 63,  63,  63,  255, 0,   0,   0,   255, 4,   4,   4,   255, 6,   6,   6,   255, 1,   1,   1,
    255, 0,   0,   0,   255, 0,   0,   0,   255, 83,  83,  83,  255, 222, 222, 222, 255, 206, 206, 206, 255, 155, 155, 155, 255, 134, 134, 134, 255,
    145, 145, 145, 255, 163, 163, 163, 255, 239, 239, 239, 255, 254, 254, 254, 255, 64,  64,  64,  255, 10,  10,  10,  255, 3,   3,   3,   255, 2,
    2,   2,   255, 181, 181, 181, 255, 138, 138, 138, 255, 0,   0,   0,   255, 0,   0,   0,   255, 2,   2,   2,   255, 3,   3,   3,   255, 0,   0,
    0,   255, 0,   0,   0,   255, 2,   2,   2,   255, 38,  38,  38,  255, 251, 251, 251, 255, 0,   0,   0,   255, 10,  10,  10,  255, 6,   6,   6,
    255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 1,   1,   1,   255, 6,   6,   6,   255, 0,   0,   0,   255, 0,   0,   0,   255,
    2,   2,   2,   255, 2,   2,   2,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 2,   2,   2,   255, 146,
    146, 146, 255, 5,   5,   5,   255, 7,   7,   7,   255, 10,  10,  10,  255, 0,   0,   0,   255, 9,   9,   9,   255, 7,   7,   7,   255, 149, 149,
    149, 255, 0,   0,   0,   255, 105, 105, 105, 255, 43,  43,  43,  255, 0,   0,   0,   255, 12,  12,  12,  255, 0,   0,   0,   255, 147, 147, 147,
    255, 28,  28,  28,  255, 0,   0,   0,   255, 62,  62,  62,  255, 132, 132, 132, 255, 6,   6,   6,   255, 0,   0,   0,   255, 0,   0,   0,   255,
    56,  56,  56,  255, 93,  93,  93,  255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 169, 169, 169, 255, 4,   4,   4,   255, 92,
    92,  92,  255, 34,  34,  34,  255, 4,   4,   4,   255, 0,   0,   0,   255, 1,   1,   1,   255, 138, 138, 138, 255, 13,  13,  13,  255, 0,   0,
    0,   255, 2,   2,   2,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 170, 170, 170, 255, 131, 131, 131, 255, 0,   0,   0,
    255, 2,   2,   2,   255, 7,   7,   7,   255, 0,   0,   0,   255, 0,   0,   0,   255, 162, 162, 162, 255, 58,  58,  58,  255, 0,   0,   0,   255,
    0,   0,   0,   255, 7,   7,   7,   255, 4,   4,   4,   255, 6,   6,   6,   255, 245, 245, 245, 255, 46,  46,  46,  255, 5,   5,   5,   255, 5,
    5,   5,   255, 29,  29,  29,  255, 247, 247, 247, 255, 21,  21,  21,  255, 12,  12,  12,  255, 0,   0,   0,   255, 0,   0,   0,   255, 4,   4,
    4,   255, 0,   0,   0,   255, 0,   0,   0,   255, 12,  12,  12,  255, 2,   2,   2,   255, 173, 173, 173, 255, 134, 134, 134, 255, 15,  15,  15,
    255, 0,   0,   0,   255, 0,   0,   0,   255, 13,  13,  13,  255, 0,   0,   0,   255, 34,  34,  34,  255, 232, 232, 232, 255, 83,  83,  83,  255,
    0,   0,   0,   255, 16,  16,  16,  255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 8,   8,   8,   255, 50,  50,  50,  255, 239,
    239, 239, 255, 87,  87,  87,  255, 4,   4,   4,   255, 0,   0,   0,   255, 4,   4,   4,   255, 0,   0,   0,   255, 5,   5,   5,   255, 2,   2,
    2,   255, 191, 191, 191, 255, 70,  70,  70,  255, 0,   0,   0,   255, 1,   1,   1,   255, 2,   2,   2,   255, 188, 188, 188, 255, 108, 108, 108,
    255, 0,   0,   0,   255, 2,   2,   2,   255, 0,   0,   0,   255, 3,   3,   3,   255, 6,   6,   6,   255, 0,   0,   0,   255, 5,   5,   5,   255,
    33,  33,  33,  255, 246, 246, 246, 255, 2,   2,   2,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 2,   2,   2,   255, 0,
    0,   0,   255, 0,   0,   0,   255, 9,   9,   9,   255, 7,   7,   7,   255, 0,   0,   0,   255, 0,   0,   0,   255, 5,   5,   5,   255, 0,   0,
    0,   255, 3,   3,   3,   255, 1,   1,   1,   255, 0,   0,   0,   255, 8,   8,   8,   255, 122, 122, 122, 255, 9,   9,   9,   255, 1,   1,   1,
    255, 0,   0,   0,   255, 2,   2,   2,   255, 0,   0,   0,   255, 19,  19,  19,  255, 125, 125, 125, 255, 13,  13,  13,  255, 24,  24,  24,  255,
    174, 174, 174, 255, 45,  45,  45,  255, 13,  13,  13,  255, 94,  94,  94,  255, 111, 111, 111, 255, 17,  17,  17,  255, 33,  33,  33,  255, 170,
    170, 170, 255, 27,  27,  27,  255, 21,  21,  21,  255, 28,  28,  28,  255, 25,  25,  25,  255, 29,  29,  29,  255, 170, 170, 170, 255, 23,  23,
    23,  255, 27,  27,  27,  255, 121, 121, 121, 255, 164, 164, 164, 255, 0,   0,   0,   255, 124, 124, 124, 255, 56,  56,  56,  255, 0,   0,   0,
    255, 7,   7,   7,   255, 8,   8,   8,   255, 122, 122, 122, 255, 63,  63,  63,  255, 26,  26,  26,  255, 0,   0,   0,   255, 8,   8,   8,   255,
    11,  11,  11,  255, 0,   0,   0,   255, 152, 152, 152, 255, 129, 129, 129, 255, 14,  14,  14,  255, 0,   0,   0,   255, 11,  11,  11,  255, 0,
    0,   0,   255, 1,   1,   1,   255, 9,   9,   9,   255, 0,   0,   0,   255, 2,   2,   2,   255, 4,   4,   4,   255, 0,   0,   0,   255, 0,   0,
    0,   255, 6,   6,   6,   255, 241, 241, 241, 255, 44,  44,  44,  255, 2,   2,   2,   255, 5,   5,   5,   255, 2,   2,   2,   255, 244, 244, 244,
    255, 67,  67,  67,  255, 0,   0,   0,   255, 12,  12,  12,  255, 3,   3,   3,   255, 0,   0,   0,   255, 10,  10,  10,  255, 2,   2,   2,   255,
    0,   0,   0,   255, 0,   0,   0,   255, 202, 202, 202, 255, 115, 115, 115, 255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,
    0,   0,   255, 19,  19,  19,  255, 215, 215, 215, 255, 119, 119, 119, 255, 5,   5,   5,   255, 1,   1,   1,   255, 0,   0,   0,   255, 0,   0,
    0,   255, 4,   4,   4,   255, 17,  17,  17,  255, 3,   3,   3,   255, 116, 116, 116, 255, 185, 185, 185, 255, 2,   2,   2,   255, 0,   0,   0,
    255, 6,   6,   6,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 201, 201, 201, 255, 75,  75,  75,  255,
    16,  16,  16,  255, 0,   0,   0,   255, 0,   0,   0,   255, 187, 187, 187, 255, 94,  94,  94,  255, 4,   4,   4,   255, 1,   1,   1,   255, 0,
    0,   0,   255, 1,   1,   1,   255, 0,   0,   0,   255, 9,   9,   9,   255, 0,   0,   0,   255, 40,  40,  40,  255, 226, 226, 226, 255, 14,  14,
    14,  255, 1,   1,   1,   255, 3,   3,   3,   255, 3,   3,   3,   255, 8,   8,   8,   255, 3,   3,   3,   255, 0,   0,   0,   255, 0,   0,   0,
    255, 2,   2,   2,   255, 2,   2,   2,   255, 0,   0,   0,   255, 1,   1,   1,   255, 0,   0,   0,   255, 3,   3,   3,   255, 3,   3,   3,   255,
    1,   1,   1,   255, 3,   3,   3,   255, 63,  63,  63,  255, 0,   0,   0,   255, 0,   0,   0,   255, 11,  11,  11,  255, 13,  13,  13,  255, 0,
    0,   0,   255, 0,   0,   0,   255, 66,  66,  66,  255, 0,   0,   0,   255, 4,   4,   4,   255, 10,  10,  10,  255, 107, 107, 107, 255, 118, 118,
    118, 255, 72,  72,  72,  255, 13,  13,  13,  255, 0,   0,   0,   255, 32,  32,  32,  255, 98,  98,  98,  255, 101, 101, 101, 255, 102, 102, 102,
    255, 99,  99,  99,  255, 47,  47,  47,  255, 0,   0,   0,   255, 33,  33,  33,  255, 130, 130, 130, 255, 104, 104, 104, 255, 39,  39,  39,  255,
    52,  52,  52,  255, 10,  10,  10,  255, 31,  31,  31,  255, 8,   8,   8,   255, 8,   8,   8,   255, 0,   0,   0,   255, 0,   0,   0,   255, 19,
    19,  19,  255, 92,  92,  92,  255, 97,  97,  97,  255, 15,  15,  15,  255, 0,   0,   0,   255, 0,   0,   0,   255, 2,   2,   2,   255, 157, 157,
    157, 255, 124, 124, 124, 255, 9,   9,   9,   255, 0,   0,   0,   255, 0,   0,   0,   255, 15,  15,  15,  255, 2,   2,   2,   255, 10,  10,  10,
    255, 0,   0,   0,   255, 4,   4,   4,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 10,  10,  10,  255, 242, 242, 242, 255,
    48,  48,  48,  255, 1,   1,   1,   255, 0,   0,   0,   255, 11,  11,  11,  255, 156, 156, 156, 255, 187, 187, 187, 255, 7,   7,   7,   255, 0,
    0,   0,   255, 15,  15,  15,  255, 0,   0,   0,   255, 0,   0,   0,   255, 3,   3,   3,   255, 0,   0,   0,   255, 75,  75,  75,  255, 247, 247,
    247, 255, 9,   9,   9,   255, 0,   0,   0,   255, 6,   6,   6,   255, 11,  11,  11,  255, 10,  10,  10,  255, 180, 180, 180, 255, 165, 165, 165,
    255, 6,   6,   6,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 6,   6,   6,   255, 0,   0,   0,   255, 3,   3,   3,   255,
    0,   0,   0,   255, 160, 160, 160, 255, 159, 159, 159, 255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 1,   1,   1,   255, 1,
    1,   1,   255, 6,   6,   6,   255, 28,  28,  28,  255, 236, 236, 236, 255, 73,  73,  73,  255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,
    0,   255, 184, 184, 184, 255, 92,  92,  92,  255, 6,   6,   6,   255, 0,   0,   0,   255, 0,   0,   0,   255, 4,   4,   4,   255, 0,   0,   0,
    255, 2,   2,   2,   255, 0,   0,   0,   255, 44,  44,  44,  255, 247, 247, 247, 255, 0,   0,   0,   255, 4,   4,   4,   255, 0,   0,   0,   255,
    0,   0,   0,   255, 0,   0,   0,   255, 5,   5,   5,   255, 4,   4,   4,   255, 0,   0,   0,   255, 0,   0,   0,   255, 4,   4,   4,   255, 0,
    0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 1,   1,   1,   255, 0,   0,   0,   255, 0,   0,   0,   255, 10,  10,
    10,  255, 0,   0,   0,   255, 8,   8,   8,   255, 0,   0,   0,   255, 4,   4,   4,   255, 0,   0,   0,   255, 4,   4,   4,   255, 0,   0,   0,
    255, 0,   0,   0,   255, 3,   3,   3,   255, 0,   0,   0,   255, 4,   4,   4,   255, 1,   1,   1,   255, 0,   0,   0,   255, 0,   0,   0,   255,
    2,   2,   2,   255, 18,  18,  18,  255, 0,   0,   0,   255, 6,   6,   6,   255, 0,   0,   0,   255, 10,  10,  10,  255, 0,   0,   0,   255, 0,
    0,   0,   255, 0,   0,   0,   255, 5,   5,   5,   255, 8,   8,   8,   255, 0,   0,   0,   255, 0,   0,   0,   255, 2,   2,   2,   255, 0,   0,
    0,   255, 11,  11,  11,  255, 0,   0,   0,   255, 1,   1,   1,   255, 11,  11,  11,  255, 0,   0,   0,   255, 8,   8,   8,   255, 5,   5,   5,
    255, 0,   0,   0,   255, 4,   4,   4,   255, 12,  12,  12,  255, 0,   0,   0,   255, 154, 154, 154, 255, 136, 136, 136, 255, 0,   0,   0,   255,
    15,  15,  15,  255, 0,   0,   0,   255, 0,   0,   0,   255, 1,   1,   1,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,
    0,   0,   255, 0,   0,   0,   255, 4,   4,   4,   255, 10,  10,  10,  255, 242, 242, 242, 255, 54,  54,  54,  255, 0,   0,   0,   255, 0,   0,
    0,   255, 0,   0,   0,   255, 29,  29,  29,  255, 226, 226, 226, 255, 129, 129, 129, 255, 10,  10,  10,  255, 0,   0,   0,   255, 0,   0,   0,
    255, 0,   0,   0,   255, 20,  20,  20,  255, 40,  40,  40,  255, 238, 238, 238, 255, 111, 111, 111, 255, 0,   0,   0,   255, 3,   3,   3,   255,
    3,   3,   3,   255, 0,   0,   0,   255, 142, 142, 142, 255, 194, 194, 194, 255, 10,  10,  10,  255, 0,   0,   0,   255, 0,   0,   0,   255, 11,
    11,  11,  255, 0,   0,   0,   255, 0,   0,   0,   255, 10,  10,  10,  255, 1,   1,   1,   255, 0,   0,   0,   255, 104, 104, 104, 255, 240, 240,
    240, 255, 5,   5,   5,   255, 15,  15,  15,  255, 4,   4,   4,   255, 0,   0,   0,   255, 3,   3,   3,   255, 4,   4,   4,   255, 161, 161, 161,
    255, 254, 254, 254, 255, 80,  80,  80,  255, 0,   0,   0,   255, 1,   1,   1,   255, 7,   7,   7,   255, 183, 183, 183, 255, 95,  95,  95,  255,
    4,   4,   4,   255, 0,   0,   0,   255, 3,   3,   3,   255, 3,   3,   3,   255, 8,   8,   8,   255, 0,   0,   0,   255, 3,   3,   3,   255, 21,
    21,  21,  255, 232, 232, 232, 255, 45,  45,  45,  255, 1,   1,   1,   255, 0,   0,   0,   255, 21,  21,  21,  255, 0,   0,   0,   255, 0,   0,
    0,   255, 12,  12,  12,  255, 0,   0,   0,   255, 0,   0,   0,   255, 6,   6,   6,   255, 0,   0,   0,   255, 3,   3,   3,   255, 3,   3,   3,
    255, 0,   0,   0,   255, 1,   1,   1,   255, 2,   2,   2,   255, 4,   4,   4,   255, 0,   0,   0,   255, 8,   8,   8,   255, 0,   0,   0,   255,
    0,   0,   0,   255, 3,   3,   3,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 10,  10,  10,  255, 0,   0,   0,   255, 0,
    0,   0,   255, 7,   7,   7,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 3,   3,   3,   255, 0,   0,   0,   255, 3,   3,
    3,   255, 0,   0,   0,   255, 4,   4,   4,   255, 0,   0,   0,   255, 7,   7,   7,   255, 5,   5,   5,   255, 0,   0,   0,   255, 0,   0,   0,
    255, 4,   4,   4,   255, 9,   9,   9,   255, 0,   0,   0,   255, 8,   8,   8,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255,
    6,   6,   6,   255, 0,   0,   0,   255, 6,   6,   6,   255, 0,   0,   0,   255, 0,   0,   0,   255, 3,   3,   3,   255, 0,   0,   0,   255, 0,
    0,   0,   255, 1,   1,   1,   255, 163, 163, 163, 255, 127, 127, 127, 255, 5,   5,   5,   255, 0,   0,   0,   255, 4,   4,   4,   255, 1,   1,
    1,   255, 0,   0,   0,   255, 0,   0,   0,   255, 5,   5,   5,   255, 0,   0,   0,   255, 4,   4,   4,   255, 4,   4,   4,   255, 9,   9,   9,
    255, 3,   3,   3,   255, 235, 235, 235, 255, 54,  54,  54,  255, 0,   0,   0,   255, 3,   3,   3,   255, 0,   0,   0,   255, 1,   1,   1,   255,
    60,  60,  60,  255, 228, 228, 228, 255, 190, 190, 190, 255, 86,  86,  86,  255, 50,  50,  50,  255, 65,  65,  65,  255, 129, 129, 129, 255, 233,
    233, 233, 255, 120, 120, 120, 255, 0,   0,   0,   255, 4,   4,   4,   255, 0,   0,   0,   255, 4,   4,   4,   255, 112, 112, 112, 255, 249, 249,
    249, 255, 118, 118, 118, 255, 103, 103, 103, 255, 82,  82,  82,  255, 100, 100, 100, 255, 90,  90,  90,  255, 93,  93,  93,  255, 96,  96,  96,
    255, 89,  89,  89,  255, 11,  11,  11,  255, 1,   1,   1,   255, 0,   0,   0,   255, 172, 172, 172, 255, 223, 223, 223, 255, 99,  99,  99,  255,
    48,  48,  48,  255, 49,  49,  49,  255, 108, 108, 108, 255, 205, 205, 205, 255, 150, 150, 150, 255, 194, 194, 194, 255, 62,  62,  62,  255, 11,
    11,  11,  255, 0,   0,   0,   255, 8,   8,   8,   255, 181, 181, 181, 255, 97,  97,  97,  255, 0,   0,   0,   255, 0,   0,   0,   255, 5,   5,
    5,   255, 0,   0,   0,   255, 0,   0,   0,   255, 3,   3,   3,   255, 0,   0,   0,   255, 1,   1,   1,   255, 180, 180, 180, 255, 206, 206, 206,
    255, 67,  67,  67,  255, 77,  77,  77,  255, 97,  97,  97,  255, 15,  15,  15,  255, 0,   0,   0,   255, 6,   6,   6,   255, 0,   0,   0,   255,
    0,   0,   0,   255, 10,  10,  10,  255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,
    0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,
    0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,
    255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255,
    0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,
    0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,
    0,   255, 9,   9,   9,   255, 0,   0,   0,   255, 0,   0,   0,   255, 6,   6,   6,   255, 0,   0,   0,   255, 13,  13,  13,  255, 90,  90,  90,
    255, 69,  69,  69,  255, 18,  18,  18,  255, 0,   0,   0,   255, 0,   0,   0,   255, 5,   5,   5,   255, 0,   0,   0,   255, 0,   0,   0,   255,
    0,   0,   0,   255, 1,   1,   1,   255, 5,   5,   5,   255, 0,   0,   0,   255, 1,   1,   1,   255, 5,   5,   5,   255, 145, 145, 145, 255, 36,
    36,  36,  255, 0,   0,   0,   255, 0,   0,   0,   255, 5,   5,   5,   255, 0,   0,   0,   255, 0,   0,   0,   255, 32,  32,  32,  255, 119, 119,
    119, 255, 195, 195, 195, 255, 228, 228, 228, 255, 216, 216, 216, 255, 144, 144, 144, 255, 54,  54,  54,  255, 1,   1,   1,   255, 0,   0,   0,
    255, 5,   5,   5,   255, 4,   4,   4,   255, 0,   0,   0,   255, 137, 137, 137, 255, 150, 150, 150, 255, 159, 159, 159, 255, 158, 158, 158, 255,
    154, 154, 154, 255, 154, 154, 154, 255, 155, 155, 155, 255, 155, 155, 155, 255, 164, 164, 164, 255, 149, 149, 149, 255, 17,  17,  17,  255, 0,
    0,   0,   255, 3,   3,   3,   255, 0,   0,   0,   255, 109, 109, 109, 255, 182, 182, 182, 255, 221, 221, 221, 255, 221, 221, 221, 255, 168, 168,
    168, 255, 62,  62,  62,  255, 3,   3,   3,   255, 124, 124, 124, 255, 39,  39,  39,  255, 4,   4,   4,   255, 1,   1,   1,   255, 6,   6,   6,
    255, 104, 104, 104, 255, 64,  64,  64,  255, 0,   0,   0,   255, 12,  12,  12,  255, 0,   0,   0,   255, 6,   6,   6,   255, 0,   0,   0,   255,
    1,   1,   1,   255, 3,   3,   3,   255, 0,   0,   0,   255, 24,  24,  24,  255, 123, 123, 123, 255, 202, 202, 202, 255, 206, 206, 206, 255, 133,
    133, 133, 255, 20,  20,  20,  255, 0,   0,   0,   255, 2,   2,   2,   255, 0,   0,   0,   255, 3,   3,   3,   255, 0,   0,   0,   255, 0,   0,
    0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,
    255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255,
    0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,
    0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,
    0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,
    255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 6,   6,   6,   255, 0,   0,   0,   255,
    0,   0,   0,   255, 11,  11,  11,  255, 0,   0,   0,   255, 0,   0,   0,   255, 19,  19,  19,  255, 13,  13,  13,  255, 0,   0,   0,   255, 0,
    0,   0,   255, 2,   2,   2,   255, 0,   0,   0,   255, 0,   0,   0,   255, 2,   2,   2,   255, 3,   3,   3,   255, 0,   0,   0,   255, 0,   0,
    0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 19,  19,  19,  255, 0,   0,   0,   255, 2,   2,   2,   255, 0,   0,   0,
    255, 6,   6,   6,   255, 6,   6,   6,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255,
    8,   8,   8,   255, 8,   8,   8,   255, 6,   6,   6,   255, 2,   2,   2,   255, 0,   0,   0,   255, 0,   0,   0,   255, 1,   1,   1,   255, 4,
    4,   4,   255, 0,   0,   0,   255, 2,   2,   2,   255, 7,   7,   7,   255, 4,   4,   4,   255, 1,   1,   1,   255, 2,   2,   2,   255, 4,   4,
    4,   255, 4,   4,   4,   255, 0,   0,   0,   255, 15,  15,  15,  255, 0,   0,   0,   255, 3,   3,   3,   255, 14,  14,  14,  255, 0,   0,   0,
    255, 0,   0,   0,   255, 5,   5,   5,   255, 3,   3,   3,   255, 1,   1,   1,   255, 1,   1,   1,   255, 0,   0,   0,   255, 0,   0,   0,   255,
    23,  23,  23,  255, 0,   0,   0,   255, 1,   1,   1,   255, 4,   4,   4,   255, 0,   0,   0,   255, 17,  17,  17,  255, 2,   2,   2,   255, 0,
    0,   0,   255, 7,   7,   7,   255, 1,   1,   1,   255, 0,   0,   0,   255, 7,   7,   7,   255, 0,   0,   0,   255, 4,   4,   4,   255, 4,   4,
    4,   255, 0,   0,   0,   255, 0,   0,   0,   255, 5,   5,   5,   255, 0,   0,   0,   255, 14,  14,  14,  255, 0,   0,   0,   255, 4,   4,   4,
    255, 9,   9,   9,   255, 0,   0,   0,   255, 3,   3,   3,   255, 6,   6,   6,   255, 2,   2,   2,   255, 0,   0,   0,   255, 0,   0,   0,   255,
    0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,
    0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,
    0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,
    255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255,
    0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,
    0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 5,   5,   5,   255, 0,   0,   0,   255, 0,   0,   0,   255, 4,   4,   4,   255, 3,   3,
    3,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 6,   6,   6,   255, 5,   5,   5,   255, 0,   0,   0,
    255, 0,   0,   0,   255, 4,   4,   4,   255, 0,   0,   0,   255, 3,   3,   3,   255, 1,   1,   1,   255, 4,   4,   4,   255, 0,   0,   0,   255,
    4,   4,   4,   255, 0,   0,   0,   255, 3,   3,   3,   255, 4,   4,   4,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 5,
    5,   5,   255, 5,   5,   5,   255, 1,   1,   1,   255, 3,   3,   3,   255, 11,  11,  11,  255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,
    0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 5,   5,   5,   255, 0,   0,   0,   255, 0,   0,   0,
    255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255,
    2,   2,   2,   255, 2,   2,   2,   255, 0,   0,   0,   255, 0,   0,   0,   255, 8,   8,   8,   255, 0,   0,   0,   255, 6,   6,   6,   255, 0,
    0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 11,  11,  11,  255, 8,   8,   8,   255, 0,   0,   0,   255, 0,   0,   0,   255, 1,   1,
    1,   255, 6,   6,   6,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 3,   3,   3,   255, 12,  12,  12,
    255, 0,   0,   0,   255, 6,   6,   6,   255, 0,   0,   0,   255, 0,   0,   0,   255, 11,  11,  11,  255, 3,   3,   3,   255, 0,   0,   0,   255,
    8,   8,   8,   255, 9,   9,   9,   255, 0,   0,   0,   255, 0,   0,   0,   255, 10,  10,  10,  255, 2,   2,   2,   255, 0,   0,   0,   255, 0,
    0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,
    0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,
    255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255,
    0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,
    0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,
    0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,
    255, 2,   2,   2,   255, 2,   2,   2,   255, 0,   0,   0,   255, 0,   0,   0,   255, 3,   3,   3,   255, 8,   8,   8,   255, 4,   4,   4,   255,
    2,   2,   2,   255, 3,   3,   3,   255, 6,   6,   6,   255, 2,   2,   2,   255, 0,   0,   0,   255, 3,   3,   3,   255, 4,   4,   4,   255, 0,
    0,   0,   255, 0,   0,   0,   255, 9,   9,   9,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 5,   5,   5,   255, 11,  11,
    11,  255, 0,   0,   0,   255, 5,   5,   5,   255, 0,   0,   0,   255, 0,   0,   0,   255, 1,   1,   1,   255, 0,   0,   0,   255, 0,   0,   0,
    255, 0,   0,   0,   255, 2,   2,   2,   255, 14,  14,  14,  255, 7,   7,   7,   255, 0,   0,   0,   255, 0,   0,   0,   255, 3,   3,   3,   255,
    4,   4,   4,   255, 0,   0,   0,   255, 0,   0,   0,   255, 6,   6,   6,   255, 5,   5,   5,   255, 3,   3,   3,   255, 1,   1,   1,   255, 1,
    1,   1,   255, 3,   3,   3,   255, 3,   3,   3,   255, 2,   2,   2,   255, 0,   0,   0,   255, 0,   0,   0,   255, 7,   7,   7,   255, 0,   0,
    0,   255, 0,   0,   0,   255, 8,   8,   8,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 5,   5,   5,   255, 0,   0,   0,
    255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 12,  12,  12,  255, 1,   1,   1,   255, 0,   0,   0,   255, 7,   7,   7,   255,
    0,   0,   0,   255, 8,   8,   8,   255, 6,   6,   6,   255, 0,   0,   0,   255, 1,   1,   1,   255, 0,   0,   0,   255, 3,   3,   3,   255, 0,
    0,   0,   255, 3,   3,   3,   255, 3,   3,   3,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 9,   9,
    9,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 1,   1,   1,   255, 2,   2,   2,   255, 0,   0,   0,   255, 6,   6,   6,
    255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255,
    0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,
    0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,
    0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,
    255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255,
    0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 3,   3,   3,   255, 6,
    6,   6,   255, 0,   0,   0,   255, 0,   0,   0,   255, 1,   1,   1,   255, 0,   0,   0,   255, 4,   4,   4,   255, 0,   0,   0,   255, 0,   0,
    0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 1,   1,   1,   255, 4,   4,   4,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,
    255, 0,   0,   0,   255, 11,  11,  11,  255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 2,   2,   2,   255, 0,   0,   0,   255,
    1,   1,   1,   255, 2,   2,   2,   255, 1,   1,   1,   255, 1,   1,   1,   255, 1,   1,   1,   255, 2,   2,   2,   255, 3,   3,   3,   255, 0,
    0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 1,   1,   1,   255, 2,   2,   2,   255, 3,   3,
    3,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,
    255, 0,   0,   0,   255, 7,   7,   7,   255, 1,   1,   1,   255, 2,   2,   2,   255, 3,   3,   3,   255, 0,   0,   0,   255, 0,   0,   0,   255,
    4,   4,   4,   255, 1,   1,   1,   255, 12,  12,  12,  255, 3,   3,   3,   255, 0,   0,   0,   255, 5,   5,   5,   255, 2,   2,   2,   255, 0,
    0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,
    0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 7,   7,   7,   255, 0,   0,   0,   255, 0,   0,   0,   255, 5,   5,   5,   255, 2,   2,   2,
    255, 1,   1,   1,   255, 9,   9,   9,   255, 10,  10,  10,  255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255,
    4,   4,   4,   255, 7,   7,   7,   255, 0,   0,   0,   255, 0,   0,   0,   255, 12,  12,  12,  255, 0,   0,   0,   255, 0,   0,   0,   255, 0,
    0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,
    0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,
    255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255,
    0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,
    0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,
    0,   255, 0,   0,   0,   255, 4,   4,   4,   255, 0,   0,   0,   255, 0,   0,   0,   255, 2,   2,   2,   255, 2,   2,   2,   255, 0,   0,   0,
    255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 6,   6,   6,   255, 0,   0,   0,   255,
    0,   0,   0,   255, 2,   2,   2,   255, 6,   6,   6,   255, 12,  12,  12,  255, 0,   0,   0,   255, 5,   5,   5,   255, 3,   3,   3,   255, 2,
    2,   2,   255, 2,   2,   2,   255, 0,   0,   0,   255, 9,   9,   9,   255, 3,   3,   3,   255, 5,   5,   5,   255, 2,   2,   2,   255, 0,   0,
    0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 2,   2,   2,   255, 0,   0,   0,   255, 6,   6,   6,   255, 5,   5,   5,   255, 3,   3,   3,
    255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 2,   2,   2,   255, 5,   5,   5,   255, 1,   1,   1,   255, 0,   0,   0,   255,
    0,   0,   0,   255, 3,   3,   3,   255, 5,   5,   5,   255, 3,   3,   3,   255, 1,   1,   1,   255, 1,   1,   1,   255, 0,   0,   0,   255, 0,
    0,   0,   255, 0,   0,   0,   255, 14,  14,  14,  255, 7,   7,   7,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,
    0,   255, 0,   0,   0,   255, 1,   1,   1,   255, 10,  10,  10,  255, 0,   0,   0,   255, 10,  10,  10,  255, 0,   0,   0,   255, 12,  12,  12,
    255, 3,   3,   3,   255, 0,   0,   0,   255, 5,   5,   5,   255, 0,   0,   0,   255, 1,   1,   1,   255, 6,   6,   6,   255, 0,   0,   0,   255,
    10,  10,  10,  255, 8,   8,   8,   255, 1,   1,   1,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,
    0,   0,   255, 5,   5,   5,   255, 0,   0,   0,   255, 8,   8,   8,   255, 2,   2,   2,   255, 3,   3,   3,   255, 2,   2,   2,   255, 0,   0,
    0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,
    255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255,
    0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,
    0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,
    0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,
    255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 6,   6,   6,   255,
    0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 3,   3,   3,   255, 3,   3,   3,   255, 1,   1,   1,   255, 1,
    1,   1,   255, 0,   0,   0,   255, 4,   4,   4,   255, 8,   8,   8,   255, 0,   0,   0,   255, 0,   0,   0,   255, 1,   1,   1,   255, 1,   1,
    1,   255, 3,   3,   3,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 7,   7,   7,   255, 4,   4,   4,
    255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 4,   4,   4,   255, 6,   6,   6,   255, 7,   7,   7,   255, 8,   8,   8,   255,
    2,   2,   2,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 4,   4,   4,   255, 8,   8,   8,   255, 6,
    6,   6,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 1,   1,   1,   255, 0,   0,
    0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 4,   4,   4,   255, 4,   4,   4,   255, 0,   0,   0,   255, 0,   0,   0,
    255, 0,   0,   0,   255, 0,   0,   0,   255, 5,   5,   5,   255, 10,  10,  10,  255, 0,   0,   0,   255, 7,   7,   7,   255, 8,   8,   8,   255,
    0,   0,   0,   255, 0,   0,   0,   255, 2,   2,   2,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 10,
    10,  10,  255, 4,   4,   4,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 1,   1,   1,   255, 0,   0,
    0,   255, 0,   0,   0,   255, 6,   6,   6,   255, 8,   8,   8,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,
    255, 2,   2,   2,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 3,   3,   3,   255, 13,  13,  13,  255, 1,   1,   1,   255,
    0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,
    0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,
    0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,
    255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255,
    0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,
    0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 6,   6,   6,   255, 6,   6,   6,   255, 0,   0,
    0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 4,   4,   4,   255, 0,   0,   0,   255, 0,   0,   0,
    255, 0,   0,   0,   255, 0,   0,   0,   255, 3,   3,   3,   255, 3,   3,   3,   255, 0,   0,   0,   255, 0,   0,   0,   255, 5,   5,   5,   255,
    0,   0,   0,   255, 9,   9,   9,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 4,   4,   4,   255, 0,
    0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 3,   3,   3,   255, 0,   0,
    0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 5,   5,   5,
    255, 2,   2,   2,   255, 0,   0,   0,   255, 0,   0,   0,   255, 1,   1,   1,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255,
    3,   3,   3,   255, 0,   0,   0,   255, 1,   1,   1,   255, 4,   4,   4,   255, 0,   0,   0,   255, 2,   2,   2,   255, 4,   4,   4,   255, 0,
    0,   0,   255, 0,   0,   0,   255, 2,   2,   2,   255, 0,   0,   0,   255, 0,   0,   0,   255, 1,   1,   1,   255, 9,   9,   9,   255, 0,   0,
    0,   255, 4,   4,   4,   255, 0,   0,   0,   255, 3,   3,   3,   255, 2,   2,   2,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,
    255, 4,   4,   4,   255, 10,  10,  10,  255, 0,   0,   0,   255, 0,   0,   0,   255, 5,   5,   5,   255, 1,   1,   1,   255, 0,   0,   0,   255,
    1,   1,   1,   255, 2,   2,   2,   255, 0,   0,   0,   255, 4,   4,   4,   255, 2,   2,   2,   255, 4,   4,   4,   255, 0,   0,   0,   255, 8,
    8,   8,   255, 0,   0,   0,   255, 0,   0,   0,   255, 3,   3,   3,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,
    0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,
    255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255,
    0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 1,
    1,   1,   255, 1,   1,   1,   255, 1,   1,   1,   255, 1,   1,   1,   255, 1,   1,   1,   255, 1,   1,   1,   255, 1,   1,   1,   255, 1,   1,
    1,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,
    255, 0,   0,   0,   255, 1,   1,   1,   255, 1,   1,   1,   255, 1,   1,   1,   255, 1,   1,   1,   255, 1,   1,   1,   255, 1,   1,   1,   255,
    1,   1,   1,   255, 1,   1,   1,   255, 1,   1,   1,   255, 1,   1,   1,   255, 1,   1,   1,   255, 1,   1,   1,   255, 1,   1,   1,   255, 1,
    1,   1,   255, 1,   1,   1,   255, 1,   1,   1,   255, 1,   1,   1,   255, 1,   1,   1,   255, 1,   1,   1,   255, 1,   1,   1,   255, 0,   0,
    0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 1,   1,   1,   255, 1,   1,   1,   255, 1,   1,   1,   255, 1,   1,   1,
    255, 1,   1,   1,   255, 1,   1,   1,   255, 1,   1,   1,   255, 1,   1,   1,   255, 1,   1,   1,   255, 1,   1,   1,   255, 1,   1,   1,   255,
    1,   1,   1,   255, 1,   1,   1,   255, 1,   1,   1,   255, 1,   1,   1,   255, 1,   1,   1,   255, 1,   1,   1,   255, 1,   1,   1,   255, 1,
    1,   1,   255, 1,   1,   1,   255, 1,   1,   1,   255, 1,   1,   1,   255, 1,   1,   1,   255, 1,   1,   1,   255, 1,   1,   1,   255, 1,   1,
    1,   255, 1,   1,   1,   255, 1,   1,   1,   255, 1,   1,   1,   255, 1,   1,   1,   255, 1,   1,   1,   255, 1,   1,   1,   255, 1,   1,   1,
    255, 1,   1,   1,   255, 1,   1,   1,   255, 1,   1,   1,   255, 1,   1,   1,   255, 1,   1,   1,   255, 1,   1,   1,   255, 1,   1,   1,   255,
    0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,
    0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,
    0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,
    255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255,
    0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,
    0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,
    0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 1,   1,   1,   255, 1,   1,   1,   255, 1,   1,   1,
    255, 1,   1,   1,   255, 1,   1,   1,   255, 1,   1,   1,   255, 1,   1,   1,   255, 1,   1,   1,   255, 0,   0,   0,   255, 0,   0,   0,   255,
    0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 1,   1,   1,   255, 1,
    1,   1,   255, 1,   1,   1,   255, 1,   1,   1,   255, 1,   1,   1,   255, 1,   1,   1,   255, 1,   1,   1,   255, 1,   1,   1,   255, 1,   1,
    1,   255, 1,   1,   1,   255, 1,   1,   1,   255, 1,   1,   1,   255, 1,   1,   1,   255, 1,   1,   1,   255, 1,   1,   1,   255, 1,   1,   1,
    255, 1,   1,   1,   255, 1,   1,   1,   255, 1,   1,   1,   255, 1,   1,   1,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255,
    0,   0,   0,   255, 1,   1,   1,   255, 1,   1,   1,   255, 1,   1,   1,   255, 1,   1,   1,   255, 1,   1,   1,   255, 1,   1,   1,   255, 1,
    1,   1,   255, 1,   1,   1,   255, 1,   1,   1,   255, 1,   1,   1,   255, 1,   1,   1,   255, 1,   1,   1,   255, 1,   1,   1,   255, 1,   1,
    1,   255, 1,   1,   1,   255, 1,   1,   1,   255, 1,   1,   1,   255, 1,   1,   1,   255, 1,   1,   1,   255, 1,   1,   1,   255, 1,   1,   1,
    255, 1,   1,   1,   255, 1,   1,   1,   255, 1,   1,   1,   255, 1,   1,   1,   255, 1,   1,   1,   255, 1,   1,   1,   255, 1,   1,   1,   255,
    1,   1,   1,   255, 1,   1,   1,   255, 1,   1,   1,   255, 1,   1,   1,   255, 1,   1,   1,   255, 1,   1,   1,   255, 1,   1,   1,   255, 1,
    1,   1,   255, 1,   1,   1,   255, 1,   1,   1,   255, 1,   1,   1,   255, 1,   1,   1,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,
    0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,
    255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255,
    0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,
    0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,
    0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,
    255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255,
    0,   0,   0,   255, 0,   0,   0,   255, 1,   1,   1,   255, 1,   1,   1,   255, 1,   1,   1,   255, 1,   1,   1,   255, 1,   1,   1,   255, 1,
    1,   1,   255, 1,   1,   1,   255, 1,   1,   1,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,
    0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 1,   1,   1,   255, 1,   1,   1,   255, 1,   1,   1,   255, 1,   1,   1,
    255, 1,   1,   1,   255, 1,   1,   1,   255, 1,   1,   1,   255, 1,   1,   1,   255, 1,   1,   1,   255, 1,   1,   1,   255, 1,   1,   1,   255,
    1,   1,   1,   255, 1,   1,   1,   255, 1,   1,   1,   255, 1,   1,   1,   255, 1,   1,   1,   255, 1,   1,   1,   255, 1,   1,   1,   255, 1,
    1,   1,   255, 1,   1,   1,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 1,   1,   1,   255, 1,   1,
    1,   255, 1,   1,   1,   255, 1,   1,   1,   255, 1,   1,   1,   255, 1,   1,   1,   255, 1,   1,   1,   255, 1,   1,   1,   255, 1,   1,   1,
    255, 1,   1,   1,   255, 1,   1,   1,   255, 1,   1,   1,   255, 1,   1,   1,   255, 1,   1,   1,   255, 1,   1,   1,   255, 1,   1,   1,   255,
    1,   1,   1,   255, 1,   1,   1,   255, 1,   1,   1,   255, 1,   1,   1,   255, 1,   1,   1,   255, 1,   1,   1,   255, 1,   1,   1,   255, 1,
    1,   1,   255, 1,   1,   1,   255, 1,   1,   1,   255, 1,   1,   1,   255, 1,   1,   1,   255, 1,   1,   1,   255, 1,   1,   1,   255, 1,   1,
    1,   255, 1,   1,   1,   255, 1,   1,   1,   255, 1,   1,   1,   255, 1,   1,   1,   255, 1,   1,   1,   255, 1,   1,   1,   255, 1,   1,   1,
    255, 1,   1,   1,   255, 1,   1,   1,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255,
    0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,
    0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,
    0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,
    255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255,
    0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,
    0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 1,   1,
    1,   255, 1,   1,   1,   255, 1,   1,   1,   255, 1,   1,   1,   255, 1,   1,   1,   255, 1,   1,   1,   255, 1,   1,   1,   255, 1,   1,   1,
    255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255,
    0,   0,   0,   255, 1,   1,   1,   255, 1,   1,   1,   255, 1,   1,   1,   255, 1,   1,   1,   255, 1,   1,   1,   255, 1,   1,   1,   255, 1,
    1,   1,   255, 1,   1,   1,   255, 1,   1,   1,   255, 1,   1,   1,   255, 1,   1,   1,   255, 1,   1,   1,   255, 1,   1,   1,   255, 1,   1,
    1,   255, 1,   1,   1,   255, 1,   1,   1,   255, 1,   1,   1,   255, 1,   1,   1,   255, 1,   1,   1,   255, 1,   1,   1,   255, 0,   0,   0,
    255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 1,   1,   1,   255, 1,   1,   1,   255, 1,   1,   1,   255, 1,   1,   1,   255,
    1,   1,   1,   255, 1,   1,   1,   255, 1,   1,   1,   255, 1,   1,   1,   255, 1,   1,   1,   255, 1,   1,   1,   255, 1,   1,   1,   255, 1,
    1,   1,   255, 1,   1,   1,   255, 1,   1,   1,   255, 1,   1,   1,   255, 1,   1,   1,   255, 1,   1,   1,   255, 1,   1,   1,   255, 1,   1,
    1,   255, 1,   1,   1,   255, 1,   1,   1,   255, 1,   1,   1,   255, 1,   1,   1,   255, 1,   1,   1,   255, 1,   1,   1,   255, 1,   1,   1,
    255, 1,   1,   1,   255, 1,   1,   1,   255, 1,   1,   1,   255, 1,   1,   1,   255, 1,   1,   1,   255, 1,   1,   1,   255, 1,   1,   1,   255,
    1,   1,   1,   255, 1,   1,   1,   255, 1,   1,   1,   255, 1,   1,   1,   255, 1,   1,   1,   255, 1,   1,   1,   255, 1,   1,   1,   255, 0,
    0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,
    0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,
    255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255,
    0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,
    0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,
    0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,
    255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 1,   1,   1,   255, 1,   1,   1,   255, 1,   1,   1,   255,
    1,   1,   1,   255, 1,   1,   1,   255, 1,   1,   1,   255, 1,   1,   1,   255, 1,   1,   1,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,
    0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 1,   1,   1,   255, 1,   1,
    1,   255, 1,   1,   1,   255, 1,   1,   1,   255, 1,   1,   1,   255, 1,   1,   1,   255, 1,   1,   1,   255, 1,   1,   1,   255, 1,   1,   1,
    255, 1,   1,   1,   255, 1,   1,   1,   255, 1,   1,   1,   255, 1,   1,   1,   255, 1,   1,   1,   255, 1,   1,   1,   255, 1,   1,   1,   255,
    1,   1,   1,   255, 1,   1,   1,   255, 1,   1,   1,   255, 1,   1,   1,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,
    0,   0,   255, 1,   1,   1,   255, 1,   1,   1,   255, 1,   1,   1,   255, 1,   1,   1,   255, 1,   1,   1,   255, 1,   1,   1,   255, 1,   1,
    1,   255, 1,   1,   1,   255, 1,   1,   1,   255, 1,   1,   1,   255, 1,   1,   1,   255, 1,   1,   1,   255, 1,   1,   1,   255, 1,   1,   1,
    255, 1,   1,   1,   255, 1,   1,   1,   255, 1,   1,   1,   255, 1,   1,   1,   255, 1,   1,   1,   255, 1,   1,   1,   255, 1,   1,   1,   255,
    1,   1,   1,   255, 1,   1,   1,   255, 1,   1,   1,   255, 1,   1,   1,   255, 1,   1,   1,   255, 1,   1,   1,   255, 1,   1,   1,   255, 1,
    1,   1,   255, 1,   1,   1,   255, 1,   1,   1,   255, 1,   1,   1,   255, 1,   1,   1,   255, 1,   1,   1,   255, 1,   1,   1,   255, 1,   1,
    1,   255, 1,   1,   1,   255, 1,   1,   1,   255, 1,   1,   1,   255, 1,   1,   1,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,
    255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255,
    0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,
    0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,
    0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,
    255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255,
    0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,
    0,   0,   255, 0,   0,   0,   255, 1,   1,   1,   255, 1,   1,   1,   255, 1,   1,   1,   255, 1,   1,   1,   255, 1,   1,   1,   255, 1,   1,
    1,   255, 1,   1,   1,   255, 1,   1,   1,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,
    255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 1,   1,   1,   255, 1,   1,   1,   255, 1,   1,   1,   255, 1,   1,   1,   255,
    1,   1,   1,   255, 1,   1,   1,   255, 1,   1,   1,   255, 1,   1,   1,   255, 1,   1,   1,   255, 1,   1,   1,   255, 1,   1,   1,   255, 1,
    1,   1,   255, 1,   1,   1,   255, 1,   1,   1,   255, 1,   1,   1,   255, 1,   1,   1,   255, 1,   1,   1,   255, 1,   1,   1,   255, 1,   1,
    1,   255, 1,   1,   1,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 1,   1,   1,   255, 1,   1,   1,
    255, 1,   1,   1,   255, 1,   1,   1,   255, 1,   1,   1,   255, 1,   1,   1,   255, 1,   1,   1,   255, 1,   1,   1,   255, 1,   1,   1,   255,
    1,   1,   1,   255, 1,   1,   1,   255, 1,   1,   1,   255, 1,   1,   1,   255, 1,   1,   1,   255, 1,   1,   1,   255, 1,   1,   1,   255, 1,
    1,   1,   255, 1,   1,   1,   255, 1,   1,   1,   255, 1,   1,   1,   255, 1,   1,   1,   255, 1,   1,   1,   255, 1,   1,   1,   255, 1,   1,
    1,   255, 1,   1,   1,   255, 1,   1,   1,   255, 1,   1,   1,   255, 1,   1,   1,   255, 1,   1,   1,   255, 1,   1,   1,   255, 1,   1,   1,
    255, 1,   1,   1,   255, 1,   1,   1,   255, 1,   1,   1,   255, 1,   1,   1,   255, 1,   1,   1,   255, 1,   1,   1,   255, 1,   1,   1,   255,
    1,   1,   1,   255, 1,   1,   1,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,
    0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,
    0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,
    255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255,
    0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,
    0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,
    0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 1,   1,   1,
    255, 1,   1,   1,   255, 1,   1,   1,   255, 1,   1,   1,   255, 1,   1,   1,   255, 1,   1,   1,   255, 1,   1,   1,   255, 1,   1,   1,   255,
    0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,
    0,   0,   255, 1,   1,   1,   255, 1,   1,   1,   255, 1,   1,   1,   255, 1,   1,   1,   255, 1,   1,   1,   255, 1,   1,   1,   255, 1,   1,
    1,   255, 1,   1,   1,   255, 1,   1,   1,   255, 1,   1,   1,   255, 1,   1,   1,   255, 1,   1,   1,   255, 1,   1,   1,   255, 1,   1,   1,
    255, 1,   1,   1,   255, 1,   1,   1,   255, 1,   1,   1,   255, 1,   1,   1,   255, 1,   1,   1,   255, 1,   1,   1,   255, 0,   0,   0,   255,
    0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 1,   1,   1,   255, 1,   1,   1,   255, 1,   1,   1,   255, 1,   1,   1,   255, 1,
    1,   1,   255, 1,   1,   1,   255, 1,   1,   1,   255, 1,   1,   1,   255, 1,   1,   1,   255, 1,   1,   1,   255, 1,   1,   1,   255, 1,   1,
    1,   255, 1,   1,   1,   255, 1,   1,   1,   255, 1,   1,   1,   255, 1,   1,   1,   255, 1,   1,   1,   255, 1,   1,   1,   255, 1,   1,   1,
    255, 1,   1,   1,   255, 1,   1,   1,   255, 1,   1,   1,   255, 1,   1,   1,   255, 1,   1,   1,   255, 1,   1,   1,   255, 1,   1,   1,   255,
    1,   1,   1,   255, 1,   1,   1,   255, 1,   1,   1,   255, 1,   1,   1,   255, 1,   1,   1,   255, 1,   1,   1,   255, 1,   1,   1,   255, 1,
    1,   1,   255, 1,   1,   1,   255, 1,   1,   1,   255, 1,   1,   1,   255, 1,   1,   1,   255, 1,   1,   1,   255, 1,   1,   1,   255, 0,   0,
    0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,
    255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255,
    0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,
    0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,
    0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,
    255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255,
    0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 1,   1,   1,   255, 1,   1,   1,   255, 1,   1,   1,   255, 1,
    1,   1,   255, 1,   1,   1,   255, 1,   1,   1,   255, 1,   1,   1,   255, 1,   1,   1,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,
    0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 1,   1,   1,   255, 1,   1,   1,
    255, 1,   1,   1,   255, 1,   1,   1,   255, 1,   1,   1,   255, 1,   1,   1,   255, 1,   1,   1,   255, 1,   1,   1,   255, 1,   1,   1,   255,
    1,   1,   1,   255, 1,   1,   1,   255, 1,   1,   1,   255, 1,   1,   1,   255, 1,   1,   1,   255, 1,   1,   1,   255, 1,   1,   1,   255, 1,
    1,   1,   255, 1,   1,   1,   255, 1,   1,   1,   255, 1,   1,   1,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,
    0,   255, 1,   1,   1,   255, 1,   1,   1,   255, 1,   1,   1,   255, 1,   1,   1,   255, 1,   1,   1,   255, 1,   1,   1,   255, 1,   1,   1,
    255, 1,   1,   1,   255, 1,   1,   1,   255, 1,   1,   1,   255, 1,   1,   1,   255, 1,   1,   1,   255, 1,   1,   1,   255, 1,   1,   1,   255,
    1,   1,   1,   255, 1,   1,   1,   255, 1,   1,   1,   255, 1,   1,   1,   255, 1,   1,   1,   255, 1,   1,   1,   255, 1,   1,   1,   255, 1,
    1,   1,   255, 1,   1,   1,   255, 1,   1,   1,   255, 1,   1,   1,   255, 1,   1,   1,   255, 1,   1,   1,   255, 1,   1,   1,   255, 1,   1,
    1,   255, 1,   1,   1,   255, 1,   1,   1,   255, 1,   1,   1,   255, 1,   1,   1,   255, 1,   1,   1,   255, 1,   1,   1,   255, 1,   1,   1,
    255, 1,   1,   1,   255, 1,   1,   1,   255, 1,   1,   1,   255, 1,   1,   1,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255,
    0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,
    0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,
    0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,
    255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255,
    0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,
    0,   0,   255, 1,   1,   1,   255, 1,   1,   1,   255, 1,   1,   1,   255, 1,   1,   1,   255, 1,   1,   1,   255, 1,   1,   1,   255, 1,   1,
    1,   255, 1,   1,   1,   255, 1,   1,   1,   255, 1,   1,   1,   255, 1,   1,   1,   255, 1,   1,   1,   255, 1,   1,   1,   255, 1,   1,   1,
    255, 1,   1,   1,   255, 1,   1,   1,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255,
    0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 1,   1,   1,   255, 1,   1,   1,   255, 2,   2,   2,   255, 1,
    1,   1,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 1,   1,   1,   255, 0,   0,   0,   255, 1,   1,   1,   255, 3,   3,
    3,   255, 0,   0,   0,   255, 0,   0,   0,   255, 3,   3,   3,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,
    255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255,
    1,   1,   1,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,
    0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,
    0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 1,   1,   1,
    255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255,
    0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,
    0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,
    0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,
    255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255,
    0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,
    0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,
    0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,
    255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255,
    0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,
    0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,
    0,   255, 2,   2,   2,   255, 2,   2,   2,   255, 1,   1,   1,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 1,   1,   1,
    255, 1,   1,   1,   255, 1,   1,   1,   255, 0,   0,   0,   255, 1,   1,   1,   255, 3,   3,   3,   255, 0,   0,   0,   255, 0,   0,   0,   255,
    3,   3,   3,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,
    0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 1,   1,   1,   255, 1,   1,   1,   255, 2,   2,   2,   255, 1,   1,   1,   255, 0,   0,
    0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 1,   1,   1,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,
    255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255,
    0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 1,   1,   1,   255, 2,   2,   2,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,
    0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,
    0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,
    255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255,
    0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,
    0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,
    0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,
    255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255,
    0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,
    0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,
    0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,
    255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 2,   2,   2,   255, 2,   2,   2,   255,
    0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 2,   2,   2,   255, 1,   1,   1,   255, 0,
    0,   0,   255, 1,   1,   1,   255, 3,   3,   3,   255, 0,   0,   0,   255, 0,   0,   0,   255, 3,   3,   3,   255, 0,   0,   0,   255, 0,   0,
    0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,
    255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255,
    0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,
    0,   0,   255, 1,   1,   1,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 1,   1,
    1,   255, 1,   1,   1,   255, 1,   1,   1,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,
    255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255,
    0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,
    0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,
    0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,
    255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255,
    0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,
    0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,
    0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,
    255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255,
    0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,
    0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 1,   1,   1,   255, 0,   0,   0,   255, 0,   0,
    0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 1,   1,   1,   255, 1,   1,   1,   255, 0,   0,   0,   255, 1,   1,   1,   255, 4,   4,   4,
    255, 0,   0,   0,   255, 0,   0,   0,   255, 3,   3,   3,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255,
    0,   0,   0,   255, 1,   1,   1,   255, 1,   1,   1,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,
    0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,
    0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,
    255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255,
    0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,
    0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,
    0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,
    255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255,
    0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,
    0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 1,   1,   1,   255, 1,   1,   1,   255, 1,   1,   1,   255, 1,   1,
    1,   255, 1,   1,   1,   255, 1,   1,   1,   255, 1,   1,   1,   255, 1,   1,   1,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,
    255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255,
    0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,
    0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 1,   1,
    1,   255, 1,   1,   1,   255, 1,   1,   1,   255, 1,   1,   1,   255, 1,   1,   1,   255, 1,   1,   1,   255, 1,   1,   1,   255, 1,   1,   1,
    255, 0,   0,   0,   255, 1,   1,   1,   255, 5,   5,   5,   255, 5,   5,   5,   255, 2,   2,   2,   255, 0,   0,   0,   255, 0,   0,   0,   255,
    1,   1,   1,   255, 2,   2,   2,   255, 0,   0,   0,   255, 2,   2,   2,   255, 5,   5,   5,   255, 0,   0,   0,   255, 1,   1,   1,   255, 4,
    4,   4,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 2,   2,   2,   255, 3,   3,   3,   255, 3,   3,
    3,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 1,   1,   1,
    255, 2,   2,   2,   255, 1,   1,   1,   255, 0,   0,   0,   255, 3,   3,   3,   255, 3,   3,   3,   255, 2,   2,   2,   255, 1,   1,   1,   255,
    0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 4,   4,   4,   255, 2,   2,   2,   255, 1,   1,   1,   255, 2,
    2,   2,   255, 3,   3,   3,   255, 2,   2,   2,   255, 0,   0,   0,   255, 0,   0,   0,   255, 1,   1,   1,   255, 1,   1,   1,   255, 1,   1,
    1,   255, 1,   1,   1,   255, 1,   1,   1,   255, 1,   1,   1,   255, 1,   1,   1,   255, 1,   1,   1,   255, 1,   1,   1,   255, 1,   1,   1,
    255, 1,   1,   1,   255, 1,   1,   1,   255, 1,   1,   1,   255, 1,   1,   1,   255, 1,   1,   1,   255, 1,   1,   1,   255, 1,   1,   1,   255,
    1,   1,   1,   255, 1,   1,   1,   255, 1,   1,   1,   255, 1,   1,   1,   255, 1,   1,   1,   255, 1,   1,   1,   255, 1,   1,   1,   255, 1,
    1,   1,   255, 1,   1,   1,   255, 1,   1,   1,   255, 1,   1,   1,   255, 1,   1,   1,   255, 1,   1,   1,   255, 1,   1,   1,   255, 1,   1,
    1,   255, 1,   1,   1,   255, 1,   1,   1,   255, 1,   1,   1,   255, 1,   1,   1,   255, 1,   1,   1,   255, 1,   1,   1,   255, 1,   1,   1,
    255, 1,   1,   1,   255, 2,   2,   2,   255, 2,   2,   2,   255, 2,   2,   2,   255, 2,   2,   2,   255, 2,   2,   2,   255, 2,   2,   2,   255,
    2,   2,   2,   255, 2,   2,   2,   255, 1,   1,   1,   255, 1,   1,   1,   255, 1,   1,   1,   255, 1,   1,   1,   255, 1,   1,   1,   255, 1,
    1,   1,   255, 1,   1,   1,   255, 1,   1,   1,   255, 1,   1,   1,   255, 1,   1,   1,   255, 1,   1,   1,   255, 1,   1,   1,   255, 1,   1,
    1,   255, 1,   1,   1,   255, 1,   1,   1,   255, 1,   1,   1,   255, 1,   1,   1,   255, 1,   1,   1,   255, 1,   1,   1,   255, 1,   1,   1,
    255, 1,   1,   1,   255, 1,   1,   1,   255, 1,   1,   1,   255, 1,   1,   1,   255, 1,   1,   1,   255, 1,   1,   1,   255, 1,   1,   1,   255,
    1,   1,   1,   255, 1,   1,   1,   255, 1,   1,   1,   255, 1,   1,   1,   255, 1,   1,   1,   255, 0,   0,   0,   255, 5,   5,   5,   255, 10,
    10,  10,  255, 10,  10,  10,  255, 7,   7,   7,   255, 3,   3,   3,   255, 2,   2,   2,   255, 4,   4,   4,   255, 4,   4,   4,   255, 0,   0,
    0,   255, 4,   4,   4,   255, 6,   6,   6,   255, 1,   1,   1,   255, 3,   3,   3,   255, 6,   6,   6,   255, 1,   1,   1,   255, 2,   2,   2,
    255, 1,   1,   1,   255, 1,   1,   1,   255, 3,   3,   3,   255, 6,   6,   6,   255, 5,   5,   5,   255, 2,   2,   2,   255, 0,   0,   0,   255,
    4,   4,   4,   255, 2,   2,   2,   255, 1,   1,   1,   255, 3,   3,   3,   255, 6,   6,   6,   255, 7,   7,   7,   255, 6,   6,   6,   255, 4,
    4,   4,   255, 4,   4,   4,   255, 4,   4,   4,   255, 4,   4,   4,   255, 3,   3,   3,   255, 2,   2,   2,   255, 1,   1,   1,   255, 0,   0,
    0,   255, 0,   0,   0,   255, 7,   7,   7,   255, 5,   5,   5,   255, 4,   4,   4,   255, 5,   5,   5,   255, 6,   6,   6,   255, 6,   6,   6,
    255, 2,   2,   2,   255, 0,   0,   0,   255, 1,   1,   1,   255, 1,   1,   1,   255, 1,   1,   1,   255, 1,   1,   1,   255, 1,   1,   1,   255,
    1,   1,   1,   255, 1,   1,   1,   255, 1,   1,   1,   255, 1,   1,   1,   255, 1,   1,   1,   255, 1,   1,   1,   255, 1,   1,   1,   255, 1,
    1,   1,   255, 1,   1,   1,   255, 1,   1,   1,   255, 1,   1,   1,   255, 1,   1,   1,   255, 1,   1,   1,   255, 1,   1,   1,   255, 1,   1,
    1,   255, 1,   1,   1,   255, 1,   1,   1,   255, 1,   1,   1,   255, 1,   1,   1,   255, 1,   1,   1,   255, 1,   1,   1,   255, 1,   1,   1,
    255, 1,   1,   1,   255, 1,   1,   1,   255, 1,   1,   1,   255, 1,   1,   1,   255, 1,   1,   1,   255, 1,   1,   1,   255, 1,   1,   1,   255,
    1,   1,   1,   255, 1,   1,   1,   255, 1,   1,   1,   255, 1,   1,   1,   255, 1,   1,   1,   255, 1,   1,   1,   255, 3,   3,   3,   255, 3,
    3,   3,   255, 3,   3,   3,   255, 3,   3,   3,   255, 3,   3,   3,   255, 3,   3,   3,   255, 3,   3,   3,   255, 3,   3,   3,   255, 2,   2,
    2,   255, 2,   2,   2,   255, 2,   2,   2,   255, 2,   2,   2,   255, 2,   2,   2,   255, 2,   2,   2,   255, 2,   2,   2,   255, 2,   2,   2,
    255, 2,   2,   2,   255, 2,   2,   2,   255, 2,   2,   2,   255, 2,   2,   2,   255, 2,   2,   2,   255, 2,   2,   2,   255, 2,   2,   2,   255,
    2,   2,   2,   255, 2,   2,   2,   255, 2,   2,   2,   255, 2,   2,   2,   255, 2,   2,   2,   255, 2,   2,   2,   255, 2,   2,   2,   255, 2,
    2,   2,   255, 2,   2,   2,   255, 1,   1,   1,   255, 1,   1,   1,   255, 1,   1,   1,   255, 1,   1,   1,   255, 1,   1,   1,   255, 1,   1,
    1,   255, 1,   1,   1,   255, 1,   1,   1,   255, 1,   1,   1,   255, 6,   6,   6,   255, 11,  11,  11,  255, 10,  10,  10,  255, 6,   6,   6,
    255, 3,   3,   3,   255, 3,   3,   3,   255, 6,   6,   6,   255, 6,   6,   6,   255, 2,   2,   2,   255, 5,   5,   5,   255, 8,   8,   8,   255,
    3,   3,   3,   255, 4,   4,   4,   255, 7,   7,   7,   255, 2,   2,   2,   255, 4,   4,   4,   255, 2,   2,   2,   255, 2,   2,   2,   255, 5,
    5,   5,   255, 8,   8,   8,   255, 8,   8,   8,   255, 3,   3,   3,   255, 0,   0,   0,   255, 7,   7,   7,   255, 5,   5,   5,   255, 3,   3,
    3,   255, 5,   5,   5,   255, 8,   8,   8,   255, 10,  10,  10,  255, 9,   9,   9,   255, 6,   6,   6,   255, 4,   4,   4,   255, 4,   4,   4,
    255, 4,   4,   4,   255, 4,   4,   4,   255, 4,   4,   4,   255, 4,   4,   4,   255, 4,   4,   4,   255, 4,   4,   4,   255, 4,   4,   4,   255,
    2,   2,   2,   255, 2,   2,   2,   255, 4,   4,   4,   255, 7,   7,   7,   255, 7,   7,   7,   255, 4,   4,   4,   255, 0,   0,   0,   255, 1,
    1,   1,   255, 1,   1,   1,   255, 1,   1,   1,   255, 1,   1,   1,   255, 1,   1,   1,   255, 1,   1,   1,   255, 1,   1,   1,   255, 1,   1,
    1,   255, 1,   1,   1,   255, 1,   1,   1,   255, 1,   1,   1,   255, 1,   1,   1,   255, 1,   1,   1,   255, 1,   1,   1,   255, 1,   1,   1,
    255, 1,   1,   1,   255, 1,   1,   1,   255, 1,   1,   1,   255, 1,   1,   1,   255, 1,   1,   1,   255, 1,   1,   1,   255, 1,   1,   1,   255,
    1,   1,   1,   255, 1,   1,   1,   255, 1,   1,   1,   255, 1,   1,   1,   255, 1,   1,   1,   255, 1,   1,   1,   255, 1,   1,   1,   255, 1,
    1,   1,   255, 1,   1,   1,   255, 1,   1,   1,   255, 1,   1,   1,   255, 1,   1,   1,   255, 1,   1,   1,   255, 1,   1,   1,   255, 1,   1,
    1,   255, 1,   1,   1,   255, 1,   1,   1,   255, 1,   1,   1,   255, 4,   4,   4,   255, 4,   4,   4,   255, 4,   4,   4,   255, 4,   4,   4,
    255, 4,   4,   4,   255, 4,   4,   4,   255, 4,   4,   4,   255, 4,   4,   4,   255, 3,   3,   3,   255, 3,   3,   3,   255, 3,   3,   3,   255,
    3,   3,   3,   255, 3,   3,   3,   255, 3,   3,   3,   255, 3,   3,   3,   255, 3,   3,   3,   255, 2,   2,   2,   255, 2,   2,   2,   255, 2,
    2,   2,   255, 2,   2,   2,   255, 2,   2,   2,   255, 2,   2,   2,   255, 2,   2,   2,   255, 2,   2,   2,   255, 2,   2,   2,   255, 2,   2,
    2,   255, 2,   2,   2,   255, 2,   2,   2,   255, 2,   2,   2,   255, 2,   2,   2,   255, 2,   2,   2,   255, 2,   2,   2,   255, 1,   1,   1,
    255, 1,   1,   1,   255, 1,   1,   1,   255, 1,   1,   1,   255, 1,   1,   1,   255, 1,   1,   1,   255, 1,   1,   1,   255, 1,   1,   1,   255,
    1,   1,   1,   255, 5,   5,   5,   255, 8,   8,   8,   255, 7,   7,   7,   255, 2,   2,   2,   255, 0,   0,   0,   255, 2,   2,   2,   255, 6,
    6,   6,   255, 7,   7,   7,   255, 3,   3,   3,   255, 6,   6,   6,   255, 9,   9,   9,   255, 4,   4,   4,   255, 5,   5,   5,   255, 8,   8,
    8,   255, 3,   3,   3,   255, 5,   5,   5,   255, 3,   3,   3,   255, 3,   3,   3,   255, 6,   6,   6,   255, 9,   9,   9,   255, 9,   9,   9,
    255, 4,   4,   4,   255, 0,   0,   0,   255, 7,   7,   7,   255, 4,   4,   4,   255, 3,   3,   3,   255, 5,   5,   5,   255, 9,   9,   9,   255,
    11,  11,  11,  255, 9,   9,   9,   255, 6,   6,   6,   255, 2,   2,   2,   255, 3,   3,   3,   255, 3,   3,   3,   255, 4,   4,   4,   255, 5,
    5,   5,   255, 6,   6,   6,   255, 7,   7,   7,   255, 7,   7,   7,   255, 0,   0,   0,   255, 0,   0,   0,   255, 0,   0,   0,   255, 1,   1,
    1,   255, 5,   5,   5,   255, 6,   6,   6,   255, 3,   3,   3,   255, 0,   0,   0,   255, 1,   1,   1,   255, 1,   1,   1,   255, 1,   1,   1,
    255, 1,   1,   1,   255, 1,   1,   1,   255, 1,   1,   1,   255, 1,   1,   1,   255, 1,   1,   1,   255, 1,   1,   1,   255, 1,   1,   1,   255,
    1,   1,   1,   255, 1,   1,   1,   255, 1,   1,   1,   255, 1,   1,   1,   255, 1,   1,   1,   255, 1,   1,   1,   255, 1,   1,   1,   255, 1,
    1,   1,   255, 1,   1,   1,   255, 1,   1,   1,   255, 1,   1,   1,   255, 1,   1,   1,   255, 1,   1,   1,   255, 1,   1,   1,   255, 1,   1,
    1,   255, 1,   1,   1,   255, 1,   1,   1,   255, 1,   1,   1,   255, 1,   1,   1,   255, 1,   1,   1,   255, 1,   1,   1,   255, 1,   1,   1,
    255, 1,   1,   1,   255, 1,   1,   1,   255, 1,   1,   1,   255, 1,   1,   1,   255, 1,   1,   1,   255, 1,   1,   1,   255, 1,   1,   1,   255,
    1,   1,   1,   255, 6,   6,   6,   255, 5,   5,   5,   255, 5,   5,   5,   255, 4,   4,   4,   255, 4,   4,   4,   255, 5,   5,   5,   255, 5,
    5,   5,   255, 6,   6,   6,   255, 5,   5,   5,   255, 5,   5,   5,   255, 5,   5,   5,   255, 5,   5,   5,   255, 5,   5,   5,   255, 5,   5,
    5,   255, 5,   5,   5,   255, 5,   5,   5,   255, 6,   6,   6,   255, 6,   6,   6,   255, 7,   7,   7,   255, 7,   7,   7,   255, 7,   7,   7,
    255, 6,   6,   6,   255, 5,   5,   5,   255, 5,   5,   5,   255, 3,   3,   3,   255, 3,   3,   3,   255, 3,   3,   3,   255, 3,   3,   3,   255,
    3,   3,   3,   255, 3,   3,   3,   255, 3,   3,   3,   255, 3,   3,   3,   255, 5,   5,   5,   255, 5,   5,   5,   255, 5,   5,   5,   255, 5,
    5,   5,   255, 5,   5,   5,   255, 5,   5,   5,   255, 5,   5,   5,   255, 5,   5,   5,   255, 4,   4,   4,   255, 7,   7,   7,   255, 9,   9,
    9,   255, 7,   7,   7,   255, 3,   3,   3,   255, 1,   1,   1,   255, 3,   3,   3,   255, 6,   6,   6,   255, 1,   1,   1,   255, 3,   3,   3,
    255, 6,   6,   6,   255, 6,   6,   6,   255, 5,   5,   5,   255, 4,   4,   4,   255, 4,   4,   4,   255, 4,   4,   4,   255, 5,   5,   5,   255,
    9,   9,   9,   255, 9,   9,   9,   255, 6,   6,   6,   255, 6,   6,   6,   255, 10,  10,  10,  255, 10,  10,  10,  255, 7,   7,   7,   255, 3,
    3,   3,   255, 3,   3,   3,   255, 4,   4,   4,   255, 6,   6,   6,   255, 8,   8,   8,   255, 8,   8,   8,   255, 6,   6,   6,   255, 4,   4,
    4,   255, 15,  15,  15,  255, 11,  11,  11,  255, 5,   5,   5,   255, 1,   1,   1,   255, 0,   0,   0,   255, 3,   3,   3,   255, 7,   7,   7,
    255, 10,  10,  10,  255, 7,   7,   7,   255, 6,   6,   6,   255, 6,   6,   6,   255, 5,   5,   5,   255, 4,   4,   4,   255, 4,   4,   4,   255,
    3,   3,   3,   255, 3,   3,   3,   255, 2,   2,   2,   255, 2,   2,   2,   255, 2,   2,   2,   255, 2,   2,   2,   255, 2,   2,   2,   255, 2,
    2,   2,   255, 2,   2,   2,   255, 2,   2,   2,   255, 2,   2,   2,   255, 2,   2,   2,   255, 1,   1,   1,   255, 1,   1,   1,   255, 1,   1,
    1,   255, 1,   1,   1,   255, 2,   2,   2,   255, 2,   2,   2,   255, 2,   2,   2,   255, 2,   2,   2,   255, 2,   2,   2,   255, 2,   2,   2,
    255, 2,   2,   2,   255, 2,   2,   2,   255, 2,   2,   2,   255, 2,   2,   2,   255, 2,   2,   2,   255, 2,   2,   2,   255, 2,   2,   2,   255,
    2,   2,   2,   255, 2,   2,   2,   255, 2,   2,   2,   255, 2,   2,   2,   255, 2,   2,   2,   255, 2,   2,   2,   255, 2,   2,   2,   255, 2,
    2,   2,   255, 2,   2,   2,   255, 1,   1,   1,   255, 1,   1,   1,   255, 1,   1,   1,   255, 1,   1,   1,   255, 8,   8,   8,   255, 8,   8,
    8,   255, 7,   7,   7,   255, 7,   7,   7,   255, 7,   7,   7,   255, 7,   7,   7,   255, 8,   8,   8,   255, 8,   8,   8,   255, 8,   8,   8,
    255, 8,   8,   8,   255, 8,   8,   8,   255, 8,   8,   8,   255, 8,   8,   8,   255, 8,   8,   8,   255, 8,   8,   8,   255, 8,   8,   8,   255,
    7,   7,   7,   255, 8,   8,   8,   255, 8,   8,   8,   255, 8,   8,   8,   255, 8,   8,   8,   255, 7,   7,   7,   255, 7,   7,   7,   255, 6,
    6,   6,   255, 6,   6,   6,   255, 6,   6,   6,   255, 6,   6,   6,   255, 6,   6,   6,   255, 6,   6,   6,   255, 6,   6,   6,   255, 6,   6,
    6,   255, 6,   6,   6,   255, 5,   5,   5,   255, 5,   5,   5,   255, 5,   5,   5,   255, 5,   5,   5,   255, 5,   5,   5,   255, 5,   5,   5,
    255, 5,   5,   5,   255, 5,   5,   5,   255, 6,   6,   6,   255, 8,   8,   8,   255, 10,  10,  10,  255, 9,   9,   9,   255, 5,   5,   5,   255,
    3,   3,   3,   255, 5,   5,   5,   255, 8,   8,   8,   255, 4,   4,   4,   255, 6,   6,   6,   255, 7,   7,   7,   255, 8,   8,   8,   255, 7,
    7,   7,   255, 5,   5,   5,   255, 5,   5,   5,   255, 6,   6,   6,   255, 3,   3,   3,   255, 6,   6,   6,   255, 7,   7,   7,   255, 4,   4,
    4,   255, 4,   4,   4,   255, 7,   7,   7,   255, 8,   8,   8,   255, 5,   5,   5,   255, 2,   2,   2,   255, 2,   2,   2,   255, 2,   2,   2,
    255, 4,   4,   4,   255, 6,   6,   6,   255, 6,   6,   6,   255, 4,   4,   4,   255, 3,   3,   3,   255, 9,   9,   9,   255, 8,   8,   8,   255,
    5,   5,   5,   255, 3,   3,   3,   255, 2,   2,   2,   255, 3,   3,   3,   255, 4,   4,   4,   255, 6,   6,   6,   255, 8,   8,   8,   255, 7,
    7,   7,   255, 7,   7,   7,   255, 6,   6,   6,   255, 6,   6,   6,   255, 5,   5,   5,   255, 4,   4,   4,   255, 4,   4,   4,   255, 2,   2,
    2,   255, 2,   2,   2,   255, 2,   2,   2,   255, 2,   2,   2,   255, 2,   2,   2,   255, 2,   2,   2,   255, 2,   2,   2,   255, 2,   2,   2,
    255, 2,   2,   2,   255, 2,   2,   2,   255, 1,   1,   1,   255, 1,   1,   1,   255, 1,   1,   1,   255, 1,   1,   1,   255, 2,   2,   2,   255,
    2,   2,   2,   255, 3,   3,   3,   255, 3,   3,   3,   255, 3,   3,   3,   255, 3,   3,   3,   255, 3,   3,   3,   255, 3,   3,   3,   255, 3,
    3,   3,   255, 3,   3,   3,   255, 3,   3,   3,   255, 3,   3,   3,   255, 3,   3,   3,   255, 3,   3,   3,   255, 3,   3,   3,   255, 3,   3,
    3,   255, 3,   3,   3,   255, 3,   3,   3,   255, 3,   3,   3,   255, 3,   3,   3,   255, 2,   2,   2,   255, 2,   2,   2,   255, 2,   2,   2,
    255, 2,   2,   2,   255, 1,   1,   1,   255, 1,   1,   1,   255, 12,  12,  12,  255, 11,  11,  11,  255, 11,  11,  11,  255, 10,  10,  10,  255,
    10,  10,  10,  255, 11,  11,  11,  255, 11,  11,  11,  255, 12,  12,  12,  255, 12,  12,  12,  255, 12,  12,  12,  255, 12,  12,  12,  255, 12,
    12,  12,  255, 12,  12,  12,  255, 12,  12,  12,  255, 12,  12,  12,  255, 12,  12,  12,  255, 10,  10,  10,  255, 10,  10,  10,  255, 10,  10,
    10,  255, 11,  11,  11,  255, 10,  10,  10,  255, 10,  10,  10,  255, 9,   9,   9,   255, 8,   8,   8,   255, 5,   5,   5,   255, 5,   5,   5,
    255, 5,   5,   5,   255, 5,   5,   5,   255, 5,   5,   5,   255, 5,   5,   5,   255, 5,   5,   5,   255, 5,   5,   5,   255, 5,   5,   5,   255,
    5,   5,   5,   255, 5,   5,   5,   255, 5,   5,   5,   255, 5,   5,   5,   255, 5,   5,   5,   255, 5,   5,   5,   255, 5,   5,   5,   255, 4,
    4,   4,   255, 6,   6,   6,   255, 7,   7,   7,   255, 6,   6,   6,   255, 3,   3,   3,   255, 1,   1,   1,   255, 3,   3,   3,   255, 5,   5,
    5,   255, 2,   2,   2,   255, 4,   4,   4,   255, 5,   5,   5,   255, 5,   5,   5,   255, 4,   4,   4,   255, 3,   3,   3,   255, 3,   3,   3,
    255, 3,   3,   3,   255, 2,   2,   2,   255, 4,   4,   4,   255, 4,   4,   4,   255, 3,   3,   3,   255, 3,   3,   3,   255, 5,   5,   5,   255,
    5,   5,   5,   255, 4,   4,   4,   255, 3,   3,   3,   255, 2,   2,   2,   255, 1,   1,   1,   255, 2,   2,   2,   255, 4,   4,   4,   255, 4,
    4,   4,   255, 3,   3,   3,   255, 2,   2,   2,   255, 4,   4,   4,   255, 5,   5,   5,   255, 5,   5,   5,   255, 5,   5,   5,   255, 4,   4,
    4,   255, 4,   4,   4,   255, 3,   3,   3,   255, 3,   3,   3,   255, 4,   4,   4,   255, 4,   4,   4,   255, 3,   3,   3,   255, 3,   3,   3,
    255, 2,   2,   2,   255, 2,   2,   2,   255, 1,   1,   1,   255, 1,   1,   1,   255, 3,   3,   3,   255, 3,   3,   3,   255, 3,   3,   3,   255,
    3,   3,   3,   255, 3,   3,   3,   255, 3,   3,   3,   255, 3,   3,   3,   255, 3,   3,   3,   255, 3,   3,   3,   255, 3,   3,   3,   255, 2,
    2,   2,   255, 2,   2,   2,   255, 2,   2,   2,   255, 2,   2,   2,   255, 3,   3,   3,   255, 3,   3,   3,   255, 4,   4,   4,   255, 4,   4,
    4,   255, 4,   4,   4,   255, 4,   4,   4,   255, 4,   4,   4,   255, 4,   4,   4,   255, 4,   4,   4,   255, 4,   4,   4,   255, 4,   4,   4,
    255, 4,   4,   4,   255, 4,   4,   4,   255, 4,   4,   4,   255, 4,   4,   4,   255, 4,   4,   4,   255, 4,   4,   4,   255, 4,   4,   4,   255,
    4,   4,   4,   255, 4,   4,   4,   255, 3,   3,   3,   255, 3,   3,   3,   255, 3,   3,   3,   255, 3,   3,   3,   255, 2,   2,   2,   255, 2,
    2,   2,   255, 15,  15,  15,  255, 14,  14,  14,  255, 14,  14,  14,  255, 14,  14,  14,  255, 14,  14,  14,  255, 14,  14,  14,  255, 14,  14,
    14,  255, 15,  15,  15,  255, 15,  15,  15,  255, 15,  15,  15,  255, 15,  15,  15,  255, 15,  15,  15,  255, 15,  15,  15,  255, 15,  15,  15,
    255, 15,  15,  15,  255, 15,  15,  15,  255, 13,  13,  13,  255, 13,  13,  13,  255, 14,  14,  14,  255, 14,  14,  14,  255, 14,  14,  14,  255,
    13,  13,  13,  255, 12,  12,  12,  255, 12,  12,  12,  255, 7,   7,   7,   255, 7,   7,   7,   255, 7,   7,   7,   255, 7,   7,   7,   255, 7,
    7,   7,   255, 7,   7,   7,   255, 7,   7,   7,   255, 7,   7,   7,   255, 8,   8,   8,   255, 8,   8,   8,   255, 8,   8,   8,   255, 8,   8,
    8,   255, 8,   8,   8,   255, 8,   8,   8,   255, 8,   8,   8,   255, 8,   8,   8,   255, 6,   6,   6,   255, 7,   7,   7,   255, 8,   8,   8,
    255, 7,   7,   7,   255, 4,   4,   4,   255, 3,   3,   3,   255, 4,   4,   4,   255, 5,   5,   5,   255, 4,   4,   4,   255, 5,   5,   5,   255,
    6,   6,   6,   255, 6,   6,   6,   255, 4,   4,   4,   255, 3,   3,   3,   255, 4,   4,   4,   255, 5,   5,   5,   255, 4,   4,   4,   255, 5,
    5,   5,   255, 5,   5,   5,   255, 5,   5,   5,   255, 5,   5,   5,   255, 6,   6,   6,   255, 6,   6,   6,   255, 6,   6,   6,   255, 7,   7,
    7,   255, 5,   5,   5,   255, 4,   4,   4,   255, 4,   4,   4,   255, 5,   5,   5,   255, 6,   6,   6,   255, 5,   5,   5,   255, 5,   5,   5,
    255, 5,   5,   5,   255, 5,   5,   5,   255, 6,   6,   6,   255, 6,   6,   6,   255, 6,   6,   6,   255, 5,   5,   5,   255, 5,   5,   5,   255,
    4,   4,   4,   255, 3,   3,   3,   255, 3,   3,   3,   255, 3,   3,   3,   255, 3,   3,   3,   255, 2,   2,   2,   255, 2,   2,   2,   255, 2,
    2,   2,   255, 1,   1,   1,   255, 4,   4,   4,   255, 4,   4,   4,   255, 4,   4,   4,   255, 4,   4,   4,   255, 4,   4,   4,   255, 4,   4,
    4,   255, 4,   4,   4,   255, 4,   4,   4,   255, 4,   4,   4,   255, 4,   4,   4,   255, 3,   3,   3,   255, 3,   3,   3,   255, 3,   3,   3,
    255, 3,   3,   3,   255, 4,   4,   4,   255, 4,   4,   4,   255, 6,   6,   6,   255, 6,   6,   6,   255, 6,   6,   6,   255, 6,   6,   6,   255,
    6,   6,   6,   255, 6,   6,   6,   255, 6,   6,   6,   255, 6,   6,   6,   255, 5,   5,   5,   255, 5,   5,   5,   255, 5,   5,   5,   255, 5,
    5,   5,   255, 5,   5,   5,   255, 5,   5,   5,   255, 5,   5,   5,   255, 5,   5,   5,   255, 5,   5,   5,   255, 5,   5,   5,   255, 5,   5,
    5,   255, 4,   4,   4,   255, 4,   4,   4,   255, 4,   4,   4,   255, 4,   4,   4,   255, 4,   4,   4,   255, 17,  17,  17,  255, 17,  17,  17,
    255, 17,  17,  17,  255, 16,  16,  16,  255, 16,  16,  16,  255, 17,  17,  17,  255, 17,  17,  17,  255, 17,  17,  17,  255, 18,  18,  18,  255,
    18,  18,  18,  255, 18,  18,  18,  255, 18,  18,  18,  255, 18,  18,  18,  255, 18,  18,  18,  255, 18,  18,  18,  255, 18,  18,  18,  255, 17,
    17,  17,  255, 17,  17,  17,  255, 17,  17,  17,  255, 17,  17,  17,  255, 17,  17,  17,  255, 16,  16,  16,  255, 16,  16,  16,  255, 15,  15,
    15,  255, 15,  15,  15,  255, 15,  15,  15,  255, 15,  15,  15,  255, 15,  15,  15,  255, 15,  15,  15,  255, 15,  15,  15,  255, 15,  15,  15,
    255, 15,  15,  15,  255, 13,  13,  13,  255, 13,  13,  13,  255, 13,  13,  13,  255, 13,  13,  13,  255, 13,  13,  13,  255, 13,  13,  13,  255,
    13,  13,  13,  255, 13,  13,  13,  255, 13,  13,  13,  255, 14,  14,  14,  255, 14,  14,  14,  255, 13,  13,  13,  255, 12,  12,  12,  255, 11,
    11,  11,  255, 11,  11,  11,  255, 12,  12,  12,  255, 11,  11,  11,  255, 12,  12,  12,  255, 13,  13,  13,  255, 12,  12,  12,  255, 11,  11,
    11,  255, 11,  11,  11,  255, 12,  12,  12,  255, 13,  13,  13,  255, 11,  11,  11,  255, 10,  10,  10,  255, 10,  10,  10,  255, 11,  11,  11,
    255, 12,  12,  12,  255, 11,  11,  11,  255, 11,  11,  11,  255, 12,  12,  12,  255, 13,  13,  13,  255, 12,  12,  12,  255, 10,  10,  10,  255,
    10,  10,  10,  255, 10,  10,  10,  255, 11,  11,  11,  255, 10,  10,  10,  255, 9,   9,   9,   255, 10,  10,  10,  255, 9,   9,   9,   255, 8,
    8,   8,   255, 8,   8,   8,   255, 7,   7,   7,   255, 8,   8,   8,   255, 9,   9,   9,   255, 9,   9,   9,   255, 9,   9,   9,   255, 9,   9,
    9,   255, 8,   8,   8,   255, 8,   8,   8,   255, 8,   8,   8,   255, 8,   8,   8,   255, 8,   8,   8,   255, 8,   8,   8,   255, 7,   7,   7,
    255, 7,   7,   7,   255, 7,   7,   7,   255, 7,   7,   7,   255, 7,   7,   7,   255, 7,   7,   7,   255, 7,   7,   7,   255, 7,   7,   7,   255,
    6,   6,   6,   255, 6,   6,   6,   255, 6,   6,   6,   255, 5,   5,   5,   255, 5,   5,   5,   255, 6,   6,   6,   255, 6,   6,   6,   255, 6,
    6,   6,   255, 7,   7,   7,   255, 7,   7,   7,   255, 7,   7,   7,   255, 7,   7,   7,   255, 7,   7,   7,   255, 7,   7,   7,   255, 7,   7,
    7,   255, 7,   7,   7,   255, 6,   6,   6,   255, 6,   6,   6,   255, 6,   6,   6,   255, 6,   6,   6,   255, 6,   6,   6,   255, 6,   6,   6,
    255, 6,   6,   6,   255, 6,   6,   6,   255, 6,   6,   6,   255, 6,   6,   6,   255, 6,   6,   6,   255, 6,   6,   6,   255, 6,   6,   6,   255,
    5,   5,   5,   255, 5,   5,   5,   255, 5,   5,   5,   255, 21,  21,  21,  255, 20,  20,  20,  255, 20,  20,  20,  255, 19,  19,  19,  255, 19,
    19,  19,  255, 20,  20,  20,  255, 20,  20,  20,  255, 21,  21,  21,  255, 20,  20,  20,  255, 20,  20,  20,  255, 20,  20,  20,  255, 20,  20,
    20,  255, 20,  20,  20,  255, 20,  20,  20,  255, 20,  20,  20,  255, 20,  20,  20,  255, 20,  20,  20,  255, 20,  20,  20,  255, 20,  20,  20,
    255, 20,  20,  20,  255, 20,  20,  20,  255, 20,  20,  20,  255, 19,  19,  19,  255, 18,  18,  18,  255, 18,  18,  18,  255, 18,  18,  18,  255,
    18,  18,  18,  255, 18,  18,  18,  255, 18,  18,  18,  255, 18,  18,  18,  255, 18,  18,  18,  255, 18,  18,  18,  255, 17,  17,  17,  255, 17,
    17,  17,  255, 17,  17,  17,  255, 17,  17,  17,  255, 17,  17,  17,  255, 17,  17,  17,  255, 17,  17,  17,  255, 17,  17,  17,  255, 17,  17,
    17,  255, 17,  17,  17,  255, 17,  17,  17,  255, 16,  16,  16,  255, 16,  16,  16,  255, 15,  15,  15,  255, 15,  15,  15,  255, 15,  15,  15,
    255, 14,  14,  14,  255, 15,  15,  15,  255, 15,  15,  15,  255, 15,  15,  15,  255, 14,  14,  14,  255, 14,  14,  14,  255, 16,  16,  16,  255,
    18,  18,  18,  255, 19,  19,  19,  255, 17,  17,  17,  255, 17,  17,  17,  255, 19,  19,  19,  255, 20,  20,  20,  255, 18,  18,  18,  255, 18,
    18,  18,  255, 20,  20,  20,  255, 20,  20,  20,  255, 19,  19,  19,  255, 18,  18,  18,  255, 17,  17,  17,  255, 18,  18,  18,  255, 17,  17,
    17,  255, 16,  16,  16,  255, 14,  14,  14,  255, 15,  15,  15,  255, 14,  14,  14,  255, 12,  12,  12,  255, 10,  10,  10,  255, 10,  10,  10,
    255, 11,  11,  11,  255, 12,  12,  12,  255, 13,  13,  13,  255, 10,  10,  10,  255, 10,  10,  10,  255, 10,  10,  10,  255, 10,  10,  10,  255,
    10,  10,  10,  255, 10,  10,  10,  255, 10,  10,  10,  255, 10,  10,  10,  255, 9,   9,   9,   255, 9,   9,   9,   255, 9,   9,   9,   255, 9,
    9,   9,   255, 9,   9,   9,   255, 9,   9,   9,   255, 9,   9,   9,   255, 9,   9,   9,   255, 9,   9,   9,   255, 9,   9,   9,   255, 8,   8,
    8,   255, 8,   8,   8,   255, 8,   8,   8,   255, 8,   8,   8,   255, 9,   9,   9,   255, 9,   9,   9,   255, 9,   9,   9,   255, 9,   9,   9,
    255, 9,   9,   9,   255, 9,   9,   9,   255, 9,   9,   9,   255, 9,   9,   9,   255, 9,   9,   9,   255, 9,   9,   9,   255, 8,   8,   8,   255,
    8,   8,   8,   255, 8,   8,   8,   255, 8,   8,   8,   255, 8,   8,   8,   255, 8,   8,   8,   255, 8,   8,   8,   255, 8,   8,   8,   255, 8,
    8,   8,   255, 8,   8,   8,   255, 7,   7,   7,   255, 7,   7,   7,   255, 7,   7,   7,   255, 7,   7,   7,   255, 6,   6,   6,   255, 6,   6,
    6,   255, 24,  24,  24,  255, 24,  24,  24,  255, 23,  23,  23,  255, 23,  23,  23,  255, 23,  23,  23,  255, 23,  23,  23,  255, 24,  24,  24,
    255, 24,  24,  24,  255, 22,  22,  22,  255, 22,  22,  22,  255, 22,  22,  22,  255, 22,  22,  22,  255, 22,  22,  22,  255, 22,  22,  22,  255,
    22,  22,  22,  255, 22,  22,  22,  255, 22,  22,  22,  255, 22,  22,  22,  255, 23,  23,  23,  255, 23,  23,  23,  255, 23,  23,  23,  255, 22,
    22,  22,  255, 21,  21,  21,  255, 21,  21,  21,  255, 19,  19,  19,  255, 19,  19,  19,  255, 19,  19,  19,  255, 19,  19,  19,  255, 19,  19,
    19,  255, 19,  19,  19,  255, 19,  19,  19,  255, 19,  19,  19,  255, 20,  20,  20,  255, 20,  20,  20,  255, 20,  20,  20,  255, 20,  20,  20,
    255, 20,  20,  20,  255, 20,  20,  20,  255, 20,  20,  20,  255, 20,  20,  20,  255, 19,  19,  19,  255, 18,  18,  18,  255, 17,  17,  17,  255,
    17,  17,  17,  255, 17,  17,  17,  255, 17,  17,  17,  255, 16,  16,  16,  255, 15,  15,  15,  255, 14,  14,  14,  255, 15,  15,  15,  255, 15,
    15,  15,  255, 15,  15,  15,  255, 15,  15,  15,  255, 16,  16,  16,  255, 18,  18,  18,  255, 20,  20,  20,  255, 26,  26,  26,  255, 23,  23,
    23,  255, 23,  23,  23,  255, 26,  26,  26,  255, 27,  27,  27,  255, 24,  24,  24,  255, 24,  24,  24,  255, 27,  27,  27,  255, 26,  26,  26,
    255, 25,  25,  25,  255, 24,  24,  24,  255, 24,  24,  24,  255, 24,  24,  24,  255, 23,  23,  23,  255, 21,  21,  21,  255, 18,  18,  18,  255,
    17,  17,  17,  255, 16,  16,  16,  255, 15,  15,  15,  255, 13,  13,  13,  255, 13,  13,  13,  255, 13,  13,  13,  255, 13,  13,  13,  255, 13,
    13,  13,  255, 10,  10,  10,  255, 10,  10,  10,  255, 10,  10,  10,  255, 10,  10,  10,  255, 10,  10,  10,  255, 10,  10,  10,  255, 10,  10,
    10,  255, 11,  11,  11,  255, 11,  11,  11,  255, 11,  11,  11,  255, 11,  11,  11,  255, 11,  11,  11,  255, 11,  11,  11,  255, 11,  11,  11,
    255, 11,  11,  11,  255, 11,  11,  11,  255, 11,  11,  11,  255, 11,  11,  11,  255, 10,  10,  10,  255, 10,  10,  10,  255, 10,  10,  10,  255,
    10,  10,  10,  255, 11,  11,  11,  255, 11,  11,  11,  255, 10,  10,  10,  255, 10,  10,  10,  255, 10,  10,  10,  255, 10,  10,  10,  255, 10,
    10,  10,  255, 10,  10,  10,  255, 10,  10,  10,  255, 10,  10,  10,  255, 9,   9,   9,   255, 9,   9,   9,   255, 9,   9,   9,   255, 9,   9,
    9,   255, 9,   9,   9,   255, 9,   9,   9,   255, 9,   9,   9,   255, 9,   9,   9,   255, 9,   9,   9,   255, 9,   9,   9,   255, 8,   8,   8,
    255, 8,   8,   8,   255, 8,   8,   8,   255, 8,   8,   8,   255, 7,   7,   7,   255, 7,   7,   7,   255, 27,  27,  27,  255, 26,  26,  26,  255,
    26,  26,  26,  255, 25,  25,  25,  255, 25,  25,  25,  255, 26,  26,  26,  255, 26,  26,  26,  255, 27,  27,  27,  255, 24,  24,  24,  255, 24,
    24,  24,  255, 24,  24,  24,  255, 24,  24,  24,  255, 24,  24,  24,  255, 24,  24,  24,  255, 24,  24,  24,  255, 24,  24,  24,  255, 23,  23,
    23,  255, 24,  24,  24,  255, 24,  24,  24,  255, 24,  24,  24,  255, 24,  24,  24,  255, 23,  23,  23,  255, 23,  23,  23,  255, 22,  22,  22,
    255, 22,  22,  22,  255, 22,  22,  22,  255, 22,  22,  22,  255, 22,  22,  22,  255, 22,  22,  22,  255, 22,  22,  22,  255, 22,  22,  22,  255,
    22,  22,  22,  255, 21,  21,  21,  255, 21,  21,  21,  255, 21,  21,  21,  255, 21,  21,  21,  255, 21,  21,  21,  255, 21,  21,  21,  255, 21,
    21,  21,  255, 21,  21,  21,  255, 23,  23,  23,  255, 22,  22,  22,  255, 21,  21,  21,  255, 21,  21,  21,  255, 21,  21,  21,  255, 21,  21,
    21,  255, 20,  20,  20,  255, 19,  19,  19,  255, 18,  18,  18,  255, 18,  18,  18,  255, 19,  19,  19,  255, 19,  19,  19,  255, 19,  19,  19,
    255, 20,  20,  20,  255, 23,  23,  23,  255, 25,  25,  25,  255, 30,  30,  30,  255, 26,  26,  26,  255, 26,  26,  26,  255, 30,  30,  30,  255,
    30,  30,  30,  255, 27,  27,  27,  255, 27,  27,  27,  255, 31,  31,  31,  255, 28,  28,  28,  255, 28,  28,  28,  255, 28,  28,  28,  255, 28,
    28,  28,  255, 28,  28,  28,  255, 26,  26,  26,  255, 23,  23,  23,  255, 20,  20,  20,  255, 17,  17,  17,  255, 17,  17,  17,  255, 17,  17,
    17,  255, 16,  16,  16,  255, 15,  15,  15,  255, 14,  14,  14,  255, 13,  13,  13,  255, 12,  12,  12,  255, 13,  13,  13,  255, 13,  13,  13,
    255, 13,  13,  13,  255, 14,  14,  14,  255, 14,  14,  14,  255, 14,  14,  14,  255, 14,  14,  14,  255, 14,  14,  14,  255, 13,  13,  13,  255,
    13,  13,  13,  255, 13,  13,  13,  255, 13,  13,  13,  255, 13,  13,  13,  255, 13,  13,  13,  255, 13,  13,  13,  255, 13,  13,  13,  255, 13,
    13,  13,  255, 12,  12,  12,  255, 12,  12,  12,  255, 11,  11,  11,  255, 11,  11,  11,  255, 12,  12,  12,  255, 12,  12,  12,  255, 13,  13,
    13,  255, 11,  11,  11,  255, 11,  11,  11,  255, 11,  11,  11,  255, 11,  11,  11,  255, 11,  11,  11,  255, 11,  11,  11,  255, 11,  11,  11,
    255, 11,  11,  11,  255, 9,   9,   9,   255, 9,   9,   9,   255, 9,   9,   9,   255, 9,   9,   9,   255, 9,   9,   9,   255, 9,   9,   9,   255,
    9,   9,   9,   255, 9,   9,   9,   255, 9,   9,   9,   255, 9,   9,   9,   255, 9,   9,   9,   255, 9,   9,   9,   255, 8,   8,   8,   255, 8,
    8,   8,   255, 8,   8,   8,   255, 8,   8,   8,   255, 28,  28,  28,  255, 28,  28,  28,  255, 28,  28,  28,  255, 29,  29,  29,  255, 30,  30,
    30,  255, 29,  29,  29,  255, 27,  27,  27,  255, 25,  25,  25,  255, 26,  26,  26,  255, 26,  26,  26,  255, 27,  27,  27,  255, 28,  28,  28,
    255, 29,  29,  29,  255, 29,  29,  29,  255, 28,  28,  28,  255, 28,  28,  28,  255, 26,  26,  26,  255, 26,  26,  26,  255, 27,  27,  27,  255,
    27,  27,  27,  255, 27,  27,  27,  255, 27,  27,  27,  255, 26,  26,  26,  255, 26,  26,  26,  255, 26,  26,  26,  255, 26,  26,  26,  255, 26,
    26,  26,  255, 26,  26,  26,  255, 26,  26,  26,  255, 26,  26,  26,  255, 25,  25,  25,  255, 25,  25,  25,  255, 25,  25,  25,  255, 25,  25,
    25,  255, 25,  25,  25,  255, 24,  24,  24,  255, 24,  24,  24,  255, 23,  23,  23,  255, 23,  23,  23,  255, 23,  23,  23,  255, 25,  25,  25,
    255, 24,  24,  24,  255, 23,  23,  23,  255, 22,  22,  22,  255, 21,  21,  21,  255, 20,  20,  20,  255, 19,  19,  19,  255, 19,  19,  19,  255,
    21,  21,  21,  255, 20,  20,  20,  255, 18,  18,  18,  255, 18,  18,  18,  255, 19,  19,  19,  255, 23,  23,  23,  255, 27,  27,  27,  255, 29,
    29,  29,  255, 27,  27,  27,  255, 27,  27,  27,  255, 28,  28,  28,  255, 29,  29,  29,  255, 30,  30,  30,  255, 31,  31,  31,  255, 32,  32,
    32,  255, 32,  32,  32,  255, 31,  31,  31,  255, 31,  31,  31,  255, 32,  32,  32,  255, 32,  32,  32,  255, 30,  30,  30,  255, 26,  26,  26,
    255, 23,  23,  23,  255, 20,  20,  20,  255, 19,  19,  19,  255, 19,  19,  19,  255, 18,  18,  18,  255, 18,  18,  18,  255, 17,  17,  17,  255,
    16,  16,  16,  255, 16,  16,  16,  255, 15,  15,  15,  255, 19,  19,  19,  255, 18,  18,  18,  255, 17,  17,  17,  255, 16,  16,  16,  255, 15,
    15,  15,  255, 14,  14,  14,  255, 13,  13,  13,  255, 13,  13,  13,  255, 14,  14,  14,  255, 14,  14,  14,  255, 14,  14,  14,  255, 14,  14,
    14,  255, 13,  13,  13,  255, 13,  13,  13,  255, 13,  13,  13,  255, 13,  13,  13,  255, 17,  17,  17,  255, 15,  15,  15,  255, 12,  12,  12,
    255, 11,  11,  11,  255, 12,  12,  12,  255, 12,  12,  12,  255, 12,  12,  12,  255, 11,  11,  11,  255, 13,  13,  13,  255, 12,  12,  12,  255,
    11,  11,  11,  255, 12,  12,  12,  255, 13,  13,  13,  255, 13,  13,  13,  255, 11,  11,  11,  255, 9,   9,   9,   255, 14,  14,  14,  255, 13,
    13,  13,  255, 13,  13,  13,  255, 12,  12,  12,  255, 11,  11,  11,  255, 11,  11,  11,  255, 10,  10,  10,  255, 10,  10,  10,  255, 11,  11,
    11,  255, 11,  11,  11,  255, 11,  11,  11,  255, 10,  10,  10,  255, 10,  10,  10,  255, 10,  10,  10,  255, 9,   9,   9,   255, 9,   9,   9,
    255, 32,  32,  32,  255, 32,  32,  32,  255, 32,  32,  32,  255, 33,  33,  33,  255, 34,  34,  34,  255, 33,  33,  33,  255, 31,  31,  31,  255,
    29,  29,  29,  255, 29,  29,  29,  255, 29,  29,  29,  255, 30,  30,  30,  255, 31,  31,  31,  255, 31,  31,  31,  255, 31,  31,  31,  255, 30,
    30,  30,  255, 30,  30,  30,  255, 29,  29,  29,  255, 29,  29,  29,  255, 28,  28,  28,  255, 28,  28,  28,  255, 27,  27,  27,  255, 26,  26,
    26,  255, 26,  26,  26,  255, 26,  26,  26,  255, 26,  26,  26,  255, 26,  26,  26,  255, 25,  25,  25,  255, 25,  25,  25,  255, 25,  25,  25,
    255, 25,  25,  25,  255, 26,  26,  26,  255, 26,  26,  26,  255, 25,  25,  25,  255, 25,  25,  25,  255, 25,  25,  25,  255, 25,  25,  25,  255,
    25,  25,  25,  255, 24,  24,  24,  255, 24,  24,  24,  255, 24,  24,  24,  255, 22,  22,  22,  255, 22,  22,  22,  255, 21,  21,  21,  255, 20,
    20,  20,  255, 19,  19,  19,  255, 18,  18,  18,  255, 18,  18,  18,  255, 18,  18,  18,  255, 21,  21,  21,  255, 20,  20,  20,  255, 19,  19,
    19,  255, 19,  19,  19,  255, 20,  20,  20,  255, 22,  22,  22,  255, 25,  25,  25,  255, 27,  27,  27,  255, 31,  31,  31,  255, 31,  31,  31,
    255, 31,  31,  31,  255, 31,  31,  31,  255, 31,  31,  31,  255, 32,  32,  32,  255, 32,  32,  32,  255, 32,  32,  32,  255, 32,  32,  32,  255,
    33,  33,  33,  255, 33,  33,  33,  255, 33,  33,  33,  255, 32,  32,  32,  255, 30,  30,  30,  255, 29,  29,  29,  255, 28,  28,  28,  255, 20,
    20,  20,  255, 19,  19,  19,  255, 19,  19,  19,  255, 18,  18,  18,  255, 18,  18,  18,  255, 17,  17,  17,  255, 16,  16,  16,  255, 16,  16,
    16,  255, 19,  19,  19,  255, 18,  18,  18,  255, 18,  18,  18,  255, 17,  17,  17,  255, 16,  16,  16,  255, 15,  15,  15,  255, 15,  15,  15,
    255, 14,  14,  14,  255, 12,  12,  12,  255, 12,  12,  12,  255, 12,  12,  12,  255, 12,  12,  12,  255, 12,  12,  12,  255, 11,  11,  11,  255,
    11,  11,  11,  255, 11,  11,  11,  255, 14,  14,  14,  255, 12,  12,  12,  255, 11,  11,  11,  255, 10,  10,  10,  255, 11,  11,  11,  255, 11,
    11,  11,  255, 11,  11,  11,  255, 10,  10,  10,  255, 11,  11,  11,  255, 10,  10,  10,  255, 9,   9,   9,   255, 10,  10,  10,  255, 11,  11,
    11,  255, 12,  12,  12,  255, 12,  12,  12,  255, 11,  11,  11,  255, 11,  11,  11,  255, 11,  11,  11,  255, 11,  11,  11,  255, 10,  10,  10,
    255, 10,  10,  10,  255, 10,  10,  10,  255, 9,   9,   9,   255, 9,   9,   9,   255, 10,  10,  10,  255, 10,  10,  10,  255, 9,   9,   9,   255,
    9,   9,   9,   255, 9,   9,   9,   255, 8,   8,   8,   255, 8,   8,   8,   255, 8,   8,   8,   255, 13,  13,  13,  255, 13,  13,  13,  255, 12,
    12,  12,  255, 13,  13,  13,  255, 14,  14,  14,  255, 13,  13,  13,  255, 12,  12,  12,  255, 10,  10,  10,  255, 17,  17,  17,  255, 17,  17,
    17,  255, 17,  17,  17,  255, 18,  18,  18,  255, 17,  17,  17,  255, 17,  17,  17,  255, 16,  16,  16,  255, 16,  16,  16,  255, 17,  17,  17,
    255, 17,  17,  17,  255, 17,  17,  17,  255, 18,  18,  18,  255, 19,  19,  19,  255, 21,  21,  21,  255, 23,  23,  23,  255, 24,  24,  24,  255,
    22,  22,  22,  255, 21,  21,  21,  255, 18,  18,  18,  255, 16,  16,  16,  255, 14,  14,  14,  255, 14,  14,  14,  255, 14,  14,  14,  255, 15,
    15,  15,  255, 19,  19,  19,  255, 19,  19,  19,  255, 19,  19,  19,  255, 19,  19,  19,  255, 19,  19,  19,  255, 20,  20,  20,  255, 20,  20,
    20,  255, 20,  20,  20,  255, 18,  18,  18,  255, 18,  18,  18,  255, 18,  18,  18,  255, 18,  18,  18,  255, 17,  17,  17,  255, 17,  17,  17,
    255, 17,  17,  17,  255, 17,  17,  17,  255, 15,  15,  15,  255, 15,  15,  15,  255, 14,  14,  14,  255, 14,  14,  14,  255, 15,  15,  15,  255,
    16,  16,  16,  255, 17,  17,  17,  255, 18,  18,  18,  255, 15,  15,  15,  255, 16,  16,  16,  255, 16,  16,  16,  255, 17,  17,  17,  255, 18,
    18,  18,  255, 19,  19,  19,  255, 19,  19,  19,  255, 19,  19,  19,  255, 20,  20,  20,  255, 19,  19,  19,  255, 18,  18,  18,  255, 16,  16,
    16,  255, 15,  15,  15,  255, 14,  14,  14,  255, 14,  14,  14,  255, 14,  14,  14,  255, 14,  14,  14,  255, 14,  14,  14,  255, 14,  14,  14,
    255, 13,  13,  13,  255, 13,  13,  13,  255, 12,  12,  12,  255, 12,  12,  12,  255, 11,  11,  11,  255, 12,  12,  12,  255, 12,  12,  12,  255,
    12,  12,  12,  255, 12,  12,  12,  255, 11,  11,  11,  255, 11,  11,  11,  255, 11,  11,  11,  255, 11,  11,  11,  255, 10,  10,  10,  255, 10,
    10,  10,  255, 10,  10,  10,  255, 9,   9,   9,   255, 9,   9,   9,   255, 9,   9,   9,   255, 9,   9,   9,   255, 8,   8,   8,   255, 8,   8,
    8,   255, 8,   8,   8,   255, 9,   9,   9,   255, 10,  10,  10,  255, 13,  13,  13,  255, 14,  14,  14,  255, 13,  13,  13,  255, 13,  13,  13,
    255, 12,  12,  12,  255, 10,  10,  10,  255, 8,   8,   8,   255, 7,   7,   7,   255, 8,   8,   8,   255, 9,   9,   9,   255, 9,   9,   9,   255,
    9,   9,   9,   255, 8,   8,   8,   255, 8,   8,   8,   255, 8,   8,   8,   255, 8,   8,   8,   255, 8,   8,   8,   255, 8,   8,   8,   255, 8,
    8,   8,   255, 8,   8,   8,   255, 7,   7,   7,   255, 7,   7,   7,   255, 7,   7,   7,   255, 7,   7,   7,   255, 7,   7,   7,   255, 6,   6,
    6,   255, 6,   6,   6,   255, 6,   6,   6,   255, 24,  24,  24,  255, 23,  23,  23,  255, 22,  22,  22,  255, 22,  22,  22,  255, 23,  23,  23,
    255, 23,  23,  23,  255, 22,  22,  22,  255, 20,  20,  20,  255, 18,  18,  18,  255, 19,  19,  19,  255, 19,  19,  19,  255, 19,  19,  19,  255,
    18,  18,  18,  255, 18,  18,  18,  255, 17,  17,  17,  255, 16,  16,  16,  255, 15,  15,  15,  255, 16,  16,  16,  255, 17,  17,  17,  255, 20,
    20,  20,  255, 25,  25,  25,  255, 30,  30,  30,  255, 35,  35,  35,  255, 38,  38,  38,  255, 35,  35,  35,  255, 32,  32,  32,  255, 27,  27,
    27,  255, 22,  22,  22,  255, 18,  18,  18,  255, 16,  16,  16,  255, 15,  15,  15,  255, 15,  15,  15,  255, 14,  14,  14,  255, 14,  14,  14,
    255, 14,  14,  14,  255, 15,  15,  15,  255, 15,  15,  15,  255, 15,  15,  15,  255, 16,  16,  16,  255, 16,  16,  16,  255, 16,  16,  16,  255,
    16,  16,  16,  255, 16,  16,  16,  255, 16,  16,  16,  255, 16,  16,  16,  255, 16,  16,  16,  255, 16,  16,  16,  255, 16,  16,  16,  255, 11,
    11,  11,  255, 12,  12,  12,  255, 12,  12,  12,  255, 12,  12,  12,  255, 12,  12,  12,  255, 12,  12,  12,  255, 12,  12,  12,  255, 11,  11,
    11,  255, 12,  12,  12,  255, 13,  13,  13,  255, 15,  15,  15,  255, 17,  17,  17,  255, 19,  19,  19,  255, 22,  22,  22,  255, 23,  23,  23,
    255, 24,  24,  24,  255, 24,  24,  24,  255, 21,  21,  21,  255, 17,  17,  17,  255, 13,  13,  13,  255, 11,  11,  11,  255, 10,  10,  10,  255,
    10,  10,  10,  255, 11,  11,  11,  255, 10,  10,  10,  255, 9,   9,   9,   255, 9,   9,   9,   255, 9,   9,   9,   255, 8,   8,   8,   255, 8,
    8,   8,   255, 8,   8,   8,   255, 8,   8,   8,   255, 7,   7,   7,   255, 8,   8,   8,   255, 8,   8,   8,   255, 8,   8,   8,   255, 8,   8,
    8,   255, 8,   8,   8,   255, 8,   8,   8,   255, 8,   8,   8,   255, 7,   7,   7,   255, 7,   7,   7,   255, 7,   7,   7,   255, 7,   7,   7,
    255, 7,   7,   7,   255, 6,   6,   6,   255, 6,   6,   6,   255, 6,   6,   6,   255, 4,   4,   4,   255, 5,   5,   5,   255, 7,   7,   7,   255,
    11,  11,  11,  255, 15,  15,  15,  255, 18,  18,  18,  255, 18,  18,  18,  255, 17,  17,  17,  255, 16,  16,  16,  255, 13,  13,  13,  255, 9,
    9,   9,   255, 6,   6,   6,   255, 5,   5,   5,   255, 5,   5,   5,   255, 4,   4,   4,   255, 3,   3,   3,   255, 5,   5,   5,   255, 5,   5,
    5,   255, 6,   6,   6,   255, 6,   6,   6,   255, 6,   6,   6,   255, 6,   6,   6,   255, 6,   6,   6,   255, 6,   6,   6,   255, 5,   5,   5,
    255, 5,   5,   5,   255, 5,   5,   5,   255, 5,   5,   5,   255, 5,   5,   5,   255, 5,   5,   5,   255, 5,   5,   5,   255, 5,   5,   5,   255,
    13,  13,  13,  255, 12,  12,  12,  255, 10,  10,  10,  255, 10,  10,  10,  255, 11,  11,  11,  255, 12,  12,  12,  255, 11,  11,  11,  255, 10,
    10,  10,  255, 19,  19,  19,  255, 19,  19,  19,  255, 20,  20,  20,  255, 20,  20,  20,  255, 19,  19,  19,  255, 18,  18,  18,  255, 18,  18,
    18,  255, 17,  17,  17,  255, 14,  14,  14,  255, 14,  14,  14,  255, 15,  15,  15,  255, 17,  17,  17,  255, 21,  21,  21,  255, 26,  26,  26,
    255, 30,  30,  30,  255, 33,  33,  33,  255, 32,  32,  32,  255, 30,  30,  30,  255, 25,  25,  25,  255, 20,  20,  20,  255, 16,  16,  16,  255,
    14,  14,  14,  255, 13,  13,  13,  255, 13,  13,  13,  255, 14,  14,  14,  255, 14,  14,  14,  255, 15,  15,  15,  255, 15,  15,  15,  255, 16,
    16,  16,  255, 16,  16,  16,  255, 16,  16,  16,  255, 16,  16,  16,  255, 14,  14,  14,  255, 14,  14,  14,  255, 15,  15,  15,  255, 15,  15,
    15,  255, 15,  15,  15,  255, 15,  15,  15,  255, 16,  16,  16,  255, 16,  16,  16,  255, 14,  14,  14,  255, 14,  14,  14,  255, 15,  15,  15,
    255, 15,  15,  15,  255, 15,  15,  15,  255, 14,  14,  14,  255, 13,  13,  13,  255, 12,  12,  12,  255, 12,  12,  12,  255, 13,  13,  13,  255,
    15,  15,  15,  255, 17,  17,  17,  255, 19,  19,  19,  255, 21,  21,  21,  255, 23,  23,  23,  255, 24,  24,  24,  255, 23,  23,  23,  255, 21,
    21,  21,  255, 17,  17,  17,  255, 13,  13,  13,  255, 11,  11,  11,  255, 10,  10,  10,  255, 11,  11,  11,  255, 11,  11,  11,  255, 10,  10,
    10,  255, 10,  10,  10,  255, 10,  10,  10,  255, 10,  10,  10,  255, 9,   9,   9,   255, 9,   9,   9,   255, 9,   9,   9,   255, 9,   9,   9,
    255, 8,   8,   8,   255, 8,   8,   8,   255, 9,   9,   9,   255, 9,   9,   9,   255, 9,   9,   9,   255, 9,   9,   9,   255, 9,   9,   9,   255,
    10,  10,  10,  255, 6,   6,   6,   255, 6,   6,   6,   255, 6,   6,   6,   255, 5,   5,   5,   255, 5,   5,   5,   255, 5,   5,   5,   255, 5,
    5,   5,   255, 5,   5,   5,   255, 5,   5,   5,   255, 5,   5,   5,   255, 7,   7,   7,   255, 10,  10,  10,  255, 14,  14,  14,  255, 15,  15,
    15,  255, 15,  15,  15,  255, 14,  14,  14,  255, 15,  15,  15,  255, 12,  12,  12,  255, 8,   8,   8,   255, 5,   5,   5,   255, 4,   4,   4,
    255, 4,   4,   4,   255, 3,   3,   3,   255, 2,   2,   2,   255, 4,   4,   4,   255, 4,   4,   4,   255, 5,   5,   5,   255, 5,   5,   5,   255,
    5,   5,   5,   255, 5,   5,   5,   255, 5,   5,   5,   255, 5,   5,   5,   255, 4,   4,   4,   255, 4,   4,   4,   255, 4,   4,   4,   255, 4,
    4,   4,   255, 4,   4,   4,   255, 4,   4,   4,   255, 4,   4,   4,   255, 4,   4,   4,   255, 19,  19,  19,  255, 17,  17,  17,  255, 15,  15,
    15,  255, 15,  15,  15,  255, 16,  16,  16,  255, 17,  17,  17,  255, 16,  16,  16,  255, 15,  15,  15,  255, 11,  11,  11,  255, 12,  12,  12,
    255, 12,  12,  12,  255, 12,  12,  12,  255, 12,  12,  12,  255, 12,  12,  12,  255, 11,  11,  11,  255, 11,  11,  11,  255, 13,  13,  13,  255,
    12,  12,  12,  255, 11,  11,  11,  255, 10,  10,  10,  255, 10,  10,  10,  255, 11,  11,  11,  255, 12,  12,  12,  255, 12,  12,  12,  255, 16,
    16,  16,  255, 15,  15,  15,  255, 12,  12,  12,  255, 10,  10,  10,  255, 8,   8,   8,   255, 8,   8,   8,   255, 8,   8,   8,   255, 9,   9,
    9,   255, 13,  13,  13,  255, 13,  13,  13,  255, 13,  13,  13,  255, 13,  13,  13,  255, 13,  13,  13,  255, 13,  13,  13,  255, 13,  13,  13,
    255, 14,  14,  14,  255, 13,  13,  13,  255, 13,  13,  13,  255, 13,  13,  13,  255, 14,  14,  14,  255, 14,  14,  14,  255, 14,  14,  14,  255,
    14,  14,  14,  255, 14,  14,  14,  255, 13,  13,  13,  255, 13,  13,  13,  255, 13,  13,  13,  255, 13,  13,  13,  255, 13,  13,  13,  255, 12,
    12,  12,  255, 11,  11,  11,  255, 11,  11,  11,  255, 8,   8,   8,   255, 8,   8,   8,   255, 8,   8,   8,   255, 8,   8,   8,   255, 8,   8,
    8,   255, 9,   9,   9,   255, 9,   9,   9,   255, 9,   9,   9,   255, 10,  10,  10,  255, 9,   9,   9,   255, 8,   8,   8,   255, 7,   7,   7,
    255, 6,   6,   6,   255, 6,   6,   6,   255, 6,   6,   6,   255, 7,   7,   7,   255, 8,   8,   8,   255, 8,   8,   8,   255, 8,   8,   8,   255,
    8,   8,   8,   255, 8,   8,   8,   255, 8,   8,   8,   255, 8,   8,   8,   255, 8,   8,   8,   255, 7,   7,   7,   255, 7,   7,   7,   255, 7,
    7,   7,   255, 7,   7,   7,   255, 7,   7,   7,   255, 8,   8,   8,   255, 8,   8,   8,   255, 8,   8,   8,   255, 6,   6,   6,   255, 6,   6,
    6,   255, 6,   6,   6,   255, 5,   5,   5,   255, 5,   5,   5,   255, 5,   5,   5,   255, 5,   5,   5,   255, 5,   5,   5,   255, 8,   8,   8,
    255, 7,   7,   7,   255, 7,   7,   7,   255, 7,   7,   7,   255, 8,   8,   8,   255, 8,   8,   8,   255, 7,   7,   7,   255, 5,   5,   5,   255,
    9,   9,   9,   255, 7,   7,   7,   255, 5,   5,   5,   255, 5,   5,   5,   255, 5,   5,   5,   255, 6,   6,   6,   255, 6,   6,   6,   255, 6,
    6,   6,   255, 5,   5,   5,   255, 5,   5,   5,   255, 5,   5,   5,   255, 5,   5,   5,   255, 5,   5,   5,   255, 5,   5,   5,   255, 5,   5,
    5,   255, 5,   5,   5,   255, 4,   4,   4,   255, 4,   4,   4,   255, 4,   4,   4,   255, 5,   5,   5,   255, 5,   5,   5,   255, 5,   5,   5,
    255, 5,   5,   5,   255, 5,   5,   5,   255, 19,  19,  19,  255, 17,  17,  17,  255, 15,  15,  15,  255, 15,  15,  15,  255, 16,  16,  16,  255,
    17,  17,  17,  255, 16,  16,  16,  255, 16,  16,  16,  255, 17,  17,  17,  255, 17,  17,  17,  255, 18,  18,  18,  255, 18,  18,  18,  255, 19,
    19,  19,  255, 18,  18,  18,  255, 18,  18,  18,  255, 18,  18,  18,  255, 21,  21,  21,  255, 20,  20,  20,  255, 19,  19,  19,  255, 18,  18,
    18,  255, 17,  17,  17,  255, 17,  17,  17,  255, 16,  16,  16,  255, 16,  16,  16,  255, 18,  18,  18,  255, 17,  17,  17,  255, 16,  16,  16,
    255, 16,  16,  16,  255, 16,  16,  16,  255, 16,  16,  16,  255, 17,  17,  17,  255, 18,  18,  18,  255, 11,  11,  11,  255, 11,  11,  11,  255,
    11,  11,  11,  255, 11,  11,  11,  255, 11,  11,  11,  255, 11,  11,  11,  255, 11,  11,  11,  255, 10,  10,  10,  255, 11,  11,  11,  255, 11,
    11,  11,  255, 11,  11,  11,  255, 11,  11,  11,  255, 11,  11,  11,  255, 11,  11,  11,  255, 11,  11,  11,  255, 11,  11,  11,  255, 11,  11,
    11,  255, 10,  10,  10,  255, 10,  10,  10,  255, 10,  10,  10,  255, 9,   9,   9,   255, 9,   9,   9,   255, 9,   9,   9,   255, 9,   9,   9,
    255, 12,  12,  12,  255, 12,  12,  12,  255, 11,  11,  11,  255, 11,  11,  11,  255, 10,  10,  10,  255, 10,  10,  10,  255, 9,   9,   9,   255,
    9,   9,   9,   255, 10,  10,  10,  255, 10,  10,  10,  255, 11,  11,  11,  255, 12,  12,  12,  255, 11,  11,  11,  255, 11,  11,  11,  255, 10,
    10,  10,  255, 9,   9,   9,   255, 5,   5,   5,   255, 5,   5,   5,   255, 5,   5,   5,   255, 6,   6,   6,   255, 6,   6,   6,   255, 6,   6,
    6,   255, 6,   6,   6,   255, 6,   6,   6,   255, 6,   6,   6,   255, 6,   6,   6,   255, 6,   6,   6,   255, 6,   6,   6,   255, 6,   6,   6,
    255, 6,   6,   6,   255, 6,   6,   6,   255, 6,   6,   6,   255, 7,   7,   7,   255, 6,   6,   6,   255, 6,   6,   6,   255, 6,   6,   6,   255,
    6,   6,   6,   255, 5,   5,   5,   255, 5,   5,   5,   255, 5,   5,   5,   255, 9,   9,   9,   255, 7,   7,   7,   255, 5,   5,   5,   255, 5,
    5,   5,   255, 5,   5,   5,   255, 5,   5,   5,   255, 4,   4,   4,   255, 3,   3,   3,   255, 6,   6,   6,   255, 5,   5,   5,   255, 4,   4,
    4,   255, 5,   5,   5,   255, 7,   7,   7,   255, 8,   8,   8,   255, 7,   7,   7,   255, 7,   7,   7,   255, 7,   7,   7,   255, 7,   7,   7,
    255, 7,   7,   7,   255, 6,   6,   6,   255, 6,   6,   6,   255, 5,   5,   5,   255, 5,   5,   5,   255, 5,   5,   5,   255, 5,   5,   5,   255,
    5,   5,   5,   255, 5,   5,   5,   255, 6,   6,   6,   255, 6,   6,   6,   255, 6,   6,   6,   255, 7,   7,   7,   255, 7,   7,   7,   255, 19,
    19,  19,  255, 17,  17,  17,  255, 15,  15,  15,  255, 14,  14,  14,  255, 15,  15,  15,  255, 16,  16,  16,  255, 16,  16,  16,  255, 16,  16,
    16,  255, 17,  17,  17,  255, 18,  18,  18,  255, 19,  19,  19,  255, 20,  20,  20,  255, 20,  20,  20,  255, 20,  20,  20,  255, 20,  20,  20,
    255, 20,  20,  20,  255, 14,  14,  14,  255, 15,  15,  15,  255, 16,  16,  16,  255, 18,  18,  18,  255, 19,  19,  19,  255, 20,  20,  20,  255,
    20,  20,  20,  255, 20,  20,  20,  255, 16,  16,  16,  255, 16,  16,  16,  255, 16,  16,  16,  255, 15,  15,  15,  255, 15,  15,  15,  255, 15,
    15,  15,  255, 15,  15,  15,  255, 15,  15,  15,  255, 15,  15,  15,  255, 15,  15,  15,  255, 15,  15,  15,  255, 14,  14,  14,  255, 14,  14,
    14,  255, 13,  13,  13,  255, 13,  13,  13,  255, 13,  13,  13,  255, 10,  10,  10,  255, 10,  10,  10,  255, 10,  10,  10,  255, 10,  10,  10,
    255, 9,   9,   9,   255, 9,   9,   9,   255, 9,   9,   9,   255, 9,   9,   9,   255, 13,  13,  13,  255, 12,  12,  12,  255, 12,  12,  12,  255,
    11,  11,  11,  255, 11,  11,  11,  255, 11,  11,  11,  255, 11,  11,  11,  255, 12,  12,  12,  255, 9,   9,   9,   255, 9,   9,   9,   255, 9,
    9,   9,   255, 9,   9,   9,   255, 9,   9,   9,   255, 9,   9,   9,   255, 9,   9,   9,   255, 9,   9,   9,   255, 8,   8,   8,   255, 9,   9,
    9,   255, 10,  10,  10,  255, 11,  11,  11,  255, 10,  10,  10,  255, 7,   7,   7,   255, 4,   4,   4,   255, 2,   2,   2,   255, 8,   8,   8,
    255, 8,   8,   8,   255, 8,   8,   8,   255, 9,   9,   9,   255, 9,   9,   9,   255, 9,   9,   9,   255, 9,   9,   9,   255, 9,   9,   9,   255,
    9,   9,   9,   255, 9,   9,   9,   255, 9,   9,   9,   255, 9,   9,   9,   255, 9,   9,   9,   255, 9,   9,   9,   255, 8,   8,   8,   255, 8,
    8,   8,   255, 7,   7,   7,   255, 7,   7,   7,   255, 7,   7,   7,   255, 7,   7,   7,   255, 6,   6,   6,   255, 6,   6,   6,   255, 6,   6,
    6,   255, 6,   6,   6,   255, 7,   7,   7,   255, 5,   5,   5,   255, 4,   4,   4,   255, 4,   4,   4,   255, 5,   5,   5,   255, 7,   7,   7,
    255, 7,   7,   7,   255, 7,   7,   7,   255, 7,   7,   7,   255, 6,   6,   6,   255, 6,   6,   6,   255, 7,   7,   7,   255, 7,   7,   7,   255,
    7,   7,   7,   255, 6,   6,   6,   255, 4,   4,   4,   255, 8,   8,   8,   255, 8,   8,   8,   255, 8,   8,   8,   255, 7,   7,   7,   255, 6,
    6,   6,   255, 6,   6,   6,   255, 5,   5,   5,   255, 5,   5,   5,   255, 6,   6,   6,   255, 6,   6,   6,   255, 6,   6,   6,   255, 6,   6,
    6,   255, 7,   7,   7,   255, 7,   7,   7,   255, 8,   8,   8,   255, 8,   8,   8,   255, 14,  14,  14,  255, 1,   1,   1,   255, 0,   0,   0,
    255, 9,   9,   9,   255, 9,   9,   9,   255, 0,   0,   0,   255, 0,   0,   0,   255, 12,  12,  12,  255, 0,   0,   0,   255, 8,   8,   8,   255,
    15,  15,  15,  255, 15,  15,  15,  255, 12,  12,  12,  255, 11,  11,  11,  255, 8,   8,   8,   255, 4,   4,   4,   255, 14,  14,  14,  255, 9,
    9,   9,   255, 3,   3,   3,   255, 10,  10,  10,  255, 26,  26,  26,  255, 26,  26,  26,  255, 15,  15,  15,  255, 12,  12,  12,  255, 7,   7,
    7,   255, 14,  14,  14,  255, 11,  11,  11,  255, 6,   6,   6,   255, 11,  11,  11,  255, 13,  13,  13,  255, 11,  11,  11,  255, 13,  13,  13,
    255, 4,   4,   4,   255, 25,  25,  25,  255, 30,  30,  30,  255, 18,  18,  18,  255, 11,  11,  11,  255, 9,   9,   9,   255, 11,  11,  11,  255,
    18,  18,  18,  255, 11,  11,  11,  255, 8,   8,   8,   255, 9,   9,   9,   255, 15,  15,  15,  255, 20,  20,  20,  255, 18,  18,  18,  255, 13,
    13,  13,  255, 11,  11,  11,  255, 3,   3,   3,   255, 28,  28,  28,  255, 6,   6,   6,   255, 3,   3,   3,   255, 13,  13,  13,  255, 21,  21,
    21,  255, 0,   0,   0,   255, 12,  12,  12,  255, 14,  14,  14,  255, 19,  19,  19,  255, 18,  18,  18,  255, 25,  25,  25,  255, 3,   3,   3,
    255, 11,  11,  11,  255, 12,  12,  12,  255, 18,  18,  18,  255, 9,   9,   9,   255, 10,  10,  10,  255, 8,   8,   8,   255, 23,  23,  23,  255,
    13,  13,  13,  255, 26,  26,  26,  255, 13,  13,  13,  255, 1,   1,   1,   255, 13,  13,  13,  255, 24,  24,  24,  255, 7,   7,   7,   255, 1,
    1,   1,   255, 23,  23,  23,  255, 16,  16,  16,  255, 0,   0,   0,   255, 11,  11,  11,  255, 12,  12,  12,  255, 21,  21,  21,  255, 25,  25,
    25,  255, 16,  16,  16,  255, 4,   4,   4,   255, 2,   2,   2,   255, 7,   7,   7,   255, 13,  13,  13,  255, 8,   8,   8,   255, 4,   4,   4,
    255, 10,  10,  10,  255, 24,  24,  24,  255, 24,  24,  24,  255, 10,  10,  10,  255, 2,   2,   2,   255, 4,   4,   4,   255, 8,   8,   8,   255,
    5,   5,   5,   255, 4,   4,   4,   255, 5,   5,   5,   255, 4,   4,   4,   255, 2,   2,   2,   255, 4,   4,   4,   255, 9,   9,   9,   255, 10,
    10,  10,  255, 16,  16,  16,  255, 17,  17,  17,  255, 10,  10,  10,  255, 3,   3,   3,   255, 1,   1,   1,   255, 3,   3,   3,   255, 4,   4,
    4,   255, 6,   6,   6,   255, 4,   4,   4,   255, 4,   4,   4,   255, 7,   7,   7,   255, 11,  11,  11,  255, 9,   9,   9,   255, 2,   2,   2,
    255, 0,   0,   0,   255, 5,   5,   5,   255, 5,   5,   5,   255, 6,   6,   6,   255, 5,   5,   5,   255, 3,   3,   3,   255, 3,   3,   3,   255,
    5,   5,   5,   255, 6,   6,   6,   255, 23,  23,  23,  255, 15,  15,  15,  255, 13,  13,  13,  255, 20,  20,  20,  255, 20,  20,  20,  255, 12,
    12,  12,  255, 13,  13,  13,  255, 21,  21,  21,  255, 38,  38,  38,  255, 34,  34,  34,  255, 25,  25,  25,  255, 14,  14,  14,  255, 10,  10,
    10,  255, 14,  14,  14,  255, 20,  20,  20,  255, 21,  21,  21,  255, 7,   7,   7,   255, 20,  20,  20,  255, 31,  31,  31,  255, 38,  38,  38,
    255, 38,  38,  38,  255, 23,  23,  23,  255, 11,  11,  11,  255, 13,  13,  13,  255, 16,  16,  16,  255, 20,  20,  20,  255, 16,  16,  16,  255,
    15,  15,  15,  255, 20,  20,  20,  255, 18,  18,  18,  255, 15,  15,  15,  255, 21,  21,  21,  255, 31,  31,  31,  255, 47,  47,  47,  255, 42,
    42,  42,  255, 23,  23,  23,  255, 18,  18,  18,  255, 23,  23,  23,  255, 27,  27,  27,  255, 31,  31,  31,  255, 11,  11,  11,  255, 18,  18,
    18,  255, 32,  32,  32,  255, 46,  46,  46,  255, 48,  48,  48,  255, 35,  35,  35,  255, 19,  19,  19,  255, 9,   9,   9,   255, 34,  34,  34,
    255, 37,  37,  37,  255, 16,  16,  16,  255, 15,  15,  15,  255, 33,  33,  33,  255, 37,  37,  37,  255, 16,  16,  16,  255, 14,  14,  14,  255,
    36,  36,  36,  255, 44,  44,  44,  255, 52,  52,  52,  255, 50,  50,  50,  255, 21,  21,  21,  255, 17,  17,  17,  255, 30,  30,  30,  255, 47,
    47,  47,  255, 20,  20,  20,  255, 20,  20,  20,  255, 24,  24,  24,  255, 46,  46,  46,  255, 41,  41,  41,  255, 49,  49,  49,  255, 33,  33,
    33,  255, 20,  20,  20,  255, 13,  13,  13,  255, 40,  40,  40,  255, 29,  29,  29,  255, 6,   6,   6,   255, 20,  20,  20,  255, 35,  35,  35,
    255, 24,  24,  24,  255, 13,  13,  13,  255, 19,  19,  19,  255, 32,  32,  32,  255, 42,  42,  42,  255, 38,  38,  38,  255, 27,  27,  27,  255,
    19,  19,  19,  255, 17,  17,  17,  255, 16,  16,  16,  255, 22,  22,  22,  255, 12,  12,  12,  255, 10,  10,  10,  255, 26,  26,  26,  255, 40,
    40,  40,  255, 40,  40,  40,  255, 30,  30,  30,  255, 24,  24,  24,  255, 9,   9,   9,   255, 10,  10,  10,  255, 10,  10,  10,  255, 9,   9,
    9,   255, 8,   8,   8,   255, 9,   9,   9,   255, 11,  11,  11,  255, 13,  13,  13,  255, 12,  12,  12,  255, 21,  21,  21,  255, 27,  27,  27,
    255, 26,  26,  26,  255, 21,  21,  21,  255, 18,  18,  18,  255, 13,  13,  13,  255, 9,   9,   9,   255, 13,  13,  13,  255, 11,  11,  11,  255,
    11,  11,  11,  255, 16,  16,  16,  255, 23,  23,  23,  255, 27,  27,  27,  255, 25,  25,  25,  255, 21,  21,  21,  255, 8,   8,   8,   255, 9,
    9,   9,   255, 9,   9,   9,   255, 9,   9,   9,   255, 8,   8,   8,   255, 9,   9,   9,   255, 11,  11,  11,  255, 12,  12,  12,  255, 56,  56,
    56,  255, 55,  55,  55,  255, 55,  55,  55,  255, 57,  57,  57,  255, 56,  56,  56,  255, 54,  54,  54,  255, 54,  54,  54,  255, 55,  55,  55,
    255, 64,  64,  64,  255, 61,  61,  61,  255, 55,  55,  55,  255, 49,  49,  49,  255, 49,  49,  49,  255, 53,  53,  53,  255, 54,  54,  54,  255,
    51,  51,  51,  255, 47,  47,  47,  255, 60,  60,  60,  255, 66,  66,  66,  255, 65,  65,  65,  255, 59,  59,  59,  255, 46,  46,  46,  255, 43,
    43,  43,  255, 54,  54,  54,  255, 47,  47,  47,  255, 46,  46,  46,  255, 42,  42,  42,  255, 44,  44,  44,  255, 49,  49,  49,  255, 43,  43,
    43,  255, 40,  40,  40,  255, 49,  49,  49,  255, 58,  58,  58,  255, 67,  67,  67,  255, 57,  57,  57,  255, 40,  40,  40,  255, 40,  40,  40,
    255, 48,  48,  48,  255, 49,  49,  49,  255, 48,  48,  48,  255, 38,  38,  38,  255, 44,  44,  44,  255, 55,  55,  55,  255, 63,  63,  63,  255,
    62,  62,  62,  255, 50,  50,  50,  255, 40,  40,  40,  255, 36,  36,  36,  255, 61,  61,  61,  255, 47,  47,  47,  255, 39,  39,  39,  255, 40,
    40,  40,  255, 55,  55,  55,  255, 51,  51,  51,  255, 43,  43,  43,  255, 35,  35,  35,  255, 52,  52,  52,  255, 52,  52,  52,  255, 67,  67,
    67,  255, 60,  60,  60,  255, 39,  39,  39,  255, 23,  23,  23,  255, 44,  44,  44,  255, 64,  64,  64,  255, 34,  34,  34,  255, 29,  29,  29,
    255, 35,  35,  35,  255, 59,  59,  59,  255, 57,  57,  57,  255, 58,  58,  58,  255, 46,  46,  46,  255, 38,  38,  38,  255, 31,  31,  31,  255,
    55,  55,  55,  255, 54,  54,  54,  255, 30,  30,  30,  255, 32,  32,  32,  255, 55,  55,  55,  255, 53,  53,  53,  255, 32,  32,  32,  255, 35,
    35,  35,  255, 50,  50,  50,  255, 62,  62,  62,  255, 61,  61,  61,  255, 51,  51,  51,  255, 44,  44,  44,  255, 39,  39,  39,  255, 37,  37,
    37,  255, 51,  51,  51,  255, 43,  43,  43,  255, 38,  38,  38,  255, 44,  44,  44,  255, 57,  57,  57,  255, 63,  63,  63,  255, 58,  58,  58,
    255, 49,  49,  49,  255, 41,  41,  41,  255, 47,  47,  47,  255, 49,  49,  49,  255, 45,  45,  45,  255, 45,  45,  45,  255, 50,  50,  50,  255,
    51,  51,  51,  255, 47,  47,  47,  255, 43,  43,  43,  255, 49,  49,  49,  255, 55,  55,  55,  255, 57,  57,  57,  255, 56,  56,  56,  255, 53,
    53,  53,  255, 47,  47,  47,  255, 40,  40,  40,  255, 51,  51,  51,  255, 47,  47,  47,  255, 44,  44,  44,  255, 46,  46,  46,  255, 51,  51,
    51,  255, 55,  55,  55,  255, 55,  55,  55,  255, 53,  53,  53,  255, 49,  49,  49,  255, 50,  50,  50,  255, 51,  51,  51,  255, 51,  51,  51,
    255, 51,  51,  51,  255, 51,  51,  51,  255, 53,  53,  53,  255, 55,  55,  55,  255, 67,  67,  67,  255, 72,  72,  72,  255, 73,  73,  73,  255,
    70,  70,  70,  255, 70,  70,  70,  255, 73,  73,  73,  255, 71,  71,  71,  255, 67,  67,  67,  255, 63,  63,  63,  255, 65,  65,  65,  255, 66,
    66,  66,  255, 69,  69,  69,  255, 73,  73,  73,  255, 75,  75,  75,  255, 67,  67,  67,  255, 58,  58,  58,  255, 75,  75,  75,  255, 74,  74,
    74,  255, 66,  66,  66,  255, 63,  63,  63,  255, 67,  67,  67,  255, 65,  65,  65,  255, 64,  64,  64,  255, 74,  74,  74,  255, 72,  72,  72,
    255, 68,  68,  68,  255, 64,  64,  64,  255, 69,  69,  69,  255, 73,  73,  73,  255, 64,  64,  64,  255, 61,  61,  61,  255, 73,  73,  73,  255,
    68,  68,  68,  255, 69,  69,  69,  255, 63,  63,  63,  255, 61,  61,  61,  255, 68,  68,  68,  255, 67,  67,  67,  255, 61,  61,  61,  255, 62,
    62,  62,  255, 65,  65,  65,  255, 65,  65,  65,  255, 67,  67,  67,  255, 67,  67,  67,  255, 63,  63,  63,  255, 59,  59,  59,  255, 61,  61,
    61,  255, 66,  66,  66,  255, 67,  67,  67,  255, 52,  52,  52,  255, 65,  65,  65,  255, 65,  65,  65,  255, 67,  67,  67,  255, 53,  53,  53,
    255, 66,  66,  66,  255, 65,  65,  65,  255, 70,  70,  70,  255, 56,  56,  56,  255, 68,  68,  68,  255, 67,  67,  67,  255, 66,  66,  66,  255,
    48,  48,  48,  255, 65,  65,  65,  255, 74,  74,  74,  255, 64,  64,  64,  255, 53,  53,  53,  255, 57,  57,  57,  255, 71,  71,  71,  255, 66,
    66,  66,  255, 63,  63,  63,  255, 62,  62,  62,  255, 64,  64,  64,  255, 58,  58,  58,  255, 58,  58,  58,  255, 65,  65,  65,  255, 64,  64,
    64,  255, 55,  55,  55,  255, 61,  61,  61,  255, 68,  68,  68,  255, 61,  61,  61,  255, 54,  54,  54,  255, 64,  64,  64,  255, 70,  70,  70,
    255, 67,  67,  67,  255, 62,  62,  62,  255, 61,  61,  61,  255, 63,  63,  63,  255, 65,  65,  65,  255, 62,  62,  62,  255, 69,  69,  69,  255,
    70,  70,  70,  255, 64,  64,  64,  255, 61,  61,  61,  255, 65,  65,  65,  255, 68,  68,  68,  255, 67,  67,  67,  255, 58,  58,  58,  255, 68,
    68,  68,  255, 71,  71,  71,  255, 64,  64,  64,  255, 63,  63,  63,  255, 70,  70,  70,  255, 70,  70,  70,  255, 63,  63,  63,  255, 65,  65,
    65,  255, 66,  66,  66,  255, 64,  64,  64,  255, 63,  63,  63,  255, 64,  64,  64,  255, 67,  67,  67,  255, 65,  65,  65,  255, 60,  60,  60,
    255, 72,  72,  72,  255, 67,  67,  67,  255, 63,  63,  63,  255, 62,  62,  62,  255, 63,  63,  63,  255, 64,  64,  64,  255, 63,  63,  63,  255,
    62,  62,  62,  255, 64,  64,  64,  255, 65,  65,  65,  255, 66,  66,  66,  255, 65,  65,  65,  255, 65,  65,  65,  255, 65,  65,  65,  255, 67,
    67,  67,  255, 68,  68,  68,  255, 63,  63,  63,  255, 71,  71,  71,  255, 73,  73,  73,  255, 68,  68,  68,  255, 68,  68,  68,  255, 73,  73,
    73,  255, 71,  71,  71,  255, 63,  63,  63,  255, 79,  79,  79,  255, 75,  75,  75,  255, 70,  70,  70,  255, 68,  68,  68,  255, 72,  72,  72,
    255, 75,  75,  75,  255, 70,  70,  70,  255, 62,  62,  62,  255, 71,  71,  71,  255, 71,  71,  71,  255, 67,  67,  67,  255, 70,  70,  70,  255,
    78,  78,  78,  255, 74,  74,  74,  255, 66,  66,  66,  255, 68,  68,  68,  255, 75,  75,  75,  255, 71,  71,  71,  255, 67,  67,  67,  255, 72,
    72,  72,  255, 77,  77,  77,  255, 67,  67,  67,  255, 64,  64,  64,  255, 76,  76,  76,  255, 75,  75,  75,  255, 66,  66,  66,  255, 62,  62,
    62,  255, 74,  74,  74,  255, 84,  84,  84,  255, 72,  72,  72,  255, 64,  64,  64,  255, 73,  73,  73,  255, 70,  70,  70,  255, 72,  72,  72,
    255, 75,  75,  75,  255, 76,  76,  76,  255, 72,  72,  72,  255, 68,  68,  68,  255, 70,  70,  70,  255, 76,  76,  76,  255, 71,  71,  71,  255,
    56,  56,  56,  255, 77,  77,  77,  255, 79,  79,  79,  255, 72,  72,  72,  255, 57,  57,  57,  255, 78,  78,  78,  255, 80,  80,  80,  255, 75,
    75,  75,  255, 56,  56,  56,  255, 68,  68,  68,  255, 72,  72,  72,  255, 79,  79,  79,  255, 63,  63,  63,  255, 74,  74,  74,  255, 76,  76,
    76,  255, 77,  77,  77,  255, 66,  66,  66,  255, 72,  72,  72,  255, 77,  77,  77,  255, 70,  70,  70,  255, 61,  61,  61,  255, 71,  71,  71,
    255, 78,  78,  78,  255, 74,  74,  74,  255, 60,  60,  60,  255, 70,  70,  70,  255, 81,  81,  81,  255, 69,  69,  69,  255, 65,  65,  65,  255,
    76,  76,  76,  255, 76,  76,  76,  255, 68,  68,  68,  255, 72,  72,  72,  255, 73,  73,  73,  255, 68,  68,  68,  255, 65,  65,  65,  255, 69,
    69,  69,  255, 75,  75,  75,  255, 79,  79,  79,  255, 57,  57,  57,  255, 71,  71,  71,  255, 78,  78,  78,  255, 70,  70,  70,  255, 63,  63,
    63,  255, 66,  66,  66,  255, 73,  73,  73,  255, 76,  76,  76,  255, 61,  61,  61,  255, 71,  71,  71,  255, 73,  73,  73,  255, 66,  66,  66,
    255, 64,  64,  64,  255, 70,  70,  70,  255, 68,  68,  68,  255, 60,  60,  60,  255, 74,  74,  74,  255, 72,  72,  72,  255, 67,  67,  67,  255,
    63,  63,  63,  255, 65,  65,  65,  255, 69,  69,  69,  255, 69,  69,  69,  255, 65,  65,  65,  255, 70,  70,  70,  255, 68,  68,  68,  255, 66,
    66,  66,  255, 67,  67,  67,  255, 69,  69,  69,  255, 70,  70,  70,  255, 69,  69,  69,  255, 67,  67,  67,  255, 66,  66,  66,  255, 67,  67,
    67,  255, 67,  67,  67,  255, 65,  65,  65,  255, 64,  64,  64,  255, 63,  63,  63,  255, 64,  64,  64,  255, 66,  66,  66,  255, 60,  60,  60,
    255, 67,  67,  67,  255, 69,  69,  69,  255, 64,  64,  64,  255, 65,  65,  65,  255, 70,  70,  70,  255, 68,  68,  68,  255, 61,  61,  61,  255,
    77,  77,  77,  255, 74,  74,  74,  255, 69,  69,  69,  255, 67,  67,  67,  255, 70,  70,  70,  255, 74,  74,  74,  255, 70,  70,  70,  255, 63,
    63,  63,  255, 68,  68,  68,  255, 74,  74,  74,  255, 74,  74,  74,  255, 75,  75,  75,  255, 77,  77,  77,  255, 70,  70,  70,  255, 65,  65,
    65,  255, 72,  72,  72,  255, 71,  71,  71,  255, 70,  70,  70,  255, 66,  66,  66,  255, 69,  69,  69,  255, 73,  73,  73,  255, 67,  67,  67,
    255, 64,  64,  64,  255, 73,  73,  73,  255, 79,  79,  79,  255, 66,  66,  66,  255, 60,  60,  60,  255, 72,  72,  72,  255, 80,  80,  80,  255,
    67,  67,  67,  255, 62,  62,  62,  255, 77,  77,  77,  255, 71,  71,  71,  255, 71,  71,  71,  255, 73,  73,  73,  255, 74,  74,  74,  255, 71,
    71,  71,  255, 68,  68,  68,  255, 72,  72,  72,  255, 78,  78,  78,  255, 76,  76,  76,  255, 60,  60,  60,  255, 70,  70,  70,  255, 77,  77,
    77,  255, 72,  72,  72,  255, 66,  66,  66,  255, 75,  75,  75,  255, 72,  72,  72,  255, 68,  68,  68,  255, 60,  60,  60,  255, 71,  71,  71,
    255, 76,  76,  76,  255, 72,  72,  72,  255, 61,  61,  61,  255, 69,  69,  69,  255, 74,  74,  74,  255, 69,  69,  69,  255, 63,  63,  63,  255,
    75,  75,  75,  255, 74,  74,  74,  255, 70,  70,  70,  255, 59,  59,  59,  255, 70,  70,  70,  255, 72,  72,  72,  255, 69,  69,  69,  255, 64,
    64,  64,  255, 72,  72,  72,  255, 74,  74,  74,  255, 64,  64,  64,  255, 68,  68,  68,  255, 76,  76,  76,  255, 69,  69,  69,  255, 68,  68,
    68,  255, 72,  72,  72,  255, 72,  72,  72,  255, 68,  68,  68,  255, 65,  65,  65,  255, 67,  67,  67,  255, 70,  70,  70,  255, 70,  70,  70,
    255, 61,  61,  61,  255, 68,  68,  68,  255, 70,  70,  70,  255, 67,  67,  67,  255, 67,  67,  67,  255, 70,  70,  70,  255, 70,  70,  70,  255,
    67,  67,  67,  255, 62,  62,  62,  255, 69,  69,  69,  255, 71,  71,  71,  255, 66,  66,  66,  255, 64,  64,  64,  255, 66,  66,  66,  255, 64,
    64,  64,  255, 59,  59,  59,  255, 66,  66,  66,  255, 66,  66,  66,  255, 64,  64,  64,  255, 61,  61,  61,  255, 62,  62,  62,  255, 64,  64,
    64,  255, 61,  61,  61,  255, 56,  56,  56,  255, 59,  59,  59,  255, 59,  59,  59,  255, 58,  58,  58,  255, 59,  59,  59,  255, 60,  60,  60,
    255, 59,  59,  59,  255, 58,  58,  58,  255, 56,  56,  56,  255, 59,  59,  59,  255, 59,  59,  59,  255, 59,  59,  59,  255, 57,  57,  57,  255,
    55,  55,  55,  255, 54,  54,  54,  255, 55,  55,  55,  255, 56,  56,  56,  255, 38,  38,  38,  255, 42,  42,  42,  255, 44,  44,  44,  255, 41,
    41,  41,  255, 41,  41,  41,  255, 45,  45,  45,  255, 44,  44,  44,  255, 40,  40,  40,  255, 38,  38,  38,  255, 40,  40,  40,  255, 42,  42,
    42,  255, 44,  44,  44,  255, 48,  48,  48,  255, 50,  50,  50,  255, 45,  45,  45,  255, 37,  37,  37,  255, 47,  47,  47,  255, 50,  50,  50,
    255, 46,  46,  46,  255, 43,  43,  43,  255, 45,  45,  45,  255, 41,  41,  41,  255, 42,  42,  42,  255, 53,  53,  53,  255, 50,  50,  50,  255,
    54,  54,  54,  255, 50,  50,  50,  255, 48,  48,  48,  255, 53,  53,  53,  255, 51,  51,  51,  255, 49,  49,  49,  255, 54,  54,  54,  255, 54,
    54,  54,  255, 52,  52,  52,  255, 46,  46,  46,  255, 48,  48,  48,  255, 53,  53,  53,  255, 48,  48,  48,  255, 46,  46,  46,  255, 56,  56,
    56,  255, 55,  55,  55,  255, 51,  51,  51,  255, 49,  49,  49,  255, 48,  48,  48,  255, 47,  47,  47,  255, 47,  47,  47,  255, 52,  52,  52,
    255, 59,  59,  59,  255, 56,  56,  56,  255, 47,  47,  47,  255, 45,  45,  45,  255, 54,  54,  54,  255, 49,  49,  49,  255, 53,  53,  53,  255,
    50,  50,  50,  255, 48,  48,  48,  255, 54,  54,  54,  255, 53,  53,  53,  255, 58,  58,  58,  255, 64,  64,  64,  255, 51,  51,  51,  255, 52,
    52,  52,  255, 56,  56,  56,  255, 60,  60,  60,  255, 54,  54,  54,  255, 49,  49,  49,  255, 62,  62,  62,  255, 55,  55,  55,  255, 57,  57,
    57,  255, 48,  48,  48,  255, 57,  57,  57,  255, 51,  51,  51,  255, 44,  44,  44,  255, 45,  45,  45,  255, 49,  49,  49,  255, 46,  46,  46,
    255, 41,  41,  41,  255, 47,  47,  47,  255, 50,  50,  50,  255, 43,  43,  43,  255, 43,  43,  43,  255, 47,  47,  47,  255, 48,  48,  48,  255,
    45,  45,  45,  255, 44,  44,  44,  255, 44,  44,  44,  255, 44,  44,  44,  255, 41,  41,  41,  255, 47,  47,  47,  255, 46,  46,  46,  255, 44,
    44,  44,  255, 44,  44,  44,  255, 45,  45,  45,  255, 45,  45,  45,  255, 42,  42,  42,  255, 38,  38,  38,  255, 36,  36,  36,  255, 38,  38,
    38,  255, 40,  40,  40,  255, 39,  39,  39,  255, 37,  37,  37,  255, 36,  36,  36,  255, 35,  35,  35,  255, 35,  35,  35,  255, 32,  32,  32,
    255, 34,  34,  34,  255, 33,  33,  33,  255, 31,  31,  31,  255, 31,  31,  31,  255, 32,  32,  32,  255, 30,  30,  30,  255, 25,  25,  25,  255,
    30,  30,  30,  255, 29,  29,  29,  255, 27,  27,  27,  255, 26,  26,  26,  255, 24,  24,  24,  255, 23,  23,  23,  255, 22,  22,  22,  255, 21,
    21,  21,  255, 20,  20,  20,  255, 21,  21,  21,  255, 21,  21,  21,  255, 19,  19,  19,  255, 18,  18,  18,  255, 17,  17,  17,  255, 18,  18,
    18,  255, 19,  19,  19,  255, 19,  19,  19,  255, 21,  21,  21,  255, 22,  22,  22,  255, 22,  22,  22,  255, 22,  22,  22,  255, 24,  24,  24,
    255, 23,  23,  23,  255, 22,  22,  22,  255, 21,  21,  21,  255, 21,  21,  21,  255, 20,  20,  20,  255, 18,  18,  18,  255, 20,  20,  20,  255,
    24,  24,  24,  255, 24,  24,  24,  255, 20,  20,  20,  255, 22,  22,  22,  255, 20,  20,  20,  255, 14,  14,  14,  255, 17,  17,  17,  255, 27,
    27,  27,  255, 25,  25,  25,  255, 19,  19,  19,  255, 22,  22,  22,  255, 15,  15,  15,  255, 22,  22,  22,  255, 19,  19,  19,  255, 14,  14,
    14,  255, 19,  19,  19,  255, 21,  21,  21,  255, 19,  19,  19,  255, 21,  21,  21,  255, 15,  15,  15,  255, 26,  26,  26,  255, 25,  25,  25,
    255, 19,  19,  19,  255, 23,  23,  23,  255, 24,  24,  24,  255, 22,  22,  22,  255, 24,  24,  24,  255, 20,  20,  20,  255, 20,  20,  20,  255,
    22,  22,  22,  255, 25,  25,  25,  255, 24,  24,  24,  255, 20,  20,  20,  255, 19,  19,  19,  255, 21,  21,  21,  255, 19,  19,  19,  255, 22,
    22,  22,  255, 17,  17,  17,  255, 27,  27,  27,  255, 16,  16,  16,  255, 24,  24,  24,  255, 18,  18,  18,  255, 23,  23,  23,  255, 21,  21,
    21,  255, 19,  19,  19,  255, 14,  14,  14,  255, 25,  25,  25,  255, 12,  12,  12,  255, 25,  25,  25,  255, 23,  23,  23,  255, 22,  22,  22,
    255, 25,  25,  25,  255, 16,  16,  16,  255, 24,  24,  24,  255, 12,  12,  12,  255, 19,  19,  19,  255, 14,  14,  14,  255, 23,  23,  23,  255,
    10,  10,  10,  255, 18,  18,  18,  255, 14,  14,  14,  255, 14,  14,  14,  255, 17,  17,  17,  255, 16,  16,  16,  255, 13,  13,  13,  255, 13,
    13,  13,  255, 15,  15,  15,  255, 10,  10,  10,  255, 13,  13,  13,  255, 13,  13,  13,  255, 11,  11,  11,  255, 11,  11,  11,  255, 14,  14,
    14,  255, 14,  14,  14,  255, 12,  12,  12,  255, 6,   6,   6,   255, 6,   6,   6,   255, 8,   8,   8,   255, 9,   9,   9,   255, 7,   7,   7,
    255, 4,   4,   4,   255, 6,   6,   6,   255, 9,   9,   9,   255, 7,   7,   7,   255, 6,   6,   6,   255, 7,   7,   7,   255, 10,  10,  10,  255,
    9,   9,   9,   255, 6,   6,   6,   255, 6,   6,   6,   255, 9,   9,   9,   255, 10,  10,  10,  255, 11,  11,  11,  255, 9,   9,   9,   255, 5,
    5,   5,   255, 4,   4,   4,   255, 7,   7,   7,   255, 9,   9,   9,   255, 8,   8,   8,   255, 11,  11,  11,  255, 9,   9,   9,   255, 8,   8,
    8,   255, 6,   6,   6,   255, 6,   6,   6,   255, 7,   7,   7,   255, 8,   8,   8,   255, 9,   9,   9,   255, 7,   7,   7,   255, 8,   8,   8,
    255, 9,   9,   9,   255, 8,   8,   8,   255, 7,   7,   7,   255, 7,   7,   7,   255, 8,   8,   8,   255, 10,  10,  10,  255,

  };
}
// The size of bitmap is 65536//
